<?php
//
// pMachine Publishing Software
//
// File Name: mailserver.php
//
// Description: This script allows you to email entries to pMachine
//
// Copyright (c) 2003 - 2005 pMachine, Inc.
//
// THIS IS COPYRIGHTED SOFTWARE


// USER CONFIGURATION SECTION

// POP3 server address
// Example: earthlink.net
   $server = "";

// POP3 Account username
// Example: you@earthlink.net
   $user = ""; 

// POP3 Password 
   $pass = "";

// Subject prefix.
// When you email an entry, the subject line must contain a prefix so 
// that the script will know which emails are valid.
   $subject_prefix = "POST:"; 
 
 // Time interval
 // The amount of time, in minutes, between automatic checks.
 // This variable is only needed if you use the "automatic check" feature
 // as described in the instructions.  If no number is specified, the
 // script will default to 15 minutes.
   $time_interval = "";


// Strip Text
// Some email services (like Yahoo, Hotmail, etc.) will insert text at the bottom 
// of your emails.  To get rid of this, put EACH LINE of the text in the 
// array below, as shown..
//
// For example, if you want to get rid of the folowing: 
//
// Do you Yahoo?
// Get your free email at yahoo.com
//
// You will construct the array like this:
//
//  $ignore = array( "Do you Yahoo?", "Get your free email at yahoo.com" );
//
// Notice that each line is in quotes and there is a comma between each item.

  $ignore = array();


//---------------------------------------------------------------------
//	DO NOT EDIT BELOW THIS UNLESS YOU KNOW WHAT YOU ARE DOING!
//---------------------------------------------------------------------

if (isset($sfx))
{	
	$run_script = (MailServer::manage_logfile() == TRUE) ? 1 : 0;

	$show_output = 0;
}
else
{
	include ("inc.sfx.inc");
	include ("inc.cp$sfx");
	
	$run_script		= 1;
	$show_output	= 1;
}

if ($run_script == 1)
{
	$pop = new MailServer();

	$pop->host		=& $server;
	$pop->user		=& $user;
	$pop->pass		=& $pass;
	$pop->prefix	=& $subject_prefix;
	$pop->display	=& $show_output;
	$pop->ignore	=& $ignore;
	
	$pop->show_header();
	$pop->pop_login();
	$pop->show_spacer();
	$pop->get_valid_emails();
	$pop->post_valid_emails();
	$pop->close_server();
	$pop->show_footer();
}
	

//-------------------------------------
//  POP3 Email ServerClass
//-------------------------------------	

class MailServer {

	var $host		=  "";
	var $port		=  "110";
	var $user		=  "";
	var $pass		=  "";	
	var $fp			=  "";
	var $prefix		= "POST:";
	var $header		= array();
	var $display	= "yes";
	var $valid_ids	= array();
	var $offset		= 2;
	var	$flag		= false;
	var $memid		= "";
	var $deftblog	= "";
	
	function MailServer()
	{
	}

	
	//-------------------------------------
	//  Manage logfile
	//-------------------------------------	

	function manage_logfile()
	{
		global $pm_path, $time_interval;
		
		$maillogfile = $pm_path."mailserverlog.txt";
		
		if ($time_interval == "")
			$time_interval = 15;
		
		$time = file($maillogfile);
		
		if (!isset($time['0']))
		{		
			$f = fopen($maillogfile, "w+");

			fputs($f, time());
			fclose($f);	
			
			return true;
		}
		else
		{
			$time = str_replace("\n", "", $time);
			$time = str_replace("\r", "", $time);
	
			if (($time['0'] + ($time_interval * 60)) <= time())
			{
				$f = fopen($maillogfile, "w+");
	
				fputs($f, time());
				fclose($f);	
				
				return true;
			}
			else
			{
				return false;
			}
		}
	}


	//-------------------------------------
	//  Login to the POP3 server
	//-------------------------------------	

	function pop_login()
	{
		if (!$this->fp = fsockopen($this->host, $this->port, $errno, $errstr, 25))
		{
			if ($this->display == 1)
			{	
				return $this->error("Could not open the socket.&nbsp; Please verify your host name.");
			}
			return false;
		}

		if (!$this->good_response($line = fgets($this->fp, 1024)))
		{
			if ($this->display == 1)
			{	
				return $this->error("Server returned a bad response code");
			}
			return false;
		}
		
		if (!$this->good_response($user = $this->send_command("USER ".$this->user)))
		{
			if ($this->display == 1)
			{	
				return $this->error("Invalid Username");
			}
			return false;
		}
		
		if (!$this->good_response($pass = $this->send_command("PASS ".$this->pass)))
		{
			if ($this->display == 1)
			{	
				return $this->error("Invalid Password");
			}
			return false;
		}		
		
		if ($this->display == 1)
		{		
			$str  = "Connected to:&nbsp;&nbsp;".$line."<br /><br />";
			$str .= "Valid Username<br />";
			$str .= "Valid Password<br /><br />";
			$str .=  preg_replace("/\(.*?\)\./", "", $pass);
		
			echo $this->trim_newlines($this->kill_ok($str));
		}
		else
			return true;
	}
	// END
	

	//---------------------------------------------
	//  Get subject and ID number of valid emails
	//---------------------------------------------

	function get_valid_emails()
	{
		if (!$this->fp)
		{
			return false;	
		}
	
		if (!$line = $this->send_command("STAT"))
		{
			return false;
		}
	
		$n = explode(" ", $line);
		
		$total = $n['1'];
		
		if ($total == 0) 
		{
			return false;
		}

		$ct =0;
		
		for ($i = 1; $i <= $total; $i++) 
		{
			$str = $this->send_command("TOP $i 0");
			
			while (!ereg("^\.",$str))
			{            	
            	$str = $this->send_command();
  
            	if (eregi("^Subject: ", $str))
            	{   
            		if ($this->display == 1)
            		{            	
						echo "<br />";
						echo $i.": ";
						echo str_replace("Subject: ", "", $str);
           			}            	 
            	}       
            	if (eregi("^Subject: $this->prefix", $str))
            	{
					$this->valid_ids[$ct] = $i; 
					$ct ++;        	
            	}     	
			}
		}
		
		$size = sizeof($this->valid_ids);
		
		if ($size > 0)
		{
			if ($this->display == 1)
			{ 
				echo "<br /><br />";
				echo "<span class=\"good\">";
				
				if ($size == $total)
				{
					if ($size == 1)
						echo "The message is valid and ready to be posted";
					else
						echo "The messages are valid and ready to be posted";				
				}
				else
				{					
					if ($size == 1)
						echo $size." of $total messages is valid and ready to be posted";
					else
						echo $size." of $total messages are valid and ready to be posted";
				}	
				echo "</span><br />";
			}
			return true;
		}
		else
		{
			if ($this->display == 1)
			{ 
				echo "<br /><br />";
				echo "<span class=\"error\">There are no valid emails in your in-box</span>";
				echo "<br />";
			}
		
			return false;
		}
	}
	// END
	


	//-------------------------------------
	//  Send command to server
	//-------------------------------------	

	function send_command($cmd = "")
	{
		if (!$this->fp)
		{
			return false;
		}

		if ($cmd != "")
		{
			fwrite($this->fp, $cmd."\r\n");
		}
			
		$line = $this->trim_newlines(fgets($this->fp, 1024));
		
		return $line;
	}
	// END
	

	//-------------------------------------
	//  Trim newlines
	//-------------------------------------	

	function trim_newlines($str)
	{
		$str = str_replace("\n", "", $str);
		$str = str_replace("\r", "", $str);
	
		return $str;
	}
	// END


	//-------------------------------------
	//  Validate response
	//-------------------------------------	

    function good_response($str)
    {
		if (!eregi("^\+OK", $str))
		{
			return false;
		}
        else
        {
            return true;
		}
    }
    // END


	//-------------------------------------
	//  Remove "+OK" from response code
	//-------------------------------------	

    function kill_ok($str)
    {
		return str_replace("+OK", "", $str);
    }
    // END


	//-------------------------------------
	//  Delete message
	//-------------------------------------	

    function delete_message($id)
    {
    	if (!isset($this->fp))
    	{
    		return false;
    	}
   
       	if ($id == "")
    	{
    		return false;
    	}
    	
		$kill = $this->send_command("DELE $id");
		
		if (!$this->good_response($kill))
		{
			return false;
		}
		
		return true;
    }
    // END
    
    
	//-------------------------------------
	//  Close server connection
	//-------------------------------------	

    function close_server()
    {
    	if (!isset($this->fp))
    	{
    		return false;
    	}
    	
		$line = $this->send_command("QUIT");
		
		@fclose($this->fp);

		if ($this->display == 1)
		{
			echo "<br />";
        	echo "Server connection has been closed";
        	echo "<br /><br />";
        	echo "<b>End of script</b>";
        }
        else
        {
        	return true;
        }
    }
    // END
    

	//-------------------------------------
	//  Post valid emails
	//-------------------------------------	

	function post_valid_emails() 
	{
		$total = sizeof($this->valid_ids);
		
		if ($total == 0)
		{
			$this->close_server();
			unset($this->fp);
		}
	
		for ($i =0; $i < $total; $i++)
		{
			$this->flag	= false;
			$this->memid = "";
			$this->deftblog = "";
			$username = "";
			$password = "";
			$title = "";
			$body = "";
			unset($num);

			if ($this->display == 1)
			{ 
				$this->show_spacer();
			}
			
			$str = $this->send_command("RETR ".$this->valid_ids[$i]);
			
			if ($this->good_response($str))
			{
				while (!ereg("^\.",$str))
				{
					$str = fgets($this->fp, 1024);
											
					if (eregi("^Subject: $this->prefix", $str))
					{
						$title = $this->trim_newlines(str_replace("Subject: $this->prefix", "", $str));    	
					}     	
	
					if ((strlen($str) < 5) && $this->flag == false)
					{
						$num = 0;
						
						$this->flag = true;
					}
					
						if (isset($num))
						{
							$num ++;
									 
							if ($num == $this->offset)
							{
								$login = trim($this->trim_newlines($str));
								
								$x = explode(":", $login);
								
								if (isset($x['0'])) $username = trim($x['0']);
								if (isset($x['1'])) $password = trim($x['1']);
							}
							
							if ($num > $this->offset)
							{
								if (!preg_match("/^\./", $str)) 
								
								$body .= $str;								
							}							 
						}       	
				}
						
				if ($this->authenticate($username, $password))
				{
					if ($this->post_entry($title, $body))
					{
						if ($this->display == 1)
						{ 
							echo "<span class=\"good\">Message ".$this->valid_ids[$i]." has been posted successfully</span>";
							echo "<br />";
						}

						if ($this->delete_message($this->valid_ids[$i]))
						{
							if ($this->display == 1)
							{ 
								echo "<span class=\"good\">Message ".$this->valid_ids[$i]." has been deleted from email server.</span>";
								echo "<br />";
							}		
						}
					}
					else
					{
						if ($this->display == 1)
						{ 
							$this->error("Unable to post message ".$this->valid_ids[$i]);
							echo "<br />";
						}
					}
				}
				else
				{
					if ($this->display == 1)
					{ 
						$this->error("Unable to authenticate user in message ".$this->valid_ids[$i]);
						echo "<br />";
					}
				}
			}
		}
	}
	// END


	//-------------------------------------
	//  Authenticate User
	//-------------------------------------	

	function authenticate($username = "", $password = "") 
	{
		global $db_members, $DB;
		
		if ($username == "" || $password == "")
		{
			return false;
		}
		
		$sql = "select id,username,status,deft_weblog
			  from $db_members 
			  where username = '$username' 
			  and password = '".md5($password)."'";
								
		 $query = new DB_query($DB, $sql);               

		if ($query->db_num_rows() == 0) 
		{
			return false;
		}        
			$query->db_fetch_object();
			
		if ($query->obj->status >= "7") 
		{
			$this->memid = $query->obj->id;
			$this->deftblog = $query->obj->deft_weblog;
		
			return true;
		}
		else
		{
			return false;
		}
	}
	// END


	//-------------------------------------
	//  Post Entry
	//-------------------------------------	

	function post_entry($title, $message)
	{
		global $db_weblog, $db_multiweblogs, $db_categories, $DB;
		global $SHARED, $db_ping_servers;
		
		if ($title == "" || $message == "")
		{
			return false;
		}
		
		if ($this->memid == "")
		{
			return false;
		}

		$title	   = str_replace("'", "\'", trim($title));
		$clean	   = $this->remove_text(addslashes($message));
		$weblog	   = stripslashes($this->get_chunk($clean,"weblog"));
		$body	   = stripslashes($this->get_body($clean));
		$blurb	   = stripslashes($this->get_chunk($clean,"blurb"));
		$more	   = stripslashes($this->get_chunk($clean,"more"));
		$custom1   = stripslashes($this->get_chunk($clean,"custom1"));
		$custom2   = stripslashes($this->get_chunk($clean,"custom2"));
		$custom3   = stripslashes($this->get_chunk($clean,"custom3"));
		$category  = stripslashes($this->get_chunk($clean,"category"));
		$brBlurb   = stripslashes($this->get_chunk($clean,"brBlurb"));
		$brBody	   = stripslashes($this->get_chunk($clean,"brBody"));
		$brMore	   = stripslashes($this->get_chunk($clean,"brMore"));
		$brCustom1 = stripslashes($this->get_chunk($clean,"brCustom1"));
		$brCustom2 = stripslashes($this->get_chunk($clean,"brCustom2"));
		$brCustom3 = stripslashes($this->get_chunk($clean,"brCustom3"));
		$status    = stripslashes($this->get_chunk($clean,"status"));

		if ($status == "" || $status != "closed")
		{
			$status = "open";
		}
		
		$query = new DB_query($DB,"select count(*) as count from $db_weblog where title = '$title'");
																	
		$query->db_fetch_array();
		
		if ($query->row['count'] >= 1)
		{
			return $this->error("There is already an entry in the database with this title<br />");
		}
		
		unset($query);
		
		$query = new DB_query($DB,"select count(*) as count from $db_multiweblogs where weblog = '$weblog'");
																	
		$query->db_fetch_array();
		
		if ($query->row['count'] == 0)
		{
			$weblog = $this->deftblog;
		}

		if ($category != "")
		{
			$cat_array = array();
			
			$query = new DB_query($DB,"select id,category 
									from $db_categories 
									where weblog = '$weblog' 
									order by id");
																	
			 while ($query->db_fetch_array())
			 {
					$cat_array[$query->row['category']] = $query->row['id'];
			 }      
			
			$catid = $cat_array[$category];
			
			unset($query);
		}
		else
			$catid = "";
		
		
		if (($brBlurb == ""  ) || ($brBlurb	  != 0 && $brBlurb !=1))   $brBlurb   = 1;
		if (($brBody  == ""  ) || ($brBody	  != 0 && $brBody  !=1))   $brBody    = 1;
		if (($brMore  == ""	 ) || ($brMore	  != 0 && $brMore  !=1))   $brMore    = 1;
		if (($brCustom1 == "") || ($brCustom1 != 0 && $brCustom1 !=1)) $brCustom1 = 1;
		if (($brCustom2 == "") || ($brCustom2 != 0 && $brCustom2 !=1)) $brCustom2 = 1;
		if (($brCustom3 == "") || ($brCustom3 != 0 && $brCustom3 !=1)) $brCustom3 = 1;
	

		if ($SHARED->get_pref("auto_format_HTML_$weblog") == "yes") 
		{
				$title = pmcode_basic_encode($title);
					
			if ($blurb   <> "") $blurb   = pmcode_basic_encode($blurb);
			if ($body    <> "") $body    = pmcode_basic_encode($body);
			if ($more    <> "") $more    = pmcode_basic_encode($more);
			if ($custom1 <> "") $custom1 = pmcode_basic_encode($custom1);
			if ($custom2 <> "") $custom2 = pmcode_basic_encode($custom2);
			if ($custom3 <> "") $custom3 = pmcode_basic_encode($custom3);
		} 
		if ($SHARED->get_pref("auto_format_URLS_$weblog") == "yes") 
		{
				$title = pmcode_url_encode($title);
					
			if ($blurb   <> "") $blurb   = pmcode_url_encode($blurb);
			if ($body    <> "") $body    = pmcode_url_encode($body);
			if ($more    <> "") $more    = pmcode_url_encode($more);
			if ($custom1 <> "") $custom1 = pmcode_url_encode($custom1);
			if ($custom2 <> "") $custom2 = pmcode_url_encode($custom2);
			if ($custom3 <> "") $custom3 = pmcode_url_encode($custom3);
		} 
		if ($SHARED->get_pref("auto_format_IMGS_$weblog") == "yes") 
		{
				$title = pmcode_img_encode($title);
					
			if ($blurb   <> "") $blurb   = pmcode_img_encode($blurb);
			if ($body    <> "") $body    = pmcode_img_encode($body);
			if ($more    <> "") $more    = pmcode_img_encode($more);
			if ($custom1 <> "") $custom1 = pmcode_img_encode($custom1);
			if ($custom2 <> "") $custom2 = pmcode_img_encode($custom2);
			if ($custom3 <> "") $custom3 = pmcode_img_encode($custom3);
		}    

		$t_stamp = $SHARED->get_offset_time();
		$month	 = date("m",$t_stamp);    
		$year    = date("Y",$t_stamp); 
		$day     = date("d",$t_stamp);		
	
		$sql = "insert into $db_weblog 
			   (post_id, 
			   member_id, 
			   t_stamp, 
			   title, 
			   blurb, 
			   body, 
			   more,
			   custom1,
			   custom2,
			   custom3, 
			   status, 
			   weblog,
			   category,
			   preview, 
			   year,
			   month, 
			   day,
			   nl2brBlurb,
			   nl2brBody,
			   nl2brMore,
			   nl2brC1,
			   nl2brC2,
			   nl2brC3)
		values ('', 
			   '$this->memid', 
			   '$t_stamp',
			   '$title',
			   '$blurb',
			   '$body',
			   '$more',
			   '$custom1',
			   '$custom2',
			   '$custom3',
			   '$status',
			   '$weblog',
			   '$catid',
			   '"."0"."',
			   '$year',
			   '$month',
			   '$day',
			   '$brBlurb',
			   '$brBody',
			   '$brMore',
			   '$brCustom1',
			   '$brCustom2',
			   '$brCustom3')"; 
			   
		$query = new DB_query($DB, $sql);
			
		if ($SHARED->get_pref("rss_on_weblog") == "yes")
		{
			if (write_rss() == false)
			{
				if ($this->display == 1)
				{ 
					echo "<br />";
			 		echo "Unable to write data to your RSS file.";
			 	}
			}
		}
	
		if (($SHARED->get_pref("ping_$weblog") == "yes") && ($status =="open"))
		{
			$query = new DB_query($DB, "SELECT server_name, server_url, server_port FROM $db_ping_servers WHERE server_default='y')");
			
			if ($query->db_num_rows() > 0)
			{
				$bad_pings = array();
			
				while($query->db_fetch_array())
				{
					if (!ping_weblogs($weblog, $query->row['server_url'], $query->row['server_port']))
					{
						$bad_pings[] = $query->row['server_name'];
					}
				}
				
				if ($this->display == 1 && sizeof($bad_pings) > 0)
				{ 
					echo "<br />";
			 		echo "Unable to ping: ".implode(',', $bad_pings);
				}				
			}
		}
    
		return true;
	}
	// END


	// ------------------------------------
	//		EXTRACT ENTRY BODY
	// ------------------------------------
	
	function get_body($str)
	{
		$search = array("<title>(.*)</title>",
						"<status>(.*)</status>",
						"<category>(.*)</category>",
						"<blurb>(.*)</blurb>",
						"<more>(.*)</more>",
						"<custom1>(.*)</custom1>",
						"<custom2>(.*)</custom2>",
						"<custom3>(.*)</custom3>",
						"<weblog>(.*)</weblog>",
						"<brBlurb>(.*)</brBlurb>",
						"<brBody>(.*)</brBody>",
						"<brMore>(.*)</brMore>",
						"<brCustom1>(.*)</brCustom1>",
						"<brCustom2>(.*)</brCustom2>",
						"<brCustom3>(.*)</brCustom3>");
						
		for ($i =0; $i < sizeof($search); $i++)			
		{
			$str = ereg_replace($search[$i],"", $str);
		}
		
		if (eregi("<body>(.*)</body>", $str, $bstr))
		{
			$str = preg_replace("/<body>(.*)<\/body>/si","\\1",$bstr[0]);
		}
		
		return $str;
	}
	// END
	
	
	// ------------------------------------
	//		EXTRACT DATA CHUNKS
	// ------------------------------------
	
	function get_chunk($str,$tag)
	{
		if (eregi("<$tag>(.*)<\/$tag>", $str, $tstr))
		{
			$str = preg_replace("/<$tag>(.*)<\/$tag>/si","\\1",$tstr[0]);
		}
		else
		{
			$str = "";
		}
			
		return $str;
	}
	// END
	

	// ------------------------------------------
	//	 Remove user-specified text from emails
	// ------------------------------------------
	
	function remove_text($str)
	{
		$total = sizeof($this->ignore);
		
		if ($total == 0)
			return rtrim($str);
	
		for ($i =0; $i < $total; $i++)			
		{
			$str = str_replace($this->ignore[$i],"", $str);
		}

		return rtrim($str);
	}
	// END


	// ------------------------------------
	//	HTML Header
	// ------------------------------------	
	
	function show_header()
	{
		if ($this->display == 1)
		{
		?>
		<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
		<html>
		<head><title>pMachine Email Server</title></head>
	
		<style type="text/css">
		
		body { 
		 background-color: #ffffff; 
		 margin-left: 18px; 
		 margin-right: 18px; 
		 margin-top: 18px; 
		}
		
		.heading {
		 font-family: trebuchet,verdana,geneva,arial,sans-serif;
		 font-size: 13px;
		 color: #0000c0;
		 margin-top: 6px;
		 margin-bottom: 12px;
		 margin-left: 12px;
		 font-weight: bold;
		}

		.error {
		 font-family: trebuchet,verdana,geneva,arial,sans-serif;
		 font-size: 12px;
		 color: #990000;
		 margin-top: 6px;
		 margin-bottom: 12px;
		 margin-left: 12px;
		 font-weight: bold;
		}
		.good {
		 font-family: trebuchet,verdana,geneva,arial,sans-serif;
		 font-size: 12px;
		 color: #009933;
		 margin-top: 6px;
		 margin-bottom: 12px;
		 font-weight: bold;
		}
		
		.border {
		 border-top:   #999999 1px dotted;
		 border-left:  #999999 1px dotted;
		 border-right:  #999999 1px dotted;
		 border-bottom:  #999999 1px dotted;
		}
		
		p {
		 font-family: trebuchet,verdana,geneva,arial,sans-serif;
		 font-size: 12px;
		 margin-left: 20px;
		 margin-top: 6px;
		 color: #333333;
		 font-weight: normal;
		}
		</style>
		
		</head>
		<body bgcolor="#ffffff" text="#000000">
		
		<br />
		
		<div class="border">
		
		<div class="heading">pMachine Email Server</div>
		
		<p>

		<?php
		}
	}
	// END
	

	//-------------------------------------
	//  HTML Footer
	//-------------------------------------	

	function show_footer()
	{
		if ($this->display == 1)
		{
			?>
				</p>
				
				</div>
				
				</body>
				
				</html>
			<?php
		}
	}
	// END



	// ------------------------------------
	//	Spacer
	// ------------------------------------	
	
	function show_spacer($n=1)
	{
		if ($this->display == 1)
		{
			$x = 0;
		
			while ($x < $n) 
			{ 
				echo "<br />";
				
				$x ++;
			}
		}
	}
	// END


	//-------------------------------------
	//  Error message
	//-------------------------------------	

	function error($error)
	{
		if ($this->display == 1)
		{
			?>
			<span class="error"><?php echo "ERROR: ".$error; ?></span>
			<?php
		}
		else
			return false;
	}
}
// END CLASS
?>