<?php
//
// pMachine Publishing Software
//
// File Name: online_users.php
//
// Description:  Displays the number of members and guests online.
//
// Copyright (c) 2003 - 2005 pMachine, Inc.
//
// THIS IS COPYRIGHTED SOFTWARE
//
// License holders may alter or modify this software for their own use, 
// but may NOT resell or redistribute the modified or derivative version 
// without prior written consent from pMachine.  Components from this 
// software may not be extracted and used in other programs without prior 
// written consent from pMachine.
//
// PLEASE READ THE LICENSE AGREEMENT
//


function online_users($life="")
{
	global $DB, $SHARED;

//----- USER CONFIGURABLE ITEMS ---------------------------------------

	// File/path to log file
	$logfile = "scripts/online_users.txt";
	
	// Newline character.  "\n" works on Unix. May need to change to "\r" for Windows
	$newline = "\n";
	
	// Default lifespan of logged in user
	if ($life == "") $life = 12;
	
//---------------------------------------------------------------------
	
	global $pm_path, $db_members, $profileviewpage, $sfx;

	$member_name = isset($_COOKIE['member_name']) ? ($_COOKIE['member_name']) : "";
	$member_code = isset($_COOKIE['member_code']) ? ($_COOKIE['member_code']) : "";

	$user = "";

	// Get member's "post" name
	if ($member_name != "" && $member_code != "")
	{
		$sql = "select signature,id
				from $db_members 
				where member_id = '".addslashes($member_code)."' 
				and username    = '".addslashes($member_name)."'";
				
		$query = new DB_query($DB, $sql);
		
		if ($query->result)
		{	
			$query->db_fetch_object();
			$user = stripslashes($query->obj->signature);
			$id = $query->obj->id;
		}
	}

	// Log guest IP address
	if ($user == "")
	{
		if (!function_exists('getenv'))
		{
			$client_ip = $server['HTTP_CLIENT_IP'];
			$x_frd_for = $server['HTTP_X_FORWARDED_FOR'];
			$rmte_addr = $server['REMOTE_ADDR'];
		}
		else
		{
			$client_ip = getenv('HTTP_CLIENT_IP');
			$x_frd_for = getenv('HTTP_X_FORWARDED_FOR');
			$rmte_addr = getenv('REMOTE_ADDR');		
		}
		
		
		if ($client_ip) 
		{
			$x_cip = explode(".", $client_ip);
			$x_rmt = explode(".", $rmte_addr);
			
			$user = ($x_cip['0'] != $x_rmt['0']) ? implode(".", array_reverse($x_cip)) : $client_ip;
		}
		elseif ($x_frd_for) 
		{
			$user = (strstr($x_frd_for, ",")) ? end(explode(",", $x_frd_for)) : $x_frd_for;
		}
		else
		{
			$user = $rmte_addr;
		}
		$id = 0;
	}


	// Read log file into an array
	$userlist = file($pm_path.$logfile);
	
	// Read line one of the array to see if it contains the 
	// "most users ever" data.  If not, add it to the array.
	if (isset($userlist['0']))
	{ 
		if (substr($userlist['0'], 0, 16) != "most_ever_online")
		{
			$deft = "most_ever_online|0|".$SHARED->get_offset_time().$newline;
		
			array_unshift($userlist, $deft);
		}
	}
	else
	{
		$userlist['0'] = "most_ever_online|1|".$SHARED->get_offset_time().$newline;
	}	

	// Store "most ever" data as a variable for use later.
	$most_ever_online = $userlist['0'];
	
	// Remove the "most ever" data.
	array_shift($userlist); 
	
	// Grab the array key from the element that that is older than our timeout	
	$timeout = time() - (60 * $life);
	
	for ($i=0; $i < count($userlist); $i++)
	{	
		if (substr($userlist[$i],0,strpos($userlist[$i],'|')) >= $timeout)
			break;
	}
	
	// Slice the array, removing expired users	
	$userlist = array_slice ($userlist, $i);

	if (sizeof($userlist) >= 1)
	{
		// See if the current user was previously logged.  If so, remove them.
		for ($i=0; $i < count($userlist); $i++)
		{	
			$x = explode("|", $userlist[$i]);
			
			if (isset($x['2']) AND trim($x['2']) == $user)			
				array_splice ($userlist, $i, 1);
		}
	}
	
	// Compile our current user data into a string
	$userlist[] = time()."|".$id."|".$user.$newline;
	
	// O.K., We now have an up-to-date array. The old junk was trimmed off and the 
	// current user info has been added.  The array contains only unique data.
	// It's ready to be stored back in the log file. Before we do so, however, 
	// we need to update the "most user ever" data, which we'll do shortly.
		
//---------------------------------------------------------

	// Create two new arrays - one will hold non-member IPs
	// the other will hold member names.
	
	$member = array();
	$nonmbr = array();

	// Loop through our main array from earlier and fill each of our
	// two new arrays with member names and guest IP addresses.
	for ($i =0; $i < sizeof($userlist); $i ++)
	{	
		$ex = explode("|", $userlist[$i]);
	
		if (isset($ex['1']) AND isset($ex['2']))
		{
			if ($ex['1'] == 0)
				$nonmbr[] = $ex['2']; 
			else
				$member[] = $ex['2']."|".$ex['1'];
		}
	}

	// Remove the unique data out of the two arrays so we don't 
	// display duplicate member names or an incorrect guest tally.
	$member = array_unique($member);	
	$nonmbr = array_unique($nonmbr);
	
	// Sort our member array alphabetically
	sort($member);	
		
	$total_ever = explode("|",$most_ever_online);
	$total_now  = (sizeof($member) + sizeof($nonmbr));
	
	// Build our "most users ever" string
	if ($total_now > $total_ever['1']) {
		$most_ever_online = "most_ever_online|".$total_now."|".$SHARED->get_offset_time().$newline;
		$total_users = $total_now;	
	}
	else {
		$total_users = 	$total_ever['1'];
	}

	// Add the "most users" string to the front of our primary array.
	array_unshift($userlist, $most_ever_online);

	// Write our finalized data to the log file.
	$fp = fopen($pm_path.$logfile, "w+");
	flock($fp, LOCK_EX);
	fputs($fp, implode('',$userlist));
	flock($fp, LOCK_UN);
	fclose($fp);	
		
	// Put the data from the member array into a contiguous string 
	// containing a link to each member's profile page
	$user = "";
	$memdir	= $SHARED->get_pref("memdir","1");
	
	for ($i=0; $i<sizeof($userlist); $i++)
	{
		if (isset($member[$i]))
		$user .= "<a href=\"$memdir$profileviewpage$sfx?id=".substr($member[$i],strpos($member[$i],'|')+1)."\">".trim(substr($member[$i],0,strpos($member[$i],'|')))."</a>\r\n,";			
	}

	// And finally, build one master multi-dimmensional array
	$user_array = array(explode(",",substr($user,0,-1)),sizeof($member),sizeof($nonmbr),$total_now,$total_users,$total_ever['2']);

	return $user_array;
}
// END
?>