<?php

// Version 2.4 (Pro2.4.004)

// DATABASE VARIABLES
// If you do not know what these values should be, please contact 
// your hosting provider.  Most problems occur as a result of
// an error in this file.


// MYSQL SERVER ADDRESS 
// Usually this is the name of your domain (www.yoursite.com).
// In some cases the hostname will instead be "localhost".
   $hostname = '@@DB_STRING@@';


// MySQL USERNAME
// This is the username you use to access your MySQL database.
// Note: This is usually NOT the same as your FTP username.
   $dbusername = '@@DB_USER@@';


// MySQL PASSWORD
// The password used to access your MySQL database.
// Note: This is usually NOT the same as your FTP password.
   $dbpassword = '@@DB_PASS@@';

 
// DATABASE NAME
// Some hosting providers assign you a specific database.
// If this is the case, change this variable to the name of
// the database they require, otherwise you can leave it alone.
// If you are not using an existing database you might have
// to create the database prior to installing pMachine.
   $dbname = '@@DB_NAME@@';


// DEFAULT LANGUAGE OPTION
// This variable determines the default language used in the control panel.
// Language packs can be downloaded at pMachine.com.  You can override the
// default language on a per-login basis if you have more than one language
// pack installed.
   $language = "english";


// FOR ADVANCED USERS -----------------------------------------------------
// Do not mess with these variables unless you know what you are doing.

// DEBUG
// This variables turns PHP and MySQL error message on or off for 
// debugging purposes. It is recommended that you leave debug on during
// development only - not with a "live" site, due to security issues.
// 1 = on
// 0 = off
   $debug = 0;


// AUTO XHTML
// Normally, any line breaks (carriage returns) contained in your weblog 
// entires will automatically be turned into <br /> tags.  The variable
// changes that feature into into an "Auto XHTML" feature. pMachine 
// will then use <p></p> tags as well as other XHTML validated characters,
// like curly quotes, turning your weblog entries into typographically sound,
// XHTML-valid text.
// 1 = on
// 0 = off
   $auto_xhtml = 0;



// URL REWRITING ------------------------------------------------------
// This variable turns on the search-engine friendly URL feature.
// This feature only works on Apache servers with the mod_mime module.
// In addition to setting this variable, several other steps must
// be taken. PLEASE CONSULT THE MANUAL BEFORE USING THIS FEATURE.
// 1 = on
// 0 = off
   $url_rewriting = 0;



// DATABASE SETTINGS -----------------------------------------------------


// DATABASE
// mysql is the only supported database at this time.
   $database = "mysql";


// DATABASE TABLE PREFIX
// Change this if you want the database tables to be installed 
// with a different prefix.
   $dbprefix = "pm";
   
   
// DATABASE CONNECTION TYPE
// 0 = non-persistent
// 1 = persistent (generally faster)
   $conntype = 1;


// IMAGE UPLOAD METHOD -----------------------------------------------------
// This variable determines which method pMachine uses to upload images.
// 1 = Default method. Recommended for newer versions of PHP, especially with 
//     register_globals = off
// 2 = Works with older versions of PHP (uses "copy" method).
// 3 = Works with older versions of PHP (uses "move_uploaded_file" method).
    $upload_method = 1;
    
    

// EMAIL SETTINGS -----------------------------------------------------


// BATCH TOTAL
// When sending mass email to your mailing list or to your members,
// pMachine will automatically send the email in small batches so that
// you don't risk a server timeout.  It is recommended that you set
// the batch total to roughly the number of emails that can be sent in
// a 30 second time period - the default time limit for PHP script execution.
// The number of emails that can be sent in 30 seconds will vary depending on
// factors related to your email server.  A safe number is 50 - 100.  If you are
// running an SMTP server, or porting your email directly to Sendmail you can
// probably increase the batch total although you will not gain a significant
// speed boost in doing so.
//
   $batch_total = "75";


// MAIL PROTOCOL (mail/sendmail/smtp)
// pMachine can send email using any of these three methods:
// 
// "mail".  This is the default PHP method of sending email.  It is the least
// efficient but the most universally compatible.
//
// "sendmail".  This is more efficient than using "mail", but not all servers
// allow a socket connection to Sendmail. 
//
// "SMTP" is recommended in cases where your host requires it, or if your host
// runs a dedicated mail server - or if you want to use your normal POP3 email
// account.  
//
   $mail_protocol = "";


// SMTP SERVER
// If you chose SMTP as your mail protocol, you must indicate the name of your
// outgoing mail server.  Example:  mail.earthlink.net
//
   $smtp_server = "";


// SMTP USERNAME/PASSWORD
// If you chose SMTP as your mail protocol, you will normally need to supply your
// SMTP username and password so that the SMTP server can authenticate you.
//
   $smtp_username = "";
   $smtp_password = "";

       
       
// PINGBACK/TRACKBACK SERVER URL -----------------------------------------------------
// In order to use the Pingback feature you must indicate the full URL
// to the file called "pingserver.php"  (http://www.yoursite.com/pingserver.php)
   $pingserver_path = "";


// HEADER REDIRECT -----------------------------------------------------
// Alternate header redirect. Some NT servers
// have difficulty setting cookies when the standard php header
// redirect (header("location:x.php");) is used.  This variable allows
// you to use the slower "meta tag refresh" method which has proven to be more 
// reliable for those servers with problems setting cookies.
   $redirect_method = 0;


// COOKIE DOMAIN -----------------------------------------------------
// In most cases you will not need to specify a default cookie domain.
// However, if you want the cookies recognized across your entire domain, 
// or limited to a specific domain, you will need to specify the domain.
// Note:  The most common way to set a cookie domain is to use: .yourdomain.com
// Make sure and leave a period in front.  For example, if your
// site is at www.yoursite.com, you will use:  .yoursite.com
   $cookie_domain = "";

       
// SESSION ID OPTION -----------------------------------------------------
// Cookies are used in the control panel by default.  Query string
// session ID's can be used instead, by setting this variable to 1
// rather than 0.
   $use_session_id = 0;


// OPEN_BASEDIR RESTRICTION -----------------------------------------------------
// If your php configuration has an "open_basedir" restriction
// change this variable to "1".
   $open_basedir = 0;


// If you set the previous variable to "1", this is the name of
// your "members" directory.
   $obd_memdir = "./members/";
   
   
// BLOG ACCESS ARRAY -------------------------------------------------------------
// For admin level's 1 and 2.  Allows them the ability to post to more than one weblog.
// On the left side you will enter the username of each person you want to
// hacve access to more than one weblog.  On the right side "array" you will
// put the name of each weblog that you want the user to be able to access.
// Please pay close attention to the formatting before proceeding.
// Each item in the array must be in quotes and a commma must separate each item.
// In addition, each set must have a comma after it, except the last one.

// EXAMPLE 
// (Note: you must remove the comments to us this.  Be careful!)

/* 

$blogaccess = array(

    "joe"   => array('weblog', 'news', 'politics'),
    "Nancy" => array('news', 'politics'),
    "Fred"  => array('sports', 'weblog'),
    "John"  => array('weblog') 
    
    );
*/


// FORUM MODERATORS:  ADVANCED FUNCTIONALITY -----------------------------------------------
// If you are using forums and wish to have moderators given a title and/or avatar, 
// then fill out the arrays below.  This is more advanced than is typical, so only attempt
// to use this ability if you know what you are doing.

// The first array, $forum_moderators, is used to signify who these moderators are
// via their id number, what moderator level they are, and the location of their avatar icon.
// $forum_moderators['id_of_member'] = ('moderator_level', 'Absolute URL of avatar image');

// The second array, $moderator_levels, is used to signify the moderator levels.
// The key of the array is an identifying number or text, and the value is the name of the
// moderator level

// You will also need to use the %%avatar%% and %%moderation_level%% variables in your 
// Single-Entry and Display Comments templates in the Control Panel

/*

$forum_moderators = array();

$forum_moderators['1']		= array('1','http://www.pmachine.com/images/avatars/pm_staff_rick.gif'); // Rick
$forum_moderators['2404']	= array('1','http://www.pmachine.com/images/avatars/pm_staff_chris.gif'); // Chris

$moderator_levels = array(	'1' => 'pMachine Staff',
							'2'	=> 'pMachine Support Team');
*/

?>