<?php
//
// pMachine Publishing Software
//
// Version 2.4 (Pro2.4.004)
//
// Copyright (c) 2003 - 2005 pMachine, Inc.
//
// THIS IS COPYRIGHTED SOFTWARE
//
// License holders may alter or modify this software for their own use, 
// but may NOT resell or redistribute the modified or derivative version 
// without prior written consent from pMachine.  Components from this 
// software may not be extracted and used in other programs without prior 
// written consent from pMachine.
//
// PLEASE READ THE LICENSE AGREEMENT
//



//	----------------------------------------------
//		FILE UPLOAD CLASS
//	----------------------------------------------

class FileUpload
{
    var $Filename;
    var $Tempfile;
    var $Fixspaces = 1; // 1 = yes - 0 = no. Replaces white spaces in image name with underscores.
    var $ReplaceQuotes = 0; // If set to 1, quotes get replaced with `` characters.


    function FileUpload()
    { 
       
    }
    
    //	----------------------------------------------
    //		FILE HANDLER
    //	----------------------------------------------
    
    function file_handler($pb, $dirid, $filetype, $imgfmt)
    {
        global $upload_method, $db_upload_prefs, $L_FILE, $DB;
        
        $sql = "select * from $db_upload_prefs where id = '$dirid'";
        
        $query = new DB_query($DB, $sql);
        
        $query->db_fetch_object();
  
        $path       = $query->obj->relpath;
        $aldtypes   = $query->obj->allowedtypes;
        $maxsize    = $query->obj->maxsize;
        $maxwidth   = $query->obj->maxwidth;
        $maxheight  = $query->obj->maxheight;
        
        if (!eregi('/$',$path)) $path = "$path" . "/";   
        
        if ($this->directory_exists($path))
        {
            switch ($upload_method)
            {            
                case    1 : $this->upload_engine_one($pb, $dirid, $path, $filetype, $imgfmt, $aldtypes, $maxsize, $maxwidth, $maxheight);
                break;
                case    2 : $this->upload_engine_two($pb, $dirid, $path, $filetype,$imgfmt, $aldtypes, $maxsize, $maxwidth, $maxheight);
                break;
                case    3 : $this->upload_engine_two($pb, $dirid, $path, $filetype,$imgfmt, $aldtypes, $maxsize, $maxwidth, $maxheight);
                break;
                default	  : $this->upload_engine_one($pb, $dirid, $path, $filetype, $imgfmt, $aldtypes, $maxsize, $maxwidth, $maxheight);
                break;
            }
        }
        else
        {
            return $this->error_handler($L_FILE['315']);
        }    
    }
    // END
    


    //	----------------------------------------------
    //	    UPLOAD ENGINE ONE
    //	----------------------------------------------

    function upload_engine_one($pb, $dirid, $path, $filetype, $imgfmt, $aldtypes, $maxsize, $maxwidth, $maxheight)
    {
        global $HTTP_POST_FILES, $L_FILE;
        
    	if (is_uploaded_file($HTTP_POST_FILES['userfile']['tmp_name'])) 
    	{
    		$this->Tempfile = $HTTP_POST_FILES['userfile']['tmp_name'];		
    		$this->Filename = $HTTP_POST_FILES['userfile']['name'];
    		$this->Filetype = $HTTP_POST_FILES['userfile']['type'];
    		$this->Filesize = $HTTP_POST_FILES['userfile']['size'];
    		
            if ($this->Fixspaces == 1)
            {
                $this->Filename = str_replace(" ", "_", $this->Filename);
            }
            
            //-------------------------------------
			// File name security
			//------------------------------------- 
	
			$bad = array(
							"<!--",
							"-->",
							"'",
							'"',
							'&',
							'$',
							'=',
							';',
							'?',
							'/',
							"%3c",		// <
							"%253c", 	// <
							"%3e", 		// >
							"%0e", 		// >
							"%28", 		// (  
							"%29", 		// ) 
							"%2528", 	// (
							"%26", 		// &
							"%24", 		// $
							"%3f", 		// ?
							"%3b", 		// ;
							"%3d"		// =
        				);
        			
			foreach ($bad as $val)
			{
				$this->Filename =& str_replace($val, '', $this->Filename);   
			}
            
            if ($aldtypes <> "")
            {
                if (!$this->valid_file_type($aldtypes, $this->Filetype))
                {
                    return $this->error_handler($L_FILE['335']);    
                }
            }
            
            if ($maxsize <> "")
            {
                if (!$this->valid_file_size($maxsize, $this->Filesize))
                {
                    return $this->error_handler($L_FILE['340']);    
                }
            }

            if ($filetype == 1) // Is this is an image or a non-image?
            {
                if (!$this->valid_image_width_height($maxwidth, $maxheight, $this->Tempfile))
                {
                    return $this->error_handler($L_FILE['345']);    
                }
            }

            if (file_exists("$path$this->Filename"))
            {
                $temp_filename = "{$path}temporary_{$this->Filename}";
                
                if (copy($this->Tempfile, $temp_filename))
                {
                    return $this->file_overwrite_warning($pb, $dirid, $filetype, $temp_filename, "$path$this->Filename", $this->Filename, $imgfmt);           
                }
                else
                {
                    return $this->error_handler($L_FILE['320']);
                }
            }
            else
            {
                if (copy($this->Tempfile, "$path$this->Filename"))
                {               
                    return $this->good_upload_handler($pb, $dirid, $filetype, $this->Filename, "$path$this->Filename", $imgfmt);
                }
                else
                {
                    return $this->error_handler($L_FILE['320']);
                }
            }
    	}
        else 
        {
            return $this->error_handler($L_FILE['320']);
        }
    }
    // END
    
    
    //	-------------------------------------------------
    //		UPLOAD ENGINE TWO (FOR OLD VERSIONS OF PHP)
    //	-------------------------------------------------
  
    function upload_engine_two($pb, $dirid, $path, $filetype, $imgfmt, $aldtypes, $maxsize, $maxwidth, $maxheight)
    {
        global $upload_method, $L_FILE, $userfile, $userfile_name, $userfile_type, $userfile_size;

        	if ($this->Fixspaces == 1)
        	{
        	    $userfile_name = str_replace(" ", "_", $userfile_name);
       		}
        
        	//-------------------------------------
			// File name security
			//------------------------------------- 
	
			$bad = array(
							"<!--",
							"-->",
							"'",
							'"',
							'&',
							'$',
							'=',
							';',
							'?',
							'/',
							"%3c",		// <
							"%253c", 	// <
							"%3e", 		// >
							"%0e", 		// >
							"%28", 		// (  
							"%29", 		// ) 
							"%2528", 	// (
							"%26", 		// &
							"%24", 		// $
							"%3f", 		// ?
							"%3b", 		// ;
							"%3d"		// =
        				);
        			
			foreach ($bad as $val)
			{
				$this->Filename =& str_replace($val, '', $this->Filename);   
			}
        
            if ($aldtypes <> "")
            {
                if (!$this->valid_file_type($aldtypes, $userfile_type))
                {
                    return $this->error_handler($L_FILE['335']);    
                }
            }
            
            if ($maxsize <> "")
            {
                if (!$this->valid_file_size($maxsize, $userfile_size))
                {
                    return $this->error_handler($L_FILE['340']);    
                }
            }

            if ($filetype == 1) // If this is an image
            {
                if (!$this->valid_image_width_height($maxwidth, $maxheight, $userfile))
                {
                    return $this->error_handler($L_FILE['345']);    
                }
            }

            if (file_exists("$path$userfile_name"))
            {
                
                $temp_filename = "{$path}temporary_$userfile_name";
                
                if ($upload_method == 2)
                {
                    $xfer = copy($userfile, $temp_filename);    
                }
                elseif ($upload_method ==3)
                {
                    $xfer = move_uploaded_file($userfile, $temp_filename);    
                }
            
                if ($xfer)
                {
                    return $this->file_overwrite_warning($pb, $dirid, $filetype, $temp_filename, "$path$userfile_name", $userfile_name, $imgfmt);           
                }
                else
                {
                    return $this->error_handler($L_FILE['320']);
                }
            }
            else
            {
                if ($upload_method == 2)
                {
                    $xfer = copy($userfile, "$path$userfile_name");    
                }
                elseif ($upload_method == 3)
                {
                    $xfer = move_uploaded_file($userfile, "$path$userfile_name");    
                }
                if ($xfer)
                {               
                    return $this->good_upload_handler($pb, $dirid, $filetype, $userfile_name, "$path$userfile_name", $imgfmt);
                }
                else
                {
                    return $this->error_handler($L_FILE['320']);
                }
            }    
    }    
    // END
    
    
    
    //	----------------------------------------------
    //		VALIDATE UPLOADS DIRECTORY
    //	----------------------------------------------
    
    function directory_exists($path)
    {        
        if (!is_dir($path))
        {
            return false;
        }
        else
        {
            return true;
        }
    }
// END    


//	----------------------------------------------
//		VALIDATE FILE TYPES
//	----------------------------------------------
 
    function valid_file_type($allowedtypes, $fileset)
    {
        $x = explode('.',$fileset);
                        
        $t = $x[count($x)-1];
        
        $x = explode("/",$t);
        
        $z = $x[count($x)-1];

        $x = explode("-",$z);
        
        $type = strtolower($x[count($x)-1]);
        
        $allowed = explode(" ", $allowedtypes);
                  
        $valid = false;
        
        $jpg  = 0;
        $jpeg = 0;
        $pjpeg = 0;
 
         for ($i = 0; $i < count($allowed); $i++)
        {
            if ($allowed[$i] == "jpg")
            {
                $jpg = 1;
            }
            if ($allowed[$i] == "jpeg")
            {
                $jpeg = 1;
            }
            if ($allowed[$i] == "pjpeg")
            {
                $jpeg = 1;
            }
        }
       
        if (($pjpeg == 0)  AND ($jpg == 1 || $jpeg == 1))
        {
        	array_push($allowed, "pjpeg");
        }
        if (($jpeg == 0)  AND ($jpg == 1 || $pjpeg == 1))
        {
        	array_push($allowed, "jpeg");
		}
              
        for ($i = 0; $i < count($allowed); $i++)
        {
            if (preg_match("/^$allowed[$i]$/",$type))
            {
                $valid = true;
            }
        }
        
        return $valid;
    }
    // END
    
    
    //	----------------------------------------------
    //		CHECK FILE SIZE
    //	----------------------------------------------

    function valid_file_size($maxsize, $imgsize)
    {   
        $maxsize = trim($maxsize);
        
        if (!eregi("^[[:digit:]]+$", $maxsize)) 
        {
            return false;
        }
        
        if ($imgsize > $maxsize)
        {
            return false;
        }
        else
        {
            return true;
        }
    }
    // END
    
    
    //	----------------------------------------------
    //		VALIDATE IMAGE WIDTH/HEIGHT
    //	----------------------------------------------

    function valid_image_width_height($maxwidth, $maxheight, $imagepath)
    {
        if (function_exists('getimagesize')) 
        {
            $imgdim = @getimagesize($imagepath);
            
            if ($maxwidth == "")
                $maxwidth = $imgdim[0] + 10;
                
            if ($maxheight == "")
                $maxheight = $imgdim[1] + 10;
                
                if (($imgdim[0] > $maxwidth) || ($imgdim[1] > $maxheight))
                {
                    return false;
                }
                else
                {
                    return true;
                }
        }
        else
        {
            return true;
        }
    } 
    // END   
        
    
    //	----------------------------------------------
    //		FILE UPLOAD FORM
    //	----------------------------------------------
    
    function file_upload_form($pb=0) 
    {
        global $db_upload_prefs, $L_FILE, $sx, $sfx, $DB;
        
        $sql = "select id, refname, deftdir 
                from $db_upload_prefs 
                where minlevel <= '".get_user_status()."' 
                order by name";
        
        $query = new DB_query($DB, $sql);
        
        if ($query->db_num_rows() == 0)
        {
            echo "<div align=\"center\"><br /><br />";
            error_message();
            echo "<br /><br /><br />\r\n<a href=\"JavaScript:window.close()\">$L_FILE[120]</a></div>\r\n";
            footer_plain();
            exit;
        }
    ?>
    <br />
    <form method="post" action="<?php echo "index$sfx?sx=$sx"."&m=file_upload&p=upload"; ?>" enctype="multipart/form-data">
    <input type="hidden" name="pb" value="<?php echo $pb; ?>" >
    
    <div align="center">
    <br />
    <table cellpadding="0" cellspacing="0" border="0">
    <tr>
    <td height="40" align="left" valign="top">
    <div class="text11grey"><b><?php echo "$L_FILE[100]"; ?></b></div>
    </td>
    </tr>
    <tr>
    <td height="32" align="left">
    <input type="file" name="userfile" size="20" >
    <br /><br /><br />
    <div class="text10"><?php echo "$L_FILE[190]"; ?></div><br />
    <select name="dirid" class="pulldown">
    <?php
    
        
        while ($query->db_fetch_object())
        {
            $id = $query->obj->id;
            $refname = $query->obj->refname;
            $deftdir = $query->obj->deftdir;
            $selected = "";
    
            
            if ($deftdir == 1)
                $selected = "selected";
            
            echo "<option value=\"$id\" $selected>$refname</option>\r\n";
            
        }
    ?>
    </select>
    <br /><br /><br />
    <div class="text10">
    <?php echo "$L_FILE[380]"; ?> <input type="radio" name="filetype" value="1" checked>&nbsp; &nbsp;
    <?php echo "$L_FILE[385]"; ?> <input type="radio" name="filetype" value="0" >
    </div>
    <br /><br />
    <div class="text10"><?php echo "$L_FILE[110]"; ?> <input type="checkbox" name="imgfmt" value="yes" ></div>
    <br /><br /><br />
    <input type="submit" value=" <?php echo "$L_FILE[115]"; ?> " class="button">
    <br /><br />
    <hr size="1" color="#cccccc">
    <br />
    <a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=browsemenu&pb=$pb"; ?>"><?php echo "$L_FILE[200]"; ?></a>
    <br /><br /><br />
    <a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=prefs&pb=$pb"; ?>"><?php echo "$L_FILE[195]"; ?></a>
    <br /><br />
    <hr size="1" color="#cccccc">
    <br />
    <a href="JavaScript:window.close()" onmouseover="window.status='<?php echo "$L_FILE[120]"; ?> ';return true"  onmouseout="window.status='';return true"><?php echo "$L_FILE[120]"; ?> </a>
    </td>
    </tr>
    </table>
    </div>
    </form>
    <?php
    }
    // END    
        
    

    //	----------------------------------------------
    //		FILE OVERWRITE WARNING
    //	----------------------------------------------

    function file_overwrite_warning($pb, $dirid, $filetype, $tempname, $path, $imagename, $imgfmt)
    {
        global $L_FILE, $sfx, $sx;
        
        if (!access_privs(11))
            return $this->error_handler("$L_FILE[185] <br /><br />$L_FILE[187]")
        ?>
        <form method="post" action="<?php echo "index$sfx?sx=$sx"."&m=file_upload&p=overwrite"; ?>" >
        <input type="hidden" name="dirid" value="<?php echo $dirid; ?>" />
        <input type="hidden" name="filetype" value="<?php echo $filetype; ?>" />
        <input type="hidden" name="tempname" value="<?php echo $tempname; ?>" />
        <input type="hidden" name="path" value="<?php echo $path; ?>" />
        <input type="hidden" name="imagename" value="<?php echo $imagename; ?>" />
        <input type="hidden" name="imgfmt" value="<?php echo $imgfmt; ?>" />
        <input type="hidden" name="pb" value="<?php echo $pb; ?>" />

        <br /><br />
        <br /><br />
        <div align="center">
        <table border="0" cellspacing="0" cellpadding="0" width="340">
        <tr>
        <td>
        
        <div class="text11red"><b><?php echo $L_FILE['390']; ?></b></div>
            
        </td>
        </tr>
        </table>
        
        <br /><br />
        
        <input type="submit" name="submit" value=" <?php echo $L_FILE['325']; ?> " class="button">
        
        <br /><br /><br />
        
        <input type="submit" name="cancel" value=" &nbsp;<?php echo $L_FILE['330']; ?>&nbsp; " class="button">

        </div>
        
        </form>
        
        <?php
    }
    // END
    
    
    
    //	----------------------------------------------
    //		OVERWRITE FILE
    //	----------------------------------------------

    function file_overwrite($pb, $dirid, $filetype, $temp_filename, $real_filename, $imagename, $imgfmt)
    {
        global $L_FILE;
              
            if (copy($temp_filename, $real_filename))
            {
                unlink ($temp_filename);

                return $this->good_upload_handler($pb, $dirid, $filetype, $imagename, $real_filename, $imgfmt);    		
            }			
            else 
            {
                return $this->error_handler($L_FILE['320']);
            }
    }
    // END   
        
        
    
    //	----------------------------------------------
    //		ERROR HANDLER
    //	----------------------------------------------

    function error_handler($msg)
    {
        global $L_FILE, $sfx, $sx;
        ?>
        <br /><br />
        <div align="center">
        <table border="0" cellspacing="0" cellpadding="0" width="350">
        <tr>
        <td>
        <div class="text11"><?php echo $msg; ?></div>
        </td>
        </tr>
        </table>
        <br /><br />
        <a href="javascript:history.go(-1)">&lt;&nbsp;<?php echo $L_FILE['360']; ?></a>
        </div>
        <?php
    }
    // END
     
     
    //	----------------------------------------------
    //		SUCCESSFUL UPLOAD MESSAGE AND HANDLER
    //	----------------------------------------------

    function good_upload_handler($pb, $dirid, $filetype, $filename,  $imagepath, $imgfmt)
    {
        global $L_FILE, $db_upload_prefs, $sfx, $sx, $DB, $SHARED;
        
        $sql = "select * from $db_upload_prefs where id = '$dirid'";
        
        $query = new DB_query($DB, $sql);
        
        $query->db_fetch_object();
        
        $preformat  = $query->obj->preformat;
        $postformat = $query->obj->postformat;
        $properties = $query->obj->properties;
        $preformat  = $query->obj->preformat;
        $deftfield  = $query->obj->deftfield;

            $deft_blurb = "";
            $deft_body = "";
            $deft_more = "";
            $deft_c1 = "";
            $deft_c2 = "";
            $deft_c3 = "";

        if ($deftfield == "blurb")   $deft_blurb = "checked";
        if ($deftfield == "body")    $deft_body = "checked";
        if ($deftfield == "more")    $deft_more = "checked";
        if ($deftfield == "custom1") $deft_c1 = "c1";
        if ($deftfield == "custom2") $deft_c2 = "c2";
        if ($deftfield == "custom3") $deft_c3 = "c3";
        
        if ($pb == 1)  $deft_body = "checked";

        
        if ($imgfmt == "no")
        {
            $preformat = "";
            $postformat = "";
        }
        

        if ($this->ReplaceQuotes == 0)
        {
            $q = "\"";
        }
        else
        {
            if ($imgfmt == "yes")
            {
                $preformat  = pmcode_add_img_quotes($preformat);
                $properties = pmcode_add_img_quotes($properties);
                $postformat = pmcode_add_img_quotes($postformat);
                $q = "``";
            }
        }

        if ($filetype == 1) // If uploaded file is an image
        {
            if (function_exists('getimagesize')) 
            {
                $imgdim = @getimagesize($imagepath);
                if (!(false === $imgdim)) 
                {
                    $properties .= " width=$q$imgdim[0]$q height=$q$imgdim[1]$q";
                }
            }

            $finalpref = "$preformat<img src=$q%%dir[$dirid]%%$filename$q $properties />$postformat";
        }
        else  // If uploaded file is a non-image
        {
            $finalpref = "$preformat<a href=$q%%dir[$dirid]%%$filename$q >$filename</a>$postformat";
        }

?>
<script language="JavaScript">

function filejam() 
{

    var file = '<?php echo "$finalpref"; ?>';

    if (document.fileplacer.which.checked) 
    {
        opener.document.box.body.value += file +" ";
    }
    
    if (document.fileplacer.which[0].checked) 
    {
        var val = document.fileplacer.which[0].value;
        
        if (val == 'blurb') {
            opener.document.box.blurb.value += file +" ";
        }
        if (val == 'body') {
            opener.document.box.body.value += file +" ";
        }
        if (val == 'more') {
            opener.document.box.more.value += file +" ";
        }
        if (val == 'c1') {
            opener.document.box.custom1.value += file +" ";
        }
        if (val == 'c2') {
            opener.document.box.custom2.value += file +" ";
        }
        if (val == 'c3') {
            opener.document.box.custom3.value += file +" ";
        }
    }
    else if (document.fileplacer.which[1].checked) 
    {
        var val = document.fileplacer.which[1].value;
        if (val == 'blurb') {
            opener.document.box.blurb.value += file +" ";
        }
        if (val == 'body') {
            opener.document.box.body.value += file +" ";
        }
        if (val == 'more') {
            opener.document.box.more.value += file +" ";
        }
        if (val == 'c1') {
            opener.document.box.custom1.value += file +" ";
        }
        if (val == 'c2') {
            opener.document.box.custom2.value += file +" ";
        }
        if (val == 'c3') {
            opener.document.box.custom3.value += file +" ";
        }
    }
    else if (document.fileplacer.which[2].checked) 
    {
        var val = document.fileplacer.which[2].value;
        if (val == 'blurb') {
            opener.document.box.blurb.value += file +" ";
        }
        if (val == 'body') {
            opener.document.box.body.value += file +" ";
        }
        if (val == 'more') {
            opener.document.box.more.value += file +" ";
        }
        if (val == 'c1') {
            opener.document.box.custom1.value += file +" ";
        }
        if (val == 'c2') {
            opener.document.box.custom2.value += file +" ";
        }
        if (val == 'c3') {
            opener.document.box.custom3.value += file +" ";
        }
    }
    else if (document.fileplacer.which[3].checked) 
    {
        var val = document.fileplacer.which[3].value;
        if (val == 'blurb') {
            opener.document.box.blurb.value += file +" ";
        }
        if (val == 'body') {
            opener.document.box.body.value += file +" ";
        }
        if (val == 'more') {
            opener.document.box.more.value += file +" ";
        }
        if (val == 'c1') {
            opener.document.box.custom1.value += file +" ";
        }
        if (val == 'c2') {
            opener.document.box.custom2.value += file +" ";
        }
        if (val == 'c3') {
            opener.document.box.custom3.value += file +" ";
        }
    }
    else if (document.fileplacer.which[4].checked) 
    {
        var val = document.fileplacer.which[4].value;
        if (val == 'blurb') {
            opener.document.box.blurb.value += file +" ";
        }
        if (val == 'body') {
            opener.document.box.body.value += file +" ";
        }
        if (val == 'more') {
            opener.document.box.more.value += file +" ";
        }
        if (val == 'c1') {
            opener.document.box.custom1.value += file +" ";
        }
        if (val == 'c2') {
            opener.document.box.custom2.value += file +" ";
        }
        if (val == 'c3') {
            opener.document.box.custom3.value += file +" ";
        }
    }
    else if (document.fileplacer.which[5].checked) 
    {
        var val = document.fileplacer.which[5].value;
        if (val == 'blurb') {
            opener.document.box.blurb.value += file +" ";
        }
        if (val == 'body') {
            opener.document.box.body.value += file +" ";
        }
        if (val == 'more') {
            opener.document.box.more.value += file +" ";
        }
        if (val == 'c1') {
            opener.document.box.custom1.value += file +" ";
        }
        if (val == 'c2') {
            opener.document.box.custom2.value += file +" ";
        }
        if (val == 'c3') {
            opener.document.box.custom3.value += file +" ";
        }
    }
}
</script>

    <form name="fileplacer" method="post" action="JavaScript:window.close()" >
    
    <br /><br /><br />
    
    <div align="center" class="text11"><?php echo "$L_FILE[140]"; ?></div>
    
    <br /><br />
    
    <div align="center" class="text12blue"><b><?php echo "$filename"; ?></b></div>
    
    <br /><br />
    
    <div align="center" class="text9"><?php echo "$L_FILE[145]"; ?><br /><br /></div>
    
    <div align="center" class="text10">
    
    <?php if (($SHARED->get_pref("show_field_blurb")=="yes") && ($pb <> 1)) 
    {
        echo "$L_FILE[150]"; ?> <input type="radio" name="which" value="blurb" <?php echo $deft_blurb; ?> />&nbsp;&nbsp;
    <?php
    }
    ?>
    <?php echo "$L_FILE[155]"; ?> <input type="radio" name="which" value="body" <?php echo $deft_body; ?> />&nbsp;&nbsp;
    
    <?php if (($SHARED->get_pref("show_field_more")=="yes") && ($pb <> 1)) 
    {
    ?>
    <?php echo "$L_FILE[160]"; ?> <input type="radio" name="which" value="more" <?php echo $deft_more; ?> />&nbsp;&nbsp;
    <?php
    }
    if (($SHARED->get_pref("show_field_custom_1")=="yes") && ($pb <> 1)) 
    {
    ?>
    <?php echo "$L_FILE[165]"; ?> <input type="radio" name="which" value="c1" <?php echo $deft_c1; ?> />&nbsp;&nbsp;
    <?php
    }
    if (($SHARED->get_pref("show_field_custom_2")=="yes") && ($pb <> 1)) 
    {
    ?>
    <?php echo "$L_FILE[170]"; ?> <input type="radio" name="which" value="c2" <?php echo $deft_c2; ?> />&nbsp;&nbsp;
    <?php
    }
    if (($SHARED->get_pref("show_field_custom_3")=="yes") && ($pb <> 1))  
    {
    ?>
    <?php echo "$L_FILE[175]"; ?> <input type="radio" name="which" value="c3" <?php echo $deft_c3; ?> />&nbsp;&nbsp;
    <?php
    }
    ?>
    </div>
    
    <br /><br />
    
    <div class="blue" align="center">
    
    <input type="submit"  value=" <?php echo "$L_FILE[180]"; ?> " onclick="filejam();" class="button">
    
    </div>
    
    </form>
<?php
}
// END
        
 
    
}
// END OF FILE UPLOAD CLASS





//	----------------------------------------------
//		FILE PREFS
//	----------------------------------------------

function file_prefs($pb=0,$qresult="")
{
    global $db_upload_prefs, $L_FILE, $L_PREFERENCES, $sfx, $sx, $DB;
?>

<br />

<div align="center">


<table border="0" cellspacing="0" cellpadding="0" width="300">
<tr>
<td colspan="3">
<?php
    if ($qresult == "update")
    {   
    success_msg("<div class=\"text11green\"><b>$L_PREFERENCES[205]</b></div><br />");
    }
    elseif ($qresult == "new")
    {   
    success_msg("<div class=\"text11green\"><b>$L_FILE[395]</b></div><br />");
    }
?>
<br /><br />

<table cellpadding="0" cellspacing="0" border="0" width="100%">
<tr>
<td><div class="smlinkbluenb"><b><?php echo $L_FILE['210']; ?>&nbsp;&nbsp;</b></div></td>
<td colspan="1" align="right">
<div class="smlinkbluenb"> &nbsp;<a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=newpref&pb=$pb"; ?>"><b><?php echo $L_FILE['205']; ?></b></a>&nbsp;</div>
</td>
</tr>
</table>

<hr size="1" color="#cccccc">
</td>

<?php
    
    $q = "select id, refname from $db_upload_prefs order by name";
    
    $query = new DB_query($DB, $q);
    
    while ($query->db_fetch_object())
    {
        $id = $query->obj->id;
        $refname = $query->obj->refname;        

?>
<tr><td><div class="text10"><?php echo $refname; ?></div></td>
<td align="right"><div class="smlinkblue"><a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=edit&id=$id&pb=$pb"; ?>"><?php echo $L_FILE['220']; ?></a></div></td>
<td align="right"><div class="smlink">&nbsp;<a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=delconfirm&id=$id&pb=$pb"; ?>"><b><?php echo $L_FILE['225']; ?></b></a>&nbsp;</div></td>
</tr><tr><td colspan="3"><hr size="1" color="#cccccc"></td></tr>
<?php
    }
?>
</table>

</td>
</tr>
</table>

<br /><br /><br />

&nbsp;&nbsp;<a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=main&pb=$pb"; ?>">^ <?php echo $L_FILE['215']; ?></a>&nbsp;&nbsp;&nbsp;



</div>

<?php
}
// END




//	----------------------------------------------
//		NEW/EDIT PREFERENCE FORM
//	----------------------------------------------

function file_pref_form(   $pb = 0,
                            $id = "",
                            $error = 0,
                            $name = "",
                            $refname = "",
                            $relpath = "",
                            $abspath = "",
                            $properties = "",
                            $preformat = "",
                            $postformat = "",
                            $deftdir = "",
                            $maxsize = "",
                            $maxwidth = "",
                            $maxheight = "",
                            $allowedtypes = "",
                            $minlevel="",
                            $deftfield="" )
{

    global $L_FILE, $L_MEMBERS, $db_upload_prefs, $language;
    global $sfx, $sx, $DB, $SHARED;
    
    
    if ($id == "")
        $button = $L_FILE['205'];
    else
        $button = $L_FILE['290'];

    
    if ($id <> "" AND $error == 0)
    {
        
        $q = "select * from $db_upload_prefs where id = '$id'";
        
        $query = new DB_query($DB ,$q);
        
        $query->db_fetch_object();
        
        $name           = $query->obj->name;
        $refname        = $query->obj->refname;
        $relpath        = $query->obj->relpath;
        $abspath        = $query->obj->abspath;
        $properties     = $query->obj->properties;
        $preformat      = $query->obj->preformat;
        $postformat     = $query->obj->postformat;
        $deftdir        = $query->obj->deftdir;
        $deftfield      = $query->obj->deftfield;
        $maxsize        = $query->obj->maxsize;
        $maxwidth       = $query->obj->maxwidth;
        $maxheight      = $query->obj->maxheight;
        $allowedtypes   = $query->obj->allowedtypes;
        $minlevel       = $query->obj->minlevel;
        $deftfield      = $query->obj->deftfield;
        
    }
    else
    {
      if ($allowedtypes == "")
          $allowedtypes = "gif jpg jpeg png";
    }
    
    if ($deftdir == "yes" || $deftdir == 1)
        $deftdir = "checked";  

        $deftfield_blurb = "";    
        $deftfield_body = "";    
        $deftfield_more = "";    
        $deftfield_custom1 = "";    
        $deftfield_custom2 = "";    
        $deftfield_custom3 = "";
        
    if (!isset($deftfield))
        $deftfield = "";
  
    switch ($deftfield)
    {
        case "blurb" :   $deftfield_blurb = "checked";
        break;
        case "body" :    $deftfield_body = "checked";
        break;
        case "more" :    $deftfield_more = "checked";
        break;
        case "custom1" : $deftfield_custom1 = "checked";
        break;
        case "custom2" : $deftfield_custom2 = "checked";
        break;
        case "custom3" : $deftfield_custom3 = "checked";
        break;
        default : $deftfield_body = "checked";
        break; 
    }

?>

<form method="post" action="<?php echo "index$sfx?sx=$sx&m=file_upload&p=editpref"; ?>">
<input type="hidden" name="id" value="<?php echo $id; ?>" />
<input type="hidden" name="pb" value="<?php echo $pb; ?>"  />

<br />

<div align="center">

<table border="0" cellspacing="0" cellpadding="0" width="250">
<tr>
<td>


<table cellspacing="0" cellpadding="11" border="0" >
<tr>


<td align="right">
<div class="text10red" align="right"><b>*</b>
<?php 
if ($error == 0)
{
    echo $L_FILE['300']; 
}
else
{
    echo "<b>" . $L_FILE['302'] . "</b>"; 
}
?></div>

</tr><tr>
<td>
<div class="text10pad">[<a href="./language/<?php echo "$language";?>/<?php echo"preferences"."$sfx"."#i230"; ?>" onclick="prefDoc()" target="prefdoc">i</a>]
&nbsp;<span class="text10red"><b>*</b></span>&nbsp;<b><?php echo $L_FILE['230']; ?></b>
</div>
<input type="text" name="refname" class="imagePrefBox" value="<?php echo htmlspecialchars(stripslashes($refname)); ?>" /></td>


</tr><tr>
<td>
<div class="text10pad">[<a href="./language/<?php echo "$language";?>/<?php echo"preferences"."$sfx"."#i235"; ?>" onclick="prefDoc()" target="prefdoc">i</a>]
&nbsp;<span class="text10red"><b>*</b></span>&nbsp;<b><?php echo $L_FILE['235']; ?></b>
</div>
<input type="text" name="name" class="imagePrefBox" value="<?php echo htmlspecialchars(stripslashes($name)); ?>" /></td>


</tr><tr>
<td>
<div class="text10pad">[<a href="./language/<?php echo "$language";?>/<?php echo"preferences"."$sfx"."#i240"; ?>" onclick="prefDoc()" target="prefdoc">i</a>]
&nbsp;<span class="text10red"><b>*</b></span>&nbsp;<b><?php echo $L_FILE['240']; ?></b>
<?php 
if ($id == "")
echo "<br /><span class=\"text10red\">$L_FILE[241]</b></span>";
?>
</div>
<input type="text" name="relpath" class="imagePrefBox" value="<?php echo htmlspecialchars(stripslashes($relpath)); ?>" /></td>


</tr><tr>
<td>
<div class="text10pad">[<a href="./language/<?php echo "$language";?>/<?php echo"preferences"."$sfx"."#i242"; ?>" onclick="prefDoc()" target="prefdoc">i</a>]
&nbsp;<span class="text10red"><b>*</b></span>&nbsp;<b><?php echo $L_FILE['242']; ?></b>
</div>
<input type="text" name="abspath" class="imagePrefBox" value="<?php echo htmlspecialchars(stripslashes($abspath)); ?>" /></td>


</tr><tr>
<td>
<div class="text10pad">[<a href="./language/<?php echo "$language";?>/<?php echo"preferences"."$sfx"."#i243"; ?>" onclick="prefDoc()" target="prefdoc">i</a>]
&nbsp;<b><?php echo $L_FILE['243']; ?></b>
</div>
<input type="text" name="allowedtypes" class="imagePrefBox" value="<?php echo htmlspecialchars(stripslashes($allowedtypes)); ?>" /></td>


</tr><tr>
<td>
<div class="text10pad">[<a href="./language/<?php echo "$language";?>/<?php echo"preferences"."$sfx"."#i244"; ?>" onclick="prefDoc()" target="prefdoc">i</a>]
&nbsp;<b><?php echo $L_FILE['244']; ?></b>
</div>
<input type="text" name="maxsize" class="imagePrefBox" value="<?php echo htmlspecialchars(stripslashes($maxsize)); ?>" /></td>


</tr><tr>
<td>
<div class="text10pad">[<a href="./language/<?php echo "$language";?>/<?php echo"preferences"."$sfx"."#i245"; ?>" onclick="prefDoc()" target="prefdoc">i</a>]
&nbsp;<b><?php echo $L_FILE['245']; ?></b>
</div>
<input type="text" name="maxwidth" class="imagePrefBox" value="<?php echo htmlspecialchars(stripslashes($maxwidth)); ?>" /></td>


</tr><tr>
<td>
<div class="text10pad">[<a href="./language/<?php echo "$language";?>/<?php echo"preferences"."$sfx"."#i246"; ?>" onclick="prefDoc()" target="prefdoc">i</a>]
&nbsp;<b><?php echo $L_FILE['246']; ?></b>
</div>
<input type="text" name="maxheight" class="imagePrefBox" value="<?php echo htmlspecialchars(stripslashes($maxheight)); ?>" /></td>

</tr><tr>
<td>
<div class="text10pad">[<a href="./language/<?php echo "$language";?>/<?php echo"preferences"."$sfx"."#i255"; ?>" onclick="prefDoc()" target="prefdoc">i</a>]
&nbsp;<b><?php echo $L_FILE['255']; ?></b>
</div>
<input type="text" name="properties" class="imagePrefBox" value="<?php echo htmlspecialchars(stripslashes($properties)); ?>" /></td>

</tr><tr>
<td>
<div class="text10pad">[<a href="./language/<?php echo "$language";?>/<?php echo"preferences"."$sfx"."#i265"; ?>" onclick="prefDoc()" target="prefdoc">i</a>]
<b><?php echo $L_FILE['265']; ?></b>
</div>
<input type="text" name="preformat" class="imagePrefBox" value="<?php echo htmlspecialchars(stripslashes($preformat)); ?>" /></td>

</tr><tr>
<td>
<div class="text10pad">[<a href="./language/<?php echo "$language";?>/<?php echo"preferences"."$sfx"."#i275"; ?>" onclick="prefDoc()" target="prefdoc">i</a>]
<b><?php echo $L_FILE['275']; ?></b>
</div>
<input type="text" name="postformat" class="imagePrefBox" value="<?php echo htmlspecialchars(stripslashes($postformat)); ?>" /></td>


</tr><tr>
<td>
<div class="text10pad">
<?php echo $L_FILE['370']; ?><br /><br />
<?php if ($SHARED->get_pref("show_field_blurb")=="yes") { echo $L_FILE['150']; ?>&nbsp;<input type="radio" name="deftfield" value="blurb" <?php echo $deftfield_blurb; ?> /><?php } ?>
<?php echo "&nbsp;&nbsp;".$L_FILE['155']; ?>&nbsp;<input type="radio" name="deftfield" value="body" <?php echo $deftfield_body; ?> />
<?php if ($SHARED->get_pref("show_field_more")=="yes") { echo "&nbsp;&nbsp;".$L_FILE['160']; ?>&nbsp;<input type="radio" name="deftfield" value="more" <?php echo $deftfield_more; ?> /><?php } ?>
<?php if ($SHARED->get_pref("show_field_custom_1")=="yes") { echo "&nbsp;&nbsp;".$L_FILE['165']; ?>&nbsp;<input type="radio" name="deftfield" value="custom1" <?php echo $deftfield_custom1; ?> /><?php } ?>
<?php if ($SHARED->get_pref("show_field_custom_2")=="yes") { echo "&nbsp;&nbsp;".$L_FILE['170']; ?>&nbsp;<input type="radio" name="deftfield" value="custom2" <?php echo $deftfield_custom2; ?> /><?php } ?>
<?php if ($SHARED->get_pref("show_field_custom_3")=="yes") { echo "&nbsp;&nbsp;".$L_FILE['175']; ?>&nbsp;<input type="radio" name="deftfield" value="custom3" <?php echo $deftfield_custom3; ?> /><?php } ?>
</div>
</td>


</tr><tr>
<td>
<div class="text10pad">
<?php echo $L_FILE['285']; ?>&nbsp;<input type="checkbox" name="deftdir" value="yes" <?php echo $deftdir; ?> />
</div>
</td>

</tr><tr>
<td>
<?php echo $L_FILE['375']; ?><br /><br />

<?php
        $sel_7 = "";
        $sel_8 = "";
        $sel_9 = "";
        $sel_10 = "";
        $sel_11 = "";
        $sel_12 = "";

    if (!isset($minlevel))
        $minlevel = 4;
    
    switch ($minlevel)
    {
        case "7" : $sel_7 = "selected";
        break;
        case "8" : $sel_8 = "selected";
        break;
        case "9" : $sel_9 = "selected";
        break;
        case "10" : $sel_10 = "selected";
        break;
        case "11" : $sel_11 = "selected";
        break;
        case "12" : $sel_12 = "selected";
    }
?>

<select name="minlevel" class="pulldown" >
<option value="7" <?php echo "$sel_7"; ?> ><?php echo "$L_MEMBERS[385]"; ?></option>
<option value="8" <?php echo "$sel_8"; ?> ><?php echo "$L_MEMBERS[390]"; ?></option>
<option value="9" <?php echo "$sel_9"; ?> ><?php echo "$L_MEMBERS[395]"; ?></option>
<option value="10" <?php echo "$sel_10"; ?> ><?php echo "$L_MEMBERS[400]"; ?></option>
<option value="11" <?php echo "$sel_11"; ?> ><?php echo "$L_MEMBERS[403]"; ?></option>
<option value="12" <?php echo "$sel_12"; ?> ><?php echo "$L_MEMBERS[331]"; ?></option>
</select>

</td>
</tr>
</table>
<br /><br />
<div align="center"><input type="submit" value=" <?php echo $button ?>" class="button"></div>

</form>

</td>
</tr>
</table>

</div>

&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:history.go(-1)">&lt;&nbsp;<?php echo $L_FILE['360']; ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=main&pb=$pb"; ?>">^ <?php echo $L_FILE['215']; ?></a>&nbsp;&nbsp;&nbsp;


<?php
}
// END



//	----------------------------------------------
//		CREATE/EDIT PREFERENCE
//	----------------------------------------------

function file_add_pref($id = "",
                        $name = "",
                        $refname = "",
                        $relpath = "",
                        $abspath = "",
                        $properties = "",
                        $preformat = "",
                        $postformat = "",
                        $deftdir = "",
                        $maxsize = "",
                        $maxwidth = "",
                        $maxheight = "",
                        $allowedtypes = "",
                        $minlevel = "",
                        $deftfield = "",
                        $pb =0) 
                        {
                            

    global $L_FILE, $db_upload_prefs, $sfx, $sx, $DB;
    
    if ($name == "" || $refname == "" || $relpath == "" || $abspath == "")
    {
        return file_pref_form($pb,$id,"1",$name,$refname,$relpath,$abspath,$properties,$preformat,$postformat,$deftdir,$maxsize,$maxwidth,$maxheight,$allowedtypes,$minlevel,$deftfield);
    }
        
    if (!get_magic_quotes_gpc())
    {
        $name           = addslashes($name);
        $refname        = addslashes($refname);
        $relpath        = addslashes($relpath);
        $abspath        = addslashes($abspath);
        $properties     = addslashes($properties);
        $preformat      = addslashes($preformat);
        $postformat     = addslashes($postformat);    
        $maxsize        = addslashes($maxsize);    
        $maxwidth       = addslashes($maxwidth);    
        $maxheight      = addslashes($maxheight);    
        $allowedtypes   = addslashes($allowedtypes);    
    }

    if ($deftdir == "yes")
        $deftdir = 1;
    else
        $deftdir = 0;
        
    if (!eregi('/$',$relpath)) $relpath = "$relpath" . "/";
    
    if ($deftdir == 1)
    {
        $q = "update $db_upload_prefs set deftdir = '0' where deftdir = '1' ";
                
        $query = new DB_query($DB, $q);
        
        unset($q);
        unset($query);        
    }
    
    if ($id == "")
    {   
        $qresult = "new";
        $q = "insert into $db_upload_prefs 
                (id,
                name,
                refname,
                relpath,
                abspath,
                properties,
                preformat,
                postformat,
                deftdir,
                maxsize,
                maxwidth,
                maxheight,
                allowedtypes,
                minlevel,
                deftfield)
              values
                ('',
                '$name',
                '$refname',
                '$relpath',
                '$abspath',
                '$properties',
                '$preformat',
                '$postformat',
                '$deftdir',
                '$maxsize',
                '$maxwidth',
                '$maxheight',
                '$allowedtypes',
                '$minlevel',
                '$deftfield')";
    }
    else
    {
         $qresult = "update";
        
         $q = "update $db_upload_prefs set 
                name            = '$name',
                refname         = '$refname',
                relpath         = '$relpath',
                abspath         = '$abspath',
                properties      = '$properties',
                preformat       = '$preformat',
                postformat      = '$postformat',
                deftdir         = '$deftdir',
                maxsize         = '$maxsize',
                maxwidth        = '$maxwidth',
                maxheight       = '$maxheight',
                minlevel        = '$minlevel',
                deftfield       = '$deftfield',
                allowedtypes    = '$allowedtypes'
                where id        = '$id'"; 
    }       
        
    $query = new DB_query($DB, $q);
    
    unset($q);
    unset($query);
    
    return file_prefs($pb,$qresult);
}
// END


//	----------------------------------------------
//		FILE PREFERENCE DELETE CONFIRM
//	----------------------------------------------

function file_pref_delete_confirm($id,$pb=0)
{
    global $L_FILE, $sfx, $sx;
    
?>

<form method="post" action="<?php echo "index$sfx?sx=$sx&m=file_upload&p=delpref"; ?>">
<input type="hidden" name="id" value="<?php echo $id; ?>" />
<input type="hidden" name="pb" value="<?php echo $pb; ?>" />
<br />

<div align="center">

<table border="0" cellspacing="0" cellpadding="0" width="300">
<tr>
<td>
<br /><br />
<div class="text12">
<?php echo $L_FILE['310']; ?>
</div>
<br /><br />
<div align="center"><input type="submit" value=" <?php echo $L_FILE['305'] ?>" class="button"></div>
</form>
</div>
</td>
</tr>
</table>

</div>

<?php
}
// END



//	----------------------------------------------
//		FILE PREFERENCE DELETE
//	----------------------------------------------

function file_pref_delete($id,$pb=0)
{
    global $L_FILE, $db_upload_prefs, $sfx, $sx, $DB;

    $query = new DB_query($DB ,"delete from $db_upload_prefs where id = '$id'");
    
    return file_prefs($pb);

}
// END




//	----------------------------------------------
//		IMAGE BROWSER LISTING
//	----------------------------------------------

function image_browser_list($pb=0)
{
    global $db_upload_prefs, $L_FILE, $sfx, $sx, $DB;
?>

<br />

<div align="center">

<table border="0" cellspacing="0" cellpadding="0" width="300">
<tr>
<td colspan="3">

<br /><br />

<table cellpadding="0" cellspacing="0" border="0" width="100%">
<tr>
<td><div class="smlinkbluenb"><b><?php echo $L_FILE['355']; ?>&nbsp;&nbsp;</b></div></td>
</tr>
</table>

<hr size="1" color="#cccccc">
</td>

<?php
    
    $query = new DB_query($DB, "select id, refname from $db_upload_prefs order by name");
    
    while ($query->db_fetch_object())
    {
        $id = $query->obj->id;
        $refname = $query->obj->refname;        

?>
<tr><td><div class="text10"><?php echo $refname; ?></div></td>
<td align="right"><div class="smlinkblue"><a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=browse&id=$id&pb=$pb"; ?>"><?php echo $L_FILE['350']; ?></a></div></td>
</tr><tr><td colspan="2"><hr size="1" color="#cccccc"></td></tr>
<?php
    }
?>
</table>

</td>
</tr>
</table>

<br /><br /><br />

<a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=main&pb=$pb"; ?>">^ <?php echo $L_FILE['215']; ?></a>&nbsp;&nbsp;&nbsp;
</div>
<?php
}
// END



//	----------------------------------------------
//		IMAGE BROWSER LISTING
//	----------------------------------------------

function image_browser($id,$pb=0)
{
    global $db_upload_prefs, $L_ERROR, $L_FILE, $sfx, $sx, $DB;
    
    $query = new DB_query($DB, "select relpath from $db_upload_prefs where id = '$id' ");
    
    $query->db_fetch_object();
    
    $dir = $query->obj->relpath;
    
    $up = new FileUpload();
        

?>
<div align="center">
<br /><br />
<table cellspacing="0" cellpadding="0" border="0">
<tr>
<td bgcolor="#cccccc">
<table cellspacing="1" cellpadding="2" border="0" width="140">

<?php

    $filelist = array();

    if ($handle = @opendir($dir)) 
    { 
        while (false !== ($file = readdir($handle))) 
        { 
                $filelist[count($filelist)] = $file;
        } 
    } 
    else 
    {
?>
<tr>
<td bgcolor="#ffffff"><nobr><div class="text10">&nbsp;&nbsp;<?php echo "$L_ERROR[220]"; ?>&nbsp;&nbsp;</div></td>
</tr>
<?php
    }
        @closedir($handle); 
    
        sort($filelist);

    for ($i =0; $i < sizeof($filelist); $i++) 
    {

        if ((eregi('.gif$', $filelist[$i]))  ||
            (eregi('.jpg$', $filelist[$i]))  || 
            (eregi('.jpeg$',$filelist[$i]))  || 
            (eregi('.png$', $filelist[$i]))) 
        { 
                $size = @getimagesize("$dir$filelist[$i]");

                if (!(false === $size)) 
                {
                    $width  = $size[0];
                    $height = $size[1];
                }
?>
<tr>
<td bgcolor="#ffffff"><nobr><div class="smlinkblue">&nbsp;&nbsp;&nbsp;<a href="#" onclick="imageBrowser('<?php echo "$dir$filelist[$i]"; ?>','<?php echo "$width"; ?>','<?php echo "$height"; ?>')"><?php echo "$filelist[$i]"; ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</div></td>
<td bgcolor="#ffffff"><nobr><div class="smlinkgreen">&nbsp;&nbsp;&nbsp;<a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=addexisting&id=$id&pb=$pb&filetype=1&name=$filelist[$i]&path=$dir$filelist[$i]"; ?>"><?php echo $L_FILE['307']; ?></a>&nbsp;&nbsp;&nbsp;</div></td>
<td bgcolor="#ffffff"><nobr><div class="smlinkred">&nbsp;&nbsp;&nbsp;<a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=imgdelconf&id=$id&pb=$pb&path=$dir$filelist[$i]"; ?>"><?php echo $L_FILE['306']; ?></a>&nbsp;&nbsp;&nbsp;</div></td>

<?php echo "\r\n"; ?>
</tr>
<?php            
        }
        elseif (($filelist[$i] != ".") && (!eregi("^\..*", $filelist[$i]))) 
        {
            
            if ($filelist[$i] != "..") 

            {    
?>
<tr>
<td bgcolor="#ffffff"><nobr><div class="smlinkblue">&nbsp;&nbsp;&nbsp;<?php echo "$filelist[$i]"; ?>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</div></td>
<td bgcolor="#ffffff"><nobr><div class="smlinkgreen">&nbsp;&nbsp;&nbsp;<a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=addexisting&id=$id&pb=$pb&filetype=0&name=$filelist[$i]&path=$dir$filelist[$i]"; ?>"><?php echo $L_FILE['307']; ?></a>&nbsp;&nbsp;&nbsp;</div></td>
<td bgcolor="#ffffff"><nobr><div class="smlinkred">&nbsp;&nbsp;&nbsp;<a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=imgdelconf&id=$id&pb=$pb&path=$dir$filelist[$i]"; ?>"><?php echo $L_FILE['306']; ?></a>&nbsp;&nbsp;&nbsp;</div></td>

<?php echo "\r\n"; ?>
</tr>
<?php         
        }  
    }
 }
?>
</table>
</td>
</tr>
</table>

<br /><br /><br />

<a href="javascript:history.go(-1)">&lt;&nbsp;<?php echo $L_FILE['360']; ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=main&pb=$pb"; ?>">^ <?php echo $L_FILE['215']; ?></a>&nbsp;&nbsp;&nbsp;
</div>

<?php
}
// END




//	----------------------------------------------
//		IMAGE DELETE CONFIRM
//	----------------------------------------------

function image_delete_confirm($id,$pb,$path)
{
    global $L_FILE, $sfx, $sx;
    
?>
<form method="post" action="<?php echo "index$sfx?sx=$sx&m=file_upload&p=imgdel"; ?>">
<input type="hidden" name="id" value="<?php echo $id; ?>" />
<input type="hidden" name="pb" value="<?php echo $pb; ?>" />
<input type="hidden" name="path" value="<?php echo $path; ?>" />

<br /><br /><br />

<div align="center">

<table border="0" cellspacing="0" cellpadding="0" width="300">
<tr>
<td>
<br /><br />
<div class="text12">
<?php echo $L_FILE['365']; ?>
</div>
<br /><br />
<div align="center"><input type="submit" value=" <?php echo $L_FILE['305'] ?>" class="button"></div>
</form>
</div>
</td>
</tr>
</table>

<br /><br />

<a href="javascript:history.go(-1)">&lt;&nbsp;<?php echo $L_FILE['360']; ?></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="index<?php echo "$sfx?sx=$sx&m=file_upload&p=main&pb=$pb"; ?>">^ <?php echo $L_FILE['215']; ?></a>&nbsp;&nbsp;&nbsp;

</div>

<?php
}
// END



//	----------------------------------------------
//		ADD EXISTING FILE TO ENTRY
//	----------------------------------------------

function add_existing_file($pb, $id, $filetype, $name, $path, $imgfmt="")
{
    $add = new FileUpload();
        
    $add->good_upload_handler($pb, $id, $filetype, $name, $path, $imgfmt);
}
// END



//	----------------------------------------------
//		IMAGE DELETE
//	----------------------------------------------

function image_delete($id,$pb,$path)
{
    unlink ($path);

    return image_browser($id,$pb);
}
// END

?>