<?php
//
// pMachine Publishing Software
//
// Version 2.4 (Pro2.4.004)
//
// Copyright (c) 2003 - 2005 pMachine, Inc.
//
// THIS IS COPYRIGHTED SOFTWARE
//
// License holders may alter or modify this software for their own use, 
// but may NOT resell or redistribute the modified or derivative version 
// without prior written consent from pMachine.  Components from this 
// software may not be extracted and used in other programs without prior 
// written consent from pMachine.
//
// PLEASE READ THE LICENSE AGREEMENT
//




//	----------------------------------------------
//	 	XML - START ELEMENT
//	----------------------------------------------

function startElement($parser, $name, $attrs) 
{
	global $content, $tag, $title, $description, $link;

	    if ($content)
		    $tag = $name;
	elseif ($name == "ITEM")
		    $content = true;
}
// END


//	----------------------------------------------
//	 	XML - END ELEMENT
//	----------------------------------------------

function endElement($parser, $name) 
{
	global $rssTemplate,$content, $tag, $title, $description, $link;

    if ($name == "ITEM") 
    {
    	$title = strip_tags($title);
    	$link = strip_tags($link);
    	$description = strip_tags($description);
        $val = array($title,$link,$description);
        $var = array("%%title%%", "%%url%%", "%%description%%");
    
        echo stripslashes(str_replace($var,$val,$rssTemplate)); 
    
        $title = "";
        $description = "";
        $link = "";
        $content = false;
    }
}
// END


//	----------------------------------------------
//	 	XML - PARSE DATA
//	----------------------------------------------

function characterData($parser, $data) 
{
	global $content, $tag, $title, $description, $link;

	if ($content) 
    {
    	switch ($tag) 
        {
    		case "TITLE":
    		$title .= $data;
    		break;
    		case "DESCRIPTION":
    		$description .= $data;
    		break;
    		case "LINK":
    		$link .= $data;
    		break;
        }
	}
}
// END


//	----------------------------------------------
//	 	DISPLAY RSS PAGE/TEMPLATE
//	----------------------------------------------

function show_rss_page($template, $rsspage, $limit="")
{
	global $SHARED;
	
	if ($template == "") return false;
	if ($rsspage =="") return false;

	global $db_rss_templates, $DB;

	$query = new DB_query($DB, "select body from $db_rss_templates where name = '$template'");   
        
	if ($query->db_num_rows() ==0) return false;   
                    
	$query->db_fetch_array();
	$rsstempl = $query->row['body']; 
	
	global $rssTemplate; 
	$rssTemplate = $rsstempl;
	
	$content = false;
	$tag = "";
	$title = "";
	$description = "";
	$link = "";
	
	$xml_parser = xml_parser_create();
	xml_set_element_handler($xml_parser, "startElement", "endElement");
	xml_set_character_data_handler($xml_parser, "characterData");
	
	if (!$fp = fopen($rsspage,'rb')) 
	{
		// TEST PROXY SOLUTION
		
		$proxy_host = '0.0.0.0';
		$proxy_port = '0';
		$errno = '';
		$errstr = '';
		
		if ( ! $proxy_connect = @fsockopen($proxy_host, $proxy_port, $errno, $errstr,20))
		{
			@fclose;
			return false;
		}
		else
		{
			$r = "\r\n";
			$version  = "pMachine ";
			$version .= $SHARED->get_pref("version") . $SHARED->get_pref("vnumber");
			
			$bits = parse_url($rsspage);
			
			if ( ! isset($bits['path'])) 
			{	
				return false;
			}
			
			$host = $bits['host'];
			$path = ( ! isset($bits['path'])) ? '' : $bits['path'];
			
			$request  = "GET $path HTTP/1.1{$r}";
			$request .= "Host: $host{$r}";
			$request .= "User-Agent: $version PHP/" . phpversion() . "{$r}{$r}";

			fputs($proxy_connect,$request);
			$data = "";
			$getting_headers = true;
			while (!feof($proxy_connect))
			{
				$line = fgets($proxy_connect, 4096);
				
				if ($getting_headers == false)
				{
					$data .= $line;
				}
				elseif (trim($line) == '')
				{
					$getting_headers = false;
				}
			}
		
		}
	}
	else
	{
		set_magic_quotes_runtime(0);
	
		$data = "";
		do {
			$content = fread($fp, 8192);
			if (strlen($content) == 0) break;
			$data .= $content;
		} while(true);
	
		fclose ($fp);
	}

    if ($limit <> "") 
    {
		$head   = strpos($data, "<item>");
		$chunk  = substr($data, 0, $head);
		$start  = strpos($data, "<item>");
		$length = ((strpos($data,"</item>") + strlen('</item>') - $start));

        for($x=0; $x < $limit; $x++) 
        {
            $chunk .= substr($data, $start, $length); 
            $data = substr( $data,(strpos($data,"</item>") + strlen('</item>')));
            $start = strpos($data, "<item>");
            $length = ((strpos($data,"</item>") + strlen('</item>') - $start));
    	}
    		
		$chunk .= "</channel></rss>";
	
		$data = $chunk;
    }

	xml_parse($xml_parser, $data);
	xml_parser_free($xml_parser);
}
// END



//	----------------------------------------------
//	 	NEW RSS TEMPLATE FORM
//	----------------------------------------------

function new_rss_template_form($name="",$id="") 
{
	global $L_RSS, $sx, $sfx, $SHARED;

    if (substr($SHARED->get_pref($GLOBALS['pmb']),0,1) <1)
        return FALSE;
    if (strtolower(substr($SHARED->get_pref($GLOBALS['pmv']),0,1)) 
    	=== substr($GLOBALS['pmf'],0,1))
        return FALSE;
?>
<form method="post" action="<?php echo "index$sfx?sx=$sx&m=admin&p=newrsstemplate"; ?>" name="rss_templates">
<input type="hidden" name="id" value="<?php echo "$id"; ?>">

<br />

<table border="0" cellspacing="0" cellpadding="1">
<tr>
<td bgcolor="#cccccc">

<table border="0" cellspacing="0" cellpadding="5">
<tr>
<td align="right" bgcolor="#ffffff"><div class="text10"><b><?php echo "$L_RSS[100]"; ?></b></div></td>
<td align="left"  bgcolor="#ffffff"><input type="text" name="name" class="box150" maxlength="100" value="<?php echo stripslashes($name); ?>"  ></td>
</tr>
</table>

</td>
</tr>
</table>

<br />

<input class="button" type="submit" value=" <?php echo "$L_RSS[105]"; ?> "> 

</form>
<?php
}
// END




//	----------------------------------------------
//	 	GET RSS TEMPLATE NAMES 
//	----------------------------------------------

function get_rss_template_names($id="") 
{	
	global $db_rss_templates, $L_RSS, $sx, $sfx, $DB;
            
	$query = new DB_query($DB, "select id, name from $db_rss_templates order by name");
     
	if ($query->db_num_rows() == 0) 
	{ 
?>   
<div class="text10"><?php echo "$L_RSS[110]"; ?></div>
<?php      
	}
	else 
	{  
?>
<hr size="1" width="260" align="left" color="#cccccc">

<table border="0" cellspacing="0" cellpadding="0" width="260">
<tr>
<td><div class="text10"><b><?php echo "$L_RSS[115]"; ?></b></div></td><td align="center"><div class="text10"><b><?php echo "$L_RSS[120]"; ?></b></div></td><td align="right"><div class="text10"><b><?php echo "$L_RSS[125]"; ?> &nbsp;</b></div></td></tr>

<?php                 

	while ($query->db_fetch_array())
	{
?>
<tr><td colspan="3"><hr size="1" color="#cccccc"></td></tr>
<tr><td><div class="text9"><?php echo stripslashes($query->row['name']); ?></div></td><td align="center"><div class="smlink"><a href="<?php echo "index$sfx?sx=$sx&m=admin&p=edit_rss_template&id=".$query->row['id']; ?>"><b><?php echo "$L_RSS[120]"; ?></b></a></div></td><td align="right"><div class="smlink"><a href="<?php echo "index$sfx?sx=$sx&m=admin&p=delconf_rss_template&id=".$query->row['id']; ?>"><b><?php echo "$L_RSS[125]"; ?></b></a> &nbsp; </div></td></tr>	
<?php

	}
?>
</table>
</div>
<?php 
   }
}
// END




//	----------------------------------------------
//	 	ADD A NEW XML TEMPLATE
//	----------------------------------------------

function add_news_rss_template($name) 
{	
	global $db_rss_templates, $L_RSS, $DB, $SHARED;

    if (substr($SHARED->get_pref($GLOBALS['pmb']),0,1) <1)
        return FALSE;
    if (strtolower(substr($SHARED->get_pref($GLOBALS['pmv']),0,1)) 
    	=== substr($GLOBALS['pmf'],0,1))
        return FALSE;

  if ($name == "") 
  {
        new_rss_template_form($name);
        get_rss_template_names();
  }
  else 
  {

  $name = trim(strip_tags($name));
	
	$query = new DB_query($DB, "select count(*) as count from $db_rss_templates where name ='".trim(addslashes($name))."'");
	$query->db_fetch_array();

    if ($query->row['count'] > 0)
    {
        echo error_message("$L_RSS[130]");
        new_rss_template_form($name);
        get_rss_template_names();
    }
    else 
    {
		$body = "<a href=\"%%url%%\">%%title%%</a>\n\r<br />\n\r%%description%%\n\r<br /><br />";

		$query = new DB_query($DB, "insert into $db_rss_templates (id, name,body) values ('','".trim(addslashes($name))."','$body')");                                                     

		
		new_rss_template_form();
		get_rss_template_names();
    }
   }
  }  
// END



//	----------------------------------------------
//	 	XML TEMPLATE DELETE CONFIRM 
//	----------------------------------------------

function delete_contirm_rss_template($id) 
{
	global $L_RSS, $sx, $sfx;	
?>
<br />
<form method="post" action="<?php echo "index$sfx?sx=$sx&m=admin&p=del_rss_template&id=$id"; ?>">
<input type="hidden" name="id" value="<?php echo "$id"; ?>" >
<div class="text11red"><b><nobr><?php echo "$L_RSS[135]"; ?></b></div>
<br /><br />
<input type="submit" value=" <?php echo "$L_RSS[140]"; ?> " class="button">
</form>
<?php	
}
// END




//	----------------------------------------------
//	 	DELETE XML TEMPLATE
//	----------------------------------------------

function delete_rss_template($id) 
{	
	global $db_rss_templates, $DB;
 
	if ($id != '') 
	{		                       
		$query = new DB_query($DB, "delete from $db_rss_templates where id = '$id'");
	}    
     
	new_rss_template_form();
	get_rss_template_names();
}
// END





//	----------------------------------------------
//	 	XML TEMPLATE EDIT FORM
//	----------------------------------------------

function edit_rss_template_form($id,$name="",$body="") 
{
	global $db_rss_templates, $L_RSS, $sx, $sfx, $DB;
                      
	$query = new DB_query($DB, "select name, body from $db_rss_templates where id = '$id'");
	$query->db_fetch_array();
	
	$name = $query->row['name'];
	$body = $query->row['body'];

    if(get_magic_quotes_runtime())
    {
		$name = stripslashes($name);
		$body = stripslashes($body);
    }
?>
<form name="box" method="post" action="<?php echo "index$sfx?sx=$sx&m=admin&p=update_rss_template"; ?>">
<input type="hidden" name="id" value="<?php echo "$id"; ?>" >

<br />

<table cellspacing="0" cellpadding="2" border="0" >
<tr>
<td>
<div class="text10"><b><?php echo "$L_RSS[145]"; ?></b></div>
<input type="text" name="name" class="box250" maxlength="60" value="<?php echo $name; ?>"  ></td>

</tr><tr>

<td bgcolor="#ffffff" colspan="3"><div class="text10"><b><?php echo "$L_RSS[150]"; ?></b><br /></div>
<textarea name="body"  class="textarea" rows="12" cols="<?php echo "$GLOBALS[t_area_one]"; ?>" wrap="virtual"  ><?php echo "$body"; ?></textarea></td>
</tr>
</table>

<br />

<input type="submit" value=" <?php echo "$L_RSS[165]"; ?> " class="button">

</form>

<div class="text10"><b><?php echo "$L_RSS[155]"; ?></b></div>
<div class="text11">
%%title%%<br />
%%url%%<br />
%%description%%</div>

<?php
}
// END



//	----------------------------------------------
//	 	UPDATE XML TEMPLATE
//	----------------------------------------------

function update_rss_template_form($id,$name,$body) 
{
	global $db_rss_templates, $L_RSS, $DB;
 
	if ($name == "")
	{    
		error_message("Name is required");
		edit_rss_template_form($id,$name,$body,1);
		end_content_wrapper();
		footer();  
		exit;
	}
    
    $name = trim(strip_tags($name));

    if(!get_magic_quotes_gpc()) 
    {
        $name = addslashes($name);
        $body = addslashes($body);
    }

	$query = new DB_query($DB, "update $db_rss_templates set name = '$name', body = '$body' where id = '$id'");                 

 	echo "<div class=\"text11green\"><br /> &nbsp;<b>$L_RSS[160]</b></div>";
  
	new_rss_template_form();
	get_rss_template_names(); 
}
// END
?>