<?php
//
// pMachine Publishing Software
//
// Version 2.4 (Pro2.4.004)
//
// Copyright (c) 2003 - 2005 pMachine, Inc.
//
// THIS IS COPYRIGHTED SOFTWARE
//
// License holders may alter or modify this software for their own use, 
// but may NOT resell or redistribute the modified or derivative version 
// without prior written consent from pMachine.  Components from this 
// software may not be extracted and used in other programs without prior 
// written consent from pMachine.
//
// PLEASE READ THE LICENSE AGREEMENT
//

    
$extarray = array('.php', '.php4', '.php3', '.php5');

if ( ! in_array($sfx, $extarray))
{
	exit;
}

if ( ! file_exists("config$sfx"))
{
	exit;
}

include ("config$sfx");

if ($debug == '1')
{
	error_reporting(E_ALL);
}
else
{
	error_reporting(E_ALL ^ E_NOTICE ^ E_WARNING);
}

//	----------------------------------------------
//		SECURITY FILE INCLUDE
//	----------------------------------------------

include ("./lib/security.fns$sfx");

$SECURE = new Security();

//	----------------------------------------------
//		REGISTER GLOBALS OFF
//	----------------------------------------------

if (is_array($_COOKIE) AND count($_COOKIE) > 0)
{
	foreach($_COOKIE as $var => $val)
    {
    	$var = $SECURE->sanitize_keys($var);
        $_COOKIE[$var] = $SECURE->xss_clean($val);
        $$var = $val;
    }
}

if (is_array($_GET) AND count($_GET) > 0)
{
	foreach($_GET as $var => $val)
    {
    	$var = $SECURE->sanitize_keys($var);
    	$_GET[$var] = $SECURE->sanitize_get($val);
    	$_GET[$var] = $SECURE->xss_clean($val);
    	
    	// --------------------------------------------
		//  No Single Quotes in GET unless Bookmarklet
		//  SQL Injection Protection, Mr. Vextion
		// --------------------------------------------
    	
    	if ( ! isset($_GET['m']) OR $_GET['m'] != "bookmarklet")
		{
			$val = str_replace('%27', '', $val);
    		$val = str_replace("'", '', $val);
    	}
    	
        $$var = $val;
    }
}

if (is_array($_POST) AND count($_POST) > 0)
{
	foreach($_POST as $var => $val)
    {
    	$var = $SECURE->sanitize_keys($var);
    	
    	if (is_array($val))
    	{
    		$nval = array();
    		foreach($val as $k => $v)
    		{
    			$k = $SECURE->sanitize_keys($k);
        		$nval[$k] = $v;
    		}
    		
    		$$var = $nval;
    	}
        else
        {
        	$$var = $val;
        }
    }
}

if (is_array($_SERVER) AND count($_SERVER) > 0)
{
	foreach($_SERVER as $var => $val)
    {
        $_SERVER[$var] = $SECURE->xss_clean($val);
        $$var = $val;
    }
}

// END



//	----------------------------------------------
//		LANGUAGE COOKIE
//	----------------------------------------------

if (isset($pmlanguage)) 
{
	$language = $pmlanguage;
}        
// END

unset($sx);

// ------------------------------------
//  Start Up Database
// ------------------------------------

include ("./db/db.$database$sfx");
include ("./db/db.tables$sfx");

$DB = new DB();

// --------------------------------------
//  Shared Functions and Shared Caching
// --------------------------------------

include ("./lib/shared.fns$sfx");

$SHARED = new Shared();

// ----------------------------------------------
//  Master Includes
// ----------------------------------------------

include ("./cp/access.cp$sfx");
include ("./cp/bookmarklet.cp$sfx");
include ("./cp/calendar.cp$sfx");
include ("./cp/categories.cp$sfx");
include ("./cp/comments.cp$sfx");
include ("./cp/filebrowser.cp$sfx");
include ("./cp/resetpw.cp$sfx");
include ("./cp/global.vis.cp$sfx");
include ("./cp/global.vars.cp$sfx");
include ("./cp/ipbanning.cp$sfx");
include ("./cp/language.cp$sfx");
include ("./cp/login.cp$sfx");
include ("./cp/logout.cp$sfx");
include ("./cp/fileupload.cp$sfx");
include ("./cp/mailinglist.cp$sfx");
include ("./cp/minicalendar.cp$sfx");
include ("./cp/members.cp$sfx");
include ("./cp/postoffice.cp$sfx");
include ("./cp/preferences.cp$sfx");
include ("./cp/pblocks.cp$sfx");
include ("./cp/rss.cp$sfx");
include ("./cp/rss.class$sfx");
include ("./cp/stats.cp$sfx");
include ("./cp/search.cp$sfx");
include ("./cp/tagarray.cp$sfx");
include ("./cp/trackback.cp$sfx");
include ("./cp/templates.cp$sfx");
include ("./cp/weblog.cp$sfx");

// Pro only includes
include ("./cp/events.cp$sfx");
include ("./cp/multiweblogs.cp$sfx");
include ("./cp/multitemplates.cp$sfx");
include ("./cp/xmlparser$sfx");
include ("./cp/blacklist.cp$sfx");

// xmlrpc includes
include ("./xmlrpc/ping.fns$sfx");
include ("./xmlrpc/xmlrpc.inc");
include ("./xmlrpc/xmlrpcs.inc");

// Lib includes

include ("./lib/email.class$sfx");
include ("./lib/ip.fns$sfx");
include ("./lib/encoded.email$sfx");
include ("./lib/birthday.fns$sfx");
include ("./lib/pmcode.fns$sfx");
include ("./lib/memberfiles$sfx");
include ("./lib/password.fns$sfx");
include ("./lib/deprecated.fns$sfx");
include ("./lib/mailfiles$sfx");

$pmb = "build";
$pmv = "version";
$pmf = "function"; 
?>