<?php

//	MEMBER MESSAGES
//
// This file contains the messages that appear in
// the "messages.php" page (members directory) 
//
// Please edit these messages carefully!
//


//	----------------------------------------------
//		"BACK" LINK DEFENITION
//	----------------------------------------------

// Most of these messages include a "BACK" link so that visitors can return to
// where they were.  This variable defines that link.  By default we use
// JavaScript "history go(-1)" since there are any number of page the person
// might have come from and it saves us from having to create many different
// links.  If you change this, don't forget to escape the quotes.

 $backlink = "<br /><br /><a href=\"javascript:history.go(-1)\" >BACK</a>"; 
 

//	----------------------------------------------
//		HOME PAGE LINK DEFENITION
//	----------------------------------------------

// Some of the messages have a static link to the home page using the site name 
// you defined in the control panel preferences.  You can, of course, place
// a different link here, or even use an image.  Don't forget to escape quotes.

 $homelink = "<br /><br /><a href=\"$site_url\">$site_name</a>";  
 
 
 //	----------------------------------------------
//		COMMENT LINK DEFENITION
//	----------------------------------------------

// One of the messages has a dynamic link to the comment page for the submitted
// comment.  You can, of course, place a different link here though.

 $comment_link = "<br /><br /><a href=\"$i\">Return to Comments</a>";  
 


//	----------------------------------------------
//	    LOGIN MESSAGES
//	----------------------------------------------

$L_MESSAGE['01'] = "Your account is not currently active.";
$L_MESSAGE['02'] = "The username and/or password you submitted are not correct. $backlink";
$L_MESSAGE['03'] = "Your account has not been activated yet.<br /><br />Click <a href=\"$activatepage$sfx\">here</a> to receive activation instructions.";
$L_MESSAGE['04'] = "You are now logged in. $homelink";

//	----------------------------------------------
//	    LOGOUT MESSAGE
//	----------------------------------------------

$L_MESSAGE['10'] = "You are now logged out. $GLOBALS[homelink]";

//	----------------------------------------------
//	    PASSWORD RESET MESSAGES
//	----------------------------------------------

$L_MESSAGE['20'] = "You must submit a valid email address. $backlink";
$L_MESSAGE['21'] = "Instructions for resetting your password have been emailed to you. $homelink";
$L_MESSAGE['22'] = "The email address you submitted is not in the database. $backlink";
$L_MESSAGE['23'] = "Your password has been reset and you have been emailed the new password. $homelink";
$L_MESSAGE['24'] = "Your new password request has expired.  Please resubmit a new request. $homelink";
$L_MESSAGE['25'] = "This ID number is not valid.  Please consult the email you were sent for instructions on resetting your password. $homelink";
$L_MESSAGE['26'] = "A problem was encountered while emailing your new password. $homelink";

//	----------------------------------------------
//	    MEMBER REGISTRATION - PROFILE EDITING 
//	---------------------------------------------- 

$L_MESSAGE['27'] = "You must submit a username. $backlink";
$L_MESSAGE['28'] = "You must submit a password and a password confirmation. $backlink";
$L_MESSAGE['29'] = "You must submit a name to post with. $backlink";
$L_MESSAGE['30'] = "You could not be registered at this time.<br /><br />If the problem persists; contact the system administrator.";
$L_MESSAGE['31'] = "You left some of the form fields empty. $backlink";
$L_MESSAGE['32'] = "Username must be at least $un_min_length characters long. $backlink";
$L_MESSAGE['33'] = "Password must be at least $pw_min_length characters long. $backlink";
$L_MESSAGE['34'] = "Passwords do not match. $backlink";
$L_MESSAGE['35'] = "Email address is required. $backlink";
$L_MESSAGE['36'] = "The email address you submitted is not valid. $backlink";
$L_MESSAGE['37'] = "You must include both the month and day when submitting your birthday. $backlink";
$L_MESSAGE['38'] = "Your birthday must be submitted in numeric format. ie: 06 21 1972. $backlink";
$L_MESSAGE['39'] = "The birth day you submitted is not a valid. $backlink";
$L_MESSAGE['40'] = "The birth month you submitted is not a valid. $backlink";
$L_MESSAGE['41'] = "It's not likely that you were born in $i. $backlink";
$L_MESSAGE['43'] = "Your registration is complete!<br /><br />You have just been sent an email with instructions for activating your account.<br /><br />Once you follow those instructions you will be able to log-in and post messages. $homelink";
$L_MESSAGE['44'] = "This email address is already registered. $backlink";
$L_MESSAGE['45'] = "The username you've chosen is already taken. $backlink";
$L_MESSAGE['46'] = "The name you've chosen to post with is already taken. $backlink";
$L_MESSAGE['47'] = "Your registration is complete and you are now logged in! $homelink";
$L_MESSAGE['48'] = "Your username must contain only alpha-numeric characters and no spaces. $backlink";
$L_MESSAGE['49'] = "Your password must contain only alpha-numeric characters and no spaces. $backlink";

//	----------------------------------------------
//	    ERROR MESSAGE FOR LOGGED OUT USERS
//	----------------------------------------------

$L_MESSAGE['55'] = "You must be logged-in to access this page.";

//	----------------------------------------------
//	   SECURITY MESSAGES 
//	----------------------------------------------

$L_MESSAGE['60'] = "Invalid page request.";
$L_MESSAGE['65'] = "You must be logged-in to access this page.";

//	----------------------------------------------
//	    ACCOUNT ACTIVATION MESSAGES
//	----------------------------------------------

$L_MESSAGE['70'] = "The URL did not contain a valid ID number.<br /><br />Please consult your email messages for the full URL. $homelink";
$L_MESSAGE['71'] = "Your account is currently active. $homelink";
$L_MESSAGE['72'] = "Your account could not be activated at this time. $homelink";
$L_MESSAGE['73'] = "Your account is now active. $homelink";

// NEW
$L_MESSAGE['74'] = "A site administrator will activate your account and notify you when it is ready for use.";

//	----------------------------------------------
//	    ACCOUNT ACTIVATION - REQUEST INSTRUCTIOINS
//	----------------------------------------------

$L_MESSAGE['80'] = "You did not submit a valid email address. $backlink";
$L_MESSAGE['81'] = "The email address you submitted is not in our database. $backlink";
$L_MESSAGE['82'] = "Account activation instructions have been emailed to you. $homelink";

//	----------------------------------------------
//	    COMMENT ERROR MESSAGES
//	----------------------------------------------

$L_MESSAGE['90'] = "Your comment could not be posted at this time. $homelink";
$L_MESSAGE['91'] = "You left some form fields empty. $backlink";
$L_MESSAGE['92'] = "You must submit the form with a comment. $backlink";
$L_MESSAGE['93'] = "You must be registered and logged-in to post. $backlink";
$L_MESSAGE['94'] = "You must include your email address. $backlink";
$L_MESSAGE['95'] = "The email address you submitted is not valid. $backlink";
$L_MESSAGE['96'] = "The maximum allowed number of characters in a comment is: $i <br /><br />Your entry contains $e characters. $backlink";
$L_MESSAGE['97'] = "Sorry, we require $i second(s) between comments. $backlink";
$L_MESSAGE['98'] = "Sorry, this entry is no longer accepting new comments. $backlink";

//	----------------------------------------------
//	    EMAIL RELATED MESSAGES
//	----------------------------------------------

$L_MESSAGE['105'] = "You left some of the form fields empty $backlink";
$L_MESSAGE['106'] = "Your email has been sent. $homelink";
$L_MESSAGE['107'] = "A problem was encountered while trying to send your email. $homelink";
$L_MESSAGE['108'] = "You must submit a valid email address. $backlink";
$L_MESSAGE['109'] = "This member does not wish to receive email.";

//	----------------------------------------------
//	   ERROR: NO PROFILE EXISTS MESSAGE 
//	----------------------------------------------

$L_MESSAGE['112'] = "Only members can have profiles.";

//	----------------------------------------------
//	    MAILING LIST MESSAGES
//	----------------------------------------------

$L_MESSAGE['115'] = "You must submit a valid email address. $backlink";
$L_MESSAGE['116'] = "The email address you submitted was already in the database. $backlink";
$L_MESSAGE['117'] = "Your email address has been added to the mailing list. $homelink";
$L_MESSAGE['118'] = "Your email address has been removed from our mailing list database. $homelink";
$L_MESSAGE['119'] = "Your email address was not found in the database. $homelink";
$L_MESSAGE['120'] = "There was a problem trying to add/remove you from the mailing list(s). $homelink";
$L_MESSAGE['121'] = "Your email address has been removed from this notification list. $homelink";


//	----------------------------------------------
//	    LOGGED IN MEMBER TRIES TO REGISTER
//	----------------------------------------------

$L_MESSAGE['125'] = "You are already a registered member.<br /><br />You must log-out in order to register a new member.";

//	----------------------------------------------
//	    COLLECTIVE WEBLOG MESSAGES
//	----------------------------------------------

$L_MESSAGE['130'] = "This weblog does not accept public submissions.";
$L_MESSAGE['131'] = "Your entry could not be posted at this time.";
$L_MESSAGE['132'] = "The maximum allowed number of characters in an entry is: $i<br /><br />Your entry contains $e characters. $backlink";
$L_MESSAGE['133'] = "You left some form fields empty. $backlink";
$L_MESSAGE['134'] = "You must include your email address. $backlink";
$L_MESSAGE['135'] = "You must submit a valid email address. $backlink";
$L_MESSAGE['136'] = "You must be registered and logged-in to post. $backlink";
$L_MESSAGE['137'] = "Your entry could not be posted at this time.";
$L_MESSAGE['138'] = "Sorry, we require $i second(s) between entries. $backlink";
$L_MESSAGE['139'] = "The administrator has not enabled this page.";
$L_MESSAGE['140'] = "Thank you for your submission.  A moderator will review it for inclusion. $homelink";


//	----------------------------------------------
//	    TRACKBACK MESSAGES
//	----------------------------------------------

$L_MESSAGE['145'] = "The trackback has been deleted . $backlink";
$L_MESSAGE['146'] = "No trackbacks exist for this entry.";
$L_MESSAGE['147'] = "No pingbacks exist for this entry.";
$L_MESSAGE['148'] = "The pingback has been deleted. $backlink";

//	----------------------------------------------
//	    ADDITIONAL MAILING LIST MESSAGES
//	----------------------------------------------

$L_MESSAGE['150'] = "Your email address is already subscribed to this mailing list. $homelink";
$L_MESSAGE['151'] = "Your email address is not subscribed to this mailing list. $homelink";
$L_MESSAGE['152'] = "Your email address has been removed from this mailing list. $homelink";
$L_MESSAGE['153'] = "Your email address is already subscribed to this mailing list. $homelink";
$L_MESSAGE['154'] = "Your email address is not subscribed to this mailing list. $homelink";
$L_MESSAGE['155'] = "No mailing list specfied. $backlink";
$L_MESSAGE['156'] = "Not a publicly available mailing list. $homelink";
$L_MESSAGE['157'] = "Your email has been sent. $homelink";
$L_MESSAGE['158'] = "A problem was encountered while trying to send your email. $homelink";
$L_MESSAGE['159'] = "No Mailings Found";
$L_MESSAGE['160'] = "No mailing lists available for subscription. $homelink";
$L_MESSAGE['161'] = "Your mailing list subscriptions have been modified. $homelink";
$L_MESSAGE['162'] = "Your mailing list subscriptions have been created. $homelink";

//	----------------------------------------------
//	 Security Messages
//	----------------------------------------------

// NEW
$L_MESSAGE['163'] = "Invalid Captcha Value $backlink";
$L_MESSAGE['164'] = "New Member Registrations are not currently permitted.";
$L_MESSAGE['165'] = "Your Submission Was Blacklisted.  Contact the Administrator.";
$L_MESSAGE['166'] = "Your Comment will be reviewed by a moderator for approval. $comment_link";

?>