<?php
//
// pMachine Publishing Software
//
// Version 2.4 (Pro2.4.004)
//
// Copyright (c) 2003 - 2005 pMachine, Inc.
//
// THIS IS COPYRIGHTED SOFTWARE
//
// License holders may alter or modify this software for their own use, 
// but may NOT resell or redistribute the modified or derivative version 
// without prior written consent from pMachine.  Components from this 
// software may not be extracted and used in other programs without prior 
// written consent from pMachine.
//
// PLEASE READ THE LICENSE AGREEMENT
//


//	---------------------------------------------
//	 MIXED CALENDAR - BIRTHDAYS AND EVENT LINKS
//	---------------------------------------------

function mixed_calendar($year=0, $month=0, $calpref="") 
{

    calendar_body("mixed", $year, $month, "yes", $calpref);

}
// END

//	---------------------------------------------
//	 BIRTHDAY CALENDAR ONLY
//	---------------------------------------------

function birthday_calendar($year=0, $month=0, $calpref="") 
{

    calendar_body("bday", $year, $month, "yes", $calpref);

}
// END


//	---------------------------------------------
//	 EVENT CALENDAR ONLY - EVENTS AS LIST
//	---------------------------------------------

function event_list_calendar($year=0, $month=0, $calpref="") 
{

    calendar_body("eventlist", $year, $month, "no", $calpref); 

}
// END


//	---------------------------------------------
//	 EVENT CALENDAR ONLY - EVENTS AS LINKS
//	---------------------------------------------

function event_link_calendar($year=0, $month=0, $calpref="") 
{

    calendar_body("eventlink", $year, $month, "no", $calpref);

}
// END


//	---------------------------------------------
//		MAIN BODY OF THE FULL-SIZED CALENDAR
//	---------------------------------------------

function calendar_body($type="mixed", $year=0, $month=0, $showbdays="yes", $calpref="") 
{
    global $calendarpage, $language, $pm_path, $member_code;
    global $member_name, $db_members, $sfx, $DB, $SHARED;
    
    if ($SHARED->get_pref("public_calendar") == "private") 
    {
        if ((!$member_code) && (!$member_name)) 
        {
            return member_messages(55);
        }
        else 
        {

        $sql = "select count(*) as count
                from $db_members 
                where member_id = '".addslashes($member_code)."' 
                and username = '".addslashes($member_name)."'";
            
        $query = new DB_query($DB, $sql);
        $query->db_fetch_object();
        $total = $query->obj->count;

        if ($total == 0)
            return member_messages(55);
        }
    }

    $newtime = $SHARED->get_offset_time();  
    
    $today   = date("d", $newtime);
    $tomonth = date("m", $newtime);
    $toyear  = date("Y", $newtime); 

    if ($month == 0) $month = date("m", $newtime);
    if ($year == 0 ) $year  = date("Y", $newtime);

    if (strlen($month) == 1) $month = "0{$month}";
    if (strlen($year) == 2 ) $year  = "20{$year}";

    $prev_month = date("m", mktime(0,0,0,$month -1, 1, $year));
    $next_month = date("m", mktime(0,0,0,$month +1, 1, $year));
    $prev_year  = date("Y", mktime(0,0,0,$month -1, 1, $year));
    $next_year  = date("Y", mktime(0,0,0,$month +1, 1, $year));
    $week_day = 1-date("w", mktime(0,0,0,$month, 1, $year));
    $mthdays    = date("t", mktime(0,0,0,$month, 1, $year));
    $title      = date("F", mktime(0,0,0,$month, 1, $year));
  
    include ("{$pm_path}language/{$language}/main{$sfx}");

    $memdir = $SHARED->get_pref("memdir","1");
    
	(is_array($calpref) AND isset($calpref['path'])) ? 
		$calpath = $calpref['path'] : $calpath  = $SHARED->get_pref("calendar_path_abs");
           
    $prev = "{$calpath}?year={$prev_year}&month=$prev_month";
    $next = "{$calpath}?year={$next_year}&month=$next_month";

    switch($title)
    {
        case "January"  : $title = "$L_CALENDAR[300]";
        break;
        case "February" : $title = "$L_CALENDAR[301]";
        break;
        case "March"    : $title = "$L_CALENDAR[302]";
        break;
        case "April"    : $title = "$L_CALENDAR[303]";
        break;
        case "May"      : $title = "$L_CALENDAR[304]";
        break;
        case "June"     : $title = "$L_CALENDAR[305]";

        break;
        case "July"     : $title = "$L_CALENDAR[306]";
        break;
        case "August"   : $title = "$L_CALENDAR[307]";
        break;
        case "September": $title = "$L_CALENDAR[308]";
        break;
        case "October"  : $title = "$L_CALENDAR[309]";
        break;
        case "November" : $title = "$L_CALENDAR[310]";
        break;
        case "December" : $title = "$L_CALENDAR[311]";
        break;
    } 

	 
         
	(is_array($calpref) AND isset($calpref['cell_width'])) ? $cell_width = $calpref['cell_width'] : $cell_width  = $SHARED->get_pref("cell_width");

	(is_array($calpref) AND isset($calpref['cell_height'])) ? $cell_height = $calpref['cell_height'] : $cell_height  = $SHARED->get_pref("cell_height");

	(is_array($calpref) AND isset($calpref['header_bg'])) ? $header_bg = $calpref['header_bg'] : $header_bg  = $SHARED->get_pref("header_bg");

	(is_array($calpref) AND isset($calpref['weekday_bg'])) ? $day_bg = $calpref['weekday_bg'] : $day_bg  = $SHARED->get_pref("day_bg");

	(is_array($calpref) AND isset($calpref['cell_border'])) ? $cell_border = $calpref['cell_border'] : $cell_border  = $SHARED->get_pref("cell_border");

	(is_array($calpref) AND isset($calpref['cell_bg'])) ? $cell_bg = $calpref['cell_bg'] : $cell_bg  = $SHARED->get_pref("cell_bg");

	(is_array($calpref) AND isset($calpref['today_bg'])) ? $today_bg = $calpref['today_bg'] : $today_bg  = $SHARED->get_pref("today_bg");



    $calparams = array();
    
    $calparams['type']      = $type;
    $calparams['year']      = $year;
    $calparams['month']     = $month;
    $calparams['week_day']  = $week_day;
    $calparams['today']     = $today;
    $calparams['tomonth']   = $tomonth;
    $calparams['toyear']    = $toyear;
    $calparams['memdir']    = $memdir;
    $calparams['showbdays'] = $showbdays;

?>
<form method="get" action="<?php echo "$calpath"; ?>" >
<table border="0" cellpadding="0" cellspacing="0">
<tr>
<td style='text-align: center'>
<table bgcolor="<?php echo "$header_bg"; ?>" style='text-align: center' border="0" cellpadding="0" cellspacing="0" width="100%">
<tr>
<td height="15" align="left"><div class="navlinks">&nbsp;<a href="<?php echo "$prev"; ?>">&lt;&lt;</a></div></td>
<td style='text-align: center'><div class="header"><?php echo"$title $year" ?></div></td>
<td style='text-align: right'><div class="navlinks"><a href="<?php echo "$next"; ?>">&gt;&gt;</a>&nbsp;</div></td>
</tr>
</table>
</td>
</tr><tr>
<td bgcolor="<?php echo "$cell_border"; ?>">
<table border="0" cellpadding="4" cellspacing="1">
<tr>
<th bgcolor="<?php echo "$day_bg"; ?>" style='text-align: center' width="<?php echo "$cell_width"; ?>"><div class="weekdays"><?php echo "$L_CALENDAR[100]"; ?></div></th>
<th bgcolor="<?php echo "$day_bg"; ?>" style='text-align: center' width="<?php echo "$cell_width"; ?>"><div class="weekdays"><?php echo "$L_CALENDAR[105]"; ?></div></th>
<th bgcolor="<?php echo "$day_bg"; ?>" style='text-align: center' width="<?php echo "$cell_width"; ?>"><div class="weekdays"><?php echo "$L_CALENDAR[110]"; ?></div></th>
<th bgcolor="<?php echo "$day_bg"; ?>" style='text-align: center' width="<?php echo "$cell_width"; ?>"><div class="weekdays"><?php echo "$L_CALENDAR[115]"; ?></div></th>
<th bgcolor="<?php echo "$day_bg"; ?>" style='text-align: center' width="<?php echo "$cell_width"; ?>"><div class="weekdays"><?php echo "$L_CALENDAR[120]"; ?></div></th>
<th bgcolor="<?php echo "$day_bg"; ?>" style='text-align: center' width="<?php echo "$cell_width"; ?>"><div class="weekdays"><?php echo "$L_CALENDAR[125]"; ?></div></th>
<th bgcolor="<?php echo "$day_bg"; ?>" style='text-align: center' width="<?php echo "$cell_width"; ?>"><div class="weekdays"><?php echo "$L_CALENDAR[130]"; ?></div></th>
</tr>
<?php
while($week_day <= $mthdays) 
{
echo "<tr>\n";
for ($j=1; $j<=7; $j++)
{
if (($week_day == $today) && ($month == $tomonth) && ($year == $toyear)) 
{
    $calparams['week_day'] = $week_day;

?><td bgcolor="<?php echo "$today_bg"; ?>" height="<?php echo "$cell_height"; ?>" width="<?php echo "$cell_width"; ?>" valign="top">
<?php echo(($week_day <= $mthdays && $week_day > 0 ) ? get_events($calparams): "&nbsp;"); ?></td>
<?php       
}    
else 
{       
    $calparams['week_day'] = $week_day;

?><td bgcolor="<?php echo "$cell_bg"; ?>" height="<?php echo "$cell_height"; ?>" width="<?php echo "$cell_width"; ?>" valign="top">
<?php echo(($week_day <= $mthdays && $week_day > 0 ) ? get_events($calparams): "&nbsp;"); ?></td>
<?php 
}
$week_day++;
}
echo "</tr>\r\n";
}
?>
</table>
</td>
</tr>
</table>

<table border="0" cellpadding="0" cellspacing="5">
<tr>
<td><?php echo "$L_CALENDAR[135]"; ?> <input type="text" name="month" size="2" maxlength="2" /></td>
<td><?php echo "$L_CALENDAR[140]"; ?> <input type="text" name="year" size="4" maxlength="4" /></td>
<td><input type="submit" class="button" value=" GO " />
</td>
</tr>
</table>
</form>
<?php
}
// END



//	---------------------------------------------------
//		RETRIEVE BIRTHDAYS AND EVENTS
//	---------------------------------------------------

function get_events($calparams)
{
    global $db_members, $db_events, $profileviewpage, $sfx, $DB;

    $type  =& $calparams['type'];
    $year  =& $calparams['year'];
    $month =& $calparams['month'];
    $day   =& $calparams['week_day'];
    $showbd =& $calparams['showbdays'];
    $memdir =& $calparams['memdir'];


    if ($day   == $calparams['today']   && 
        $month == $calparams['tomonth'] && 
        $year  == $calparams['toyear'])
    {
         $dayfmt = "<b>$day</b>";
    }
    else  
    {
         $dayfmt = "$day"; 
    }   

    if (strlen ($day) == 1) $day = "0{$day}";

    if ($type == "mixed" || $type == "eventlink")
    {
        $sql = "select distinct year,month,day 
                from $db_events 
                where year = '".$DB->escape_str($year)."' 
                and month = '".$DB->escape_str($month)."' 
                and day = '".$DB->escape_str($day)."' order by t_stamp";
                
        $query = new DB_query($DB, $sql);
      
        while ($query->db_fetch_object()) 
        {
            $id = $query->obj->year . $query->obj->month . $query->obj->day;
            $dayfmt = "<a href=\"events$sfx?id=$id\" onclick=\"openEventWindow();\" target=\"events\" onmouseover=\"showEventsMessage(); return true\" onmouseout=\"hideEventsMessage();\">$dayfmt</a>";
        } 
    }
    
    echo "<div class=\"monthdays\" align=\"right\">$dayfmt</div>\n"; 
 
    if ($type == "mixed" || $showbd == "yes")
    { 
        echo "<div class=\"member\" align=\"left\">";
         
        $eql = "select id,signature 
                from $db_members 
                where bday_day = '".$DB->escape_str($day)."' 
                and bday_month = '".$DB->escape_str($month)."'";
                
        $result = new DB_query($DB, $eql);
      
        while ($result->db_fetch_object()) 
        {
            $id = $result->obj->id;
            $sig = $result->obj->signature;
    
            if (get_magic_quotes_gpc())
                $sig = stripslashes($sig);
    
        echo "<a href=\"$memdir$profileviewpage$sfx?id=$id\" onmouseover=\"showProfileMessage(); return true\" onmouseout=\"hideProfileMessage();\">".$sig."</a><br />\n";     
     
        }
        echo "</div>";
    }
    elseif ($type == "eventlist")
    {
        echo "<div class=\"member\" align=\"left\">";
         
        $sql = "select id, title
                from $db_events 
                where year = '".$DB->escape_str($year)."' 
                and month = '".$DB->escape_str($month)."' 
                and day = '".$DB->escape_str($day)."'";
                
        $query = new DB_query($DB, $sql);
      
        while ($query->db_fetch_object()) 
        {
            $id = "E" . $query->obj->id;
            $title = $query->obj->title;
            
            if (get_magic_quotes_gpc())
            {
                $title = stripslashes($title);
            }
    
            echo "<a href=\"events$sfx?id=$id\" onclick=\"openEventWindow();\" target=\"events\" onmouseover=\"showEventsMessage(); return true\" onmouseout=\"hideEventsMessage();\">$title</a><br />\r\n";
        } 
        echo "</div>";
    } 
}
// END


//	---------------------------------------------
//		RETRIEVE EVENTS
//	---------------------------------------------

function show_events($id, $date="", $time="")
{
    global $db_events, $sfx, $DB, $SHARED;

	if ($date == "")
		$date = "M, d Y";

	if ($time == "")
		$time = "h:i a";
		
	$SHARED->get_pref("link_pops_window_events") == "yes" ? $pop = "yes" : $pop = "";

	$sql = "select * from $db_events ";

	if (substr($id,0,1) == "E")
	{
		$sql .= "where id = '".$DB->escape_str(substr($id,1))."' order by t_stamp ";
	}
	else
	{
		$sql .= "where year = '".$DB->escape_str(substr($id,0,4))."'
				and month = '".$DB->escape_str(substr($id,4,2))."' 
				and day = '".$DB->escape_str(substr($id,6,2))."' order by t_stamp ";
	}
				
    $query = new DB_query($DB, $sql);
    
    if ($query->db_num_rows() > 0) 
    {

    while ($query->db_fetch_object()) 
    {
            $show_time = $query->obj->show_time;
            $t_stamp = $query->obj->t_stamp;
            $title = $query->obj->title;
            
            $description = nl2br(pmcode_decode($query->obj->description,$pop));

        if (get_magic_quotes_gpc())
        {
            $title = stripslashes($title);
            $description = stripslashes($description);
        }
        
        if ($show_time ==1)
        {
            $fdate = date("$date $time",$t_stamp);
        }
        else
        {
            $fdate = date($date,$t_stamp);
        }

        $swap = array(  "%%date%%" => $fdate, 
                        "%%title%%" => $title,
                        "%%description%%" => $description);
                        
          
        $block = $SHARED->get_template("calendar","10");

        while(list($key,$value) = each($swap))
        {
            $block = str_replace("$key","$value",$block); 
        }

    echo "$block";
    }
  }
}
// END
?>