<?php
//
// pMachine Publishing Software
//
// Version 2.4 (Pro2.4.004)
//
// Copyright (c) 2003 - 2005 pMachine, Inc.
//
// THIS IS COPYRIGHTED SOFTWARE
//
// License holders may alter or modify this software for their own use, 
// but may NOT resell or redistribute the modified or derivative version 
// without prior written consent from pMachine.  Components from this 
// software may not be extracted and used in other programs without prior 
// written consent from pMachine.
//
// PLEASE READ THE LICENSE AGREEMENT
//



//	----------------------------------------------
//		VALIDATE EMAIL ADDRESS
//	----------------------------------------------

function valid_email($address) 
{
  //if (ereg("^[a-zA-Z0-9_\.\-\+]+@[a-zA-Z0-9\-\.]+\.[a-zA-Z0-9\-\.]+$", $address))
  //if (ereg("^([a-zA-Z0-9_]|\\-|\\.|\\+)+@([a-zA-Z0-9_]|\\-|\\.|\\+)+\\.[a-z]{2,4}$", $address))

	if (!eregi( "^([-a-zA-Z0-9_\.\+])+@([-a-zA-Z0-9_\.\+]+\.)+[a-z]{2,6}$", $address))
		return false;
	else 
		return true;
}

// END



//	---------------------------------------------
//		BASIC TAG CLEAN UP
//	---------------------------------------------

function pmcode_basic_clean($str) 
{  
    $str = preg_replace("/</i","&lt;",$str);
    $str = preg_replace("/>/i","&gt;",$str);
    $str = preg_replace("/\"/i","&quot;",$str);
    $str = preg_replace("/&amp;&quot;/i","&quot;",$str);

return $str;
}
// END



//	---------------------------------------------
//		HTML SPECIAL CHARACTER ENCODE
//	---------------------------------------------

function special_char_encode($str) 
{  
    // $str = preg_replace("/&nbsp;/i","&amp;nbsp;",$str);
    $str = preg_replace("/&(\w+);/i","&amp;\\1;",$str);
    $str = preg_replace("/&#(\d+);/i","&amp;#\\1;",$str);

return $str;
}
// END



//	---------------------------------------------
//		HTML SPECIAL CHARACTER DECODE
//	---------------------------------------------

function special_char_decode($str) 
{  
    $str = preg_replace("/&amp;#(\d+);/i","&#\\1;",$str);

return $str;
}
// END



//	---------------------------------------------
//		STRIP TAGS
//	---------------------------------------------

function pmcode_remove_tags($str) 
{  
	$str = preg_replace("/</i","&lt;",$str);
	$str = preg_replace("/>/i","&gt;",$str);

return $str;
}
// END



//	---------------------------------------------
//		ADD IMAGE QUOTES
//	---------------------------------------------

function pmcode_add_img_quotes($str) 
{  
    // Replace quotes with: ``
    $str = preg_replace("/\"/i","``",$str);

return $str;
}
// END



//	---------------------------------------------
//		REMOVE IMAGE QUOTES
//	---------------------------------------------

function pmcode_fix_img_quotes($str) 
{  
    // Replace `` with quotes
    $str = preg_replace("/\``/i","\"",$str);

return $str;
}
// END



//	---------------------------------------------
//		TRANSLATE HTML ENTITIES BACK TO TEXT
//	---------------------------------------------

function pmcode_translate_entities($str)
{
    $trans_tbl = get_html_translation_table(HTML_ENTITIES);
    $trans_tbl = array_flip($trans_tbl);
    $ret = strtr($str, $trans_tbl);
    
    return preg_replace('/\&\#([0-9]+)\;/me',"chr('\\1')",$ret);
}
// END



//	---------------------------------------------
//		BASIC PMCODE ENCODING
//	---------------------------------------------

function pmcode_basic_encode($str) 
{      
    // ADD quotes back: [q]
    $str = preg_replace("/\[q\]/i","\"",$str);
    // <b> and </b>
    $str = preg_replace("/<b>(.*?)<\/b>/si","[b]\\1[/b]",$str);
    // <strong> and </strong>
    $str = preg_replace("/<strong>(.*?)<\/strong>/si","[strong]\\1[/strong]",$str);
    // <em> and </em>
    $str = preg_replace("/<em>(.*?)<\/em>/si","[em]\\1[/em]",$str);
    // <i> and </i>
    $str = preg_replace("/<i>(.*?)<\/i>/si","[i]\\1[/i]",$str);
    // <u> and </u>
    $str = preg_replace("/<u>(.*?)<\/u>/si","[u]\\1[/u]",$str);
    // <pre>
    $str = preg_replace("/<pre>/i","[pre]",$str);
    // </pre>
    $str = preg_replace("/<\/pre>/i","[/pre]",$str);

return $str;
}  
// END


//	---------------------------------------------
//		PMCODE IMAGE ENCODE
//	---------------------------------------------

function pmcode_img_encode($str) 
{
    $str = preg_replace("/<img.*src\s*=(.*?)\>/i","[img]\\1[/img]",$str);

return $str;
}
// END



//	---------------------------------------------
//		STRIP IMAGES
//	---------------------------------------------

function pmcode_img_strip($str) 
{
    $str = preg_replace("/<img.*src\s*=(.*?)\>/i","",$str);

return $str;
}
// END


//	---------------------------------------------
//		URL/EMAIL/LINK ENCODING
//	---------------------------------------------

function pmcode_url_encode($str) 
{
    $str = " " . $str . " ";

    if (get_magic_quotes_gpc())
        $str = stripslashes($str);
        
    $str = str_replace("target=\"_blank\"","",$str);    
    $str = str_replace("target=\"_top\"","",$str);    

 	// Encode URLs - Step 1 - links with quotes
	$str = preg_replace("/<a\s*href\s*=\s*\"\s*(.*?)\"\s*\>(.*?)<\/a>/si","[url=\\1]\\2[/url]",$str);
	
 	// Encode URLs - Step 2 - links with no quotes
	$str = preg_replace("/<a\s*href\s*=\s*\s*(.*?)\s*\>(.*?)<\/a>/si","[url=\\1]\\2[/url]",$str);

    // URLs with extra junk in them
    $str = preg_replace("/<a href=\"(.*^\$!)\"\>(.*^\$!)<\/a>/i","[url=\\1]\\2[/url]",$str);
    
    // Clear period from end of URLs
    $str = preg_replace("/(\s)((http(s?):\/\/)|(www\.)+)([\w\.]+)([\/\w+\.]+)([\S*]+)([.]+)(\s)/i","\\1\\2\\6\\7\\8\\10", $str);
    
    // Format stand-alone URLs
    $str = preg_replace("/(\s)((http(s?):\/\/)|(www\.)+)([\w\.]+)([\/\w+\.]+)([\S*]+)/i","\\1[url=http\\4://\\5\\6\\7\\8]\\2\\6\\7\\8[/url]", $str);
    
    // Clear period from end of email addresses
    $str = preg_replace("/(\s)([a-zA-Z0-9_\.\-]+)@([a-zA-Z0-9\-]+)\.([a-zA-Z0-9\-\.]*)([.]+)(\s)/i","\\1\\2@\\3.\\4\\6",$str);
    
    // Format stand-along email address
    $str = preg_replace("/(\s)([a-zA-Z0-9_\.\-]+)@([a-zA-Z0-9\-]+)\.([a-zA-Z0-9\-\.]*)/i","\\1[email]\\2@\\3.\\4[/email]",$str);
    
    if (get_magic_quotes_gpc())
        $str = addslashes($str);
        
    $str = substr($str,1);
    $str = substr($str, 0, -1);

return $str;
}
// END


//	---------------------------------------------
//		PMCODE DECODE
//	---------------------------------------------

function pmcode_decode($str,$pop="") 
{    
    if (!isset($pop)) $pop = "";

    if ($pop == "yes")
        $pop = "target=\"_blank\"";
    else
        $pop = ""; 
        
    
    // [b] and [/b]
    $str = preg_replace("/\[b\](.*?)\[\/b\]/si","<b>\\1</b>",$str);

    // [strong] and [/strong]
    $str = preg_replace("/\[strong\](.*?)\[\/strong\]/si","<strong>\\1</strong>",$str);

    // [em] and [/em]
    $str = preg_replace("/\[em\](.*?)\[\/em\]/si","<em>\\1</em>",$str);
    
    // [i] and [/i]
    $str = preg_replace("/\[i\](.*?)\[\/i\]/si","<i>\\1</i>",$str);
    
    // [u] and [/u]
    $str = preg_replace("/\[u\](.*?)\[\/u\]/si","<u>\\1</u>",$str);
    
    // [color=blue] and [/color]
    $str = preg_replace("/\[color=(.*?)\](.*?)\[\/color\]/si","<font color=\"\\1\">\\2</font>",$str);
    
    // [size=4] and [/size]
    $str = preg_replace("/\[size=(.*?)\](.*?)\[\/size\]/si","<font size=\"\\1\">\\2</font>",$str);
    
    // [img] and [/img]
    $str = preg_replace("/\[img\](.*?)\[\/img\]/i","<img src=\\1>",$str);
    
    // [url]http://www.somesite.com[/url]
    $str = preg_replace("/\[url\]http(s?):\/\/(.*?)\[\/url\]/i","<a href=\"http\\1://\\2\" $pop>\\2</a>",$str);
    
    // [url=http://www.somesite.com]somesite[/url]
    $str = preg_replace("/\[url=http(s?):\/\/(.*?)\](.*?)\[\/url\]/i","<a href=\"http\\1://\\2\" $pop>\\3</a>",$str);
    
    // [url]www.somesite.com[/url]
    $str = preg_replace("/\[url\]www.(.*?)\[\/url\]/i","<a href=\"http://www.\\1\" $pop>\\1</a>",$str);
    
    // [url=www.somesite.com]somesite[/url]
    $str = preg_replace("/\[url=www.(.*?)\](.*?)\[\/url\]/i","<a href=\"http://www.\\1\" $pop>\\2</a>",$str);
    
    // [url=%%dir[1]%%somefile.pdf]close[/url]
	$str = preg_replace("/\[url=(.*?)%%dir\[(.*?)\]%%(.*?)\](.*?)\[\/url\]/i","<a href=\"\\1%%dir[\\2]%%\\3\">\\4</a>",$str);    
    
    // [url=javascript:window.close()]close[/url] this one replaces oddball submissions
    $str = preg_replace("/\[url=(.*?)\](.*?)\[\/url\]/i","<a href=\"\\1\">\\2</a>",$str);
        
    // [email=your@yourstie]email[/email]
    $str = preg_replace("/\[email=(.*?)\](.*?)\[\/email\]/i","<a href=\"mailto:\\1\">\\2</a>",$str);
    
    // [email]joe@xyz.com[/email]
    $str = preg_replace("/\[email\](.*?)\[\/email\]/i","<a href=\"mailto:\\1\">\\1</a>",$str);

    // [encode=your@yourstie]email[/encode]
    $str = preg_replace_callback("/\[encode=(.*?)\](.*?)\[\/encode\]/i","email_encode_callback",$str);

    // [encode]joe@xyz.com[/encode]
    $str = preg_replace_callback("/\[encode\](.*?)\[\/encode\]/i","email_encode_callback",$str);
    
    // [style=some_style]yadda yadda[/style]  gets converted to <span class="some_style">yadda yadda</style>
    $str = preg_replace("/\[style=(.*?)\](.*?)\[\/style\]/si","<span class=\"\\1\">\\2</span>", $str);    

    // [code]
    $str = preg_replace("/\[code\]/i","<pre>",$str);
    
    // [/code]
    $str = preg_replace("/\[\/code\]/i","</pre>",$str);
    
    // [pre]
    $str = preg_replace("/\[pre\]/i","<pre>",$str);
    
    // [/pre]
    $str = preg_replace("/\[\/pre\]/i","</pre>",$str);
    
    // [quote]
    $str = preg_replace("/\[quote\]/i","<blockquote>",$str);
    
    // [/quote]
    $str = preg_replace("/\[\/quote\]/i","</blockquote>",$str);

return $str;
}
// END


function email_encode_callback($matches)
{
    if (!isset($matches['1']))
        return;

    if (isset($matches['2']))
        return encoded_email($matches['1'], $matches['2'], 0);
    else
        return encoded_email($matches['1'], '', 0);
}




//	----------------------------------------------------------------
//		CONVERT NEW LINES TO <br /> - EXCEPT WITHIN <pre> TAGS
//	----------------------------------------------------------------

function nl2brExceptPre($textstr)
{
    $retstr = "";
    $explodedBody = explode("pre>",$textstr);
    $ubound = count($explodedBody);

    for ($i = 0; $i < $ubound; $i++) {

        if (($i % 2) == 0)
            $retstr .= nl2br($explodedBody[$i]);
        else 
            $retstr .= $explodedBody[$i];

        if ($ubound-1 != $i) 
            $retstr .= "pre>";
    }
return $retstr;
}
// END


//	----------------------------------------------------------------
//      XHTML TYPOGRAPHY
//	----------------------------------------------------------------

function xhtml_typography($str)
{
	$str = trim($str);

	// Define temporary markers
    $nl = '848Ff5f9a66a5ffb627cdbDce6';
	$dq = '5ffbFR627fTs3ks0097RHGH5w2';
	$sq = '5GEf899adfqekrFR62700WWde4';
	
	$n2 = $nl.$nl;
		
    // We don't want to add an opening <p> tag if the first
    // thing in an entry is a <blockquote>, <pre>, <code>, etc.	
		
    if (substr($str, 0, 5) == "<bloc"  ||
        substr($str, 0, 4) == "<pre"   ||
        substr($str, 0, 5) == "<code"  ||
        substr($str, 0, 3) == "<ol"    ||
        substr($str, 0, 3) == "<ul")
	{
	    $str = " ".$str." ";
	}
	else
	    $str = " <p>".$str." ";
	    		
	// Replace ampersands with &amp; - but only if the
	// ampersands are not part of an entity
	
    $str = preg_replace("/&#(\d+);/", "$nl\\1;", $str);
    $str = preg_replace("/&(\w+);/",  "$nl\\1;", $str);
	$str = str_replace("&", "&amp;", $str);
    $str = preg_replace("/$nl(\d+);/","&#\\1;", $str);
    $str = preg_replace("/$nl(\w+);/","&\\1;",  $str);
    
    // Replace all newlines with a temporary marker
    
	$str = preg_replace("/(\015\012)|(\015)|(\012)/",$nl, $str);
	
	// We don't want the auto typography feature to affect the quotes that appear inside tags
	// so we'll replace all single and double quotes within tags with temporary markers.
	
	preg_match_all("/\<.+?\>/si", $str, $out);
	
	for($i=0; $i < count($out['0']); $i++)
	{
		$temp[$i] = preg_replace("/\"/si", $dq, $out['0'][$i]);
		
		$temp[$i] = str_replace("'", $sq, $temp[$i]);
		
		$str = str_replace($out['0'][$i], $temp[$i], $str);
	}
	
	// Define our translation table
		
	$trans_table = array(
	
		"\"' "              => "&#8221;&#8217; ",
		"\"'"               => "&#8220;&#8216;",
		
		" \""               => " &#8220;",
		" '"                => " &#8216;",
		"'"                 => "&#8217;",
		
		"$nl\""             => "{$nl}&#8220;",
		"{$nl}&#8217;"      => "{$nl}&#8216;",
		"&#8216;\""         => "&#8216;&#8220;",

		"\" "               => "&#8221; ",
		"\"$nl"             => "&#8221;$nl",
		"\"."               => "&#8221;.",
		"\","               => "&#8221;,",
		"\";"               => "&#8221;;",
		"\":"               => "&#8221;:",
		"\"!"               => "&#8221;!",
		"\"?"               => "&#8221;?",
		
		" -- "              => "&#8212;",
        "... "              => "&#8230; ",

		".  "               => ".&nbsp; ",
		"?  "               => "?&nbsp; ",
		"!  "               => "!&nbsp; ",
		":  "               => ":&nbsp; ",
		
		"$n2<blockquote>"   => "\n</p>\n<blockquote>",
		"</blockquote>$n2"  => "</blockquote>\n<p>\n",
		
		"$n2<ul>"           => "\n</p>\n<ul>",
		"</ul>$n2"          => "</ul>\n<p>\n",
		
		"$n2<ol>"           => "\n</p>\n<ol>",
		"</ol>$n2"          => "</ol>\n<p>\n",
		
		"$n2<code>"         => "\n</p>\n<code>",
		"</code>$n2"        => "</code>\n<p>\n",
		
		"$n2<pre>"          => "\n</p>\n<pre>",
		"</pre>$n2"         => "</pre>\n<p>\n",
			
		"$nl$nl"            => "\n</p>\n<p>\n",
		
		"</blockquote>$nl"  => "</blockquote>\n",
        
        "$nl<li>"           => "\n<li>",
		"$nl</ol>"          => "\n</ol>",
		"$nl</ul>"          => "\n</ul>"
	);
	
	foreach ($trans_table as $key => $val)
	{
		$str = str_replace($key, $val, $str);
	}
	
	// Convert newlines to <br /> tags except within <pre> tags
	
    $newstr = '';
    $ex = explode("pre>", $str);
    $ct = count($ex);

    for ($i = 0; $i < $ct; $i++) {

        if (($i % 2) == 0)
            $newstr .= str_replace($nl, "\n<br />\n", $ex[$i]);
        else 
            $newstr .= $ex[$i];

        if ($ct -1 != $i) 
            $newstr .= "pre>";
    }
	
    $str = str_replace($nl, "\n", $newstr);

	// Clean up the spaces we added at the beginning

    $str = substr($str,1);
    $str = substr($str, 0, -1);
    
    if (substr($str, 0, 3) == "<p>")
    {
        $str = substr($str, 3);
        $str = "<p>\n".$str;
	}
    
    if (substr($str, -4) == "</p>")
        $str = substr($str, 0, -4);  
    
    // Add the closing </p> tag at the end of the entry
    
    if (substr($str, -6) != "quote>" AND
        substr($str, -4) != "pre>"   AND
        substr($str, -5) != "code>"  AND
        substr($str, -3) != "ol>"    AND
        substr($str, -3) != "ul>")
	{
	    $str = $str."\n</p>";
	}
		
    // Clean up stray paragraph tags.
    	
	$newstr = '';
	
	$copy = explode("</p>", $str);

	for ($i = 0;  $i < count($copy); $i++)
	{
	    if (stristr($copy[$i], "<p>"))
	    {
	        $newstr .= $copy[$i]."</p>";
	    }
	    else
	        $newstr .= $copy[$i];
	}
	
    $str =& $newstr;
    	
   // Add quotes back to tags
    	
	$str = str_replace($dq, "\"", $str);
	$str = str_replace($sq, "'", $str);
		
    return $str;
}
// END
?>