<?php
//
// pMachine Publishing Software
//
// Version 2.4 (Pro2.4.004)
//
// Copyright (c) 2003 - 2005 pMachine, Inc.
//
// THIS IS COPYRIGHTED SOFTWARE
//
// License holders may alter or modify this software for their own use, 
// but may NOT resell or redistribute the modified or derivative version 
// without prior written consent from pMachine.  Components from this 
// software may not be extracted and used in other programs without prior 
// written consent from pMachine.
//
// PLEASE READ THE LICENSE AGREEMENT
//



//	---------------------------------------------
//		SIMPLE SEARCH FORM 
//	---------------------------------------------

function simple_search_form($weblog="", $override = 0) 
{
	global $SECURE, $db_prefs, $DB, $SHARED;

    $search_page = $SHARED->get_pref("search_page"); 
    $swap = array("%%search_page%%" => $search_page);   
    $block = $SHARED->get_template('search',"30");
    
    while(list($key,$value) = each($swap))
    {
        $block = str_replace("$key","$value",$block); 
    }
	
	// ---------------------------------
	//  Secure Forms and Captcha
	// ---------------------------------
	
	$query = new DB_query($DB, "SELECT pm_option, pm_value FROM $db_prefs WHERE pref_grp IN ('40','45')");
	
	while ($query->db_fetch_object()) 
	{
		${$query->obj->pm_option} = $query->obj->pm_value; 
	}
	
	if ($secure_forms == 'yes')
	{
		echo $SECURE->security_hash_js('y')."\r\n";
		echo "<form method=\"post\" action=\"$search_page\" ".$SECURE->security_hash_js().">\r\n";
		echo $SECURE->security_hash_field();
	}
	else
	{
		echo "<form method=\"post\" action=\"$search_page\" >\r\n";
	}
	
	echo "<input type=\"hidden\" name=\"weblog\" value=\"$weblog\" />\r\n";
	
	if ($override == 1)
	{
	    echo "<input type=\"hidden\" name=\"override\" value=\"1\" />\r\n";
	}
	
	echo "$block";
	echo "</form>";
}
// END


//	---------------------------------------------
//		ADVANCED SEARCH FORM 
//	---------------------------------------------

function advanced_search_form($weblog="", $override=0) 
{  
	global $SECURE, $db_prefs, $DB, $SHARED;

    $search_page = $SHARED->get_pref("search_page"); 
    $block = $SHARED->get_template('search',"40");
	
	// ---------------------------------
	//  Secure Forms and Captcha
	// ---------------------------------
	
	$query = new DB_query($DB, "SELECT pm_option, pm_value FROM $db_prefs WHERE pref_grp IN ('40','45')");
	
	while ($query->db_fetch_object()) 
	{
		${$query->obj->pm_option} = $query->obj->pm_value; 
	}
	
	if ($secure_forms == 'yes')
	{
		echo $SECURE->security_hash_js('y')."\r\n";
		echo "<form method=\"post\" action=\"$search_page\" ".$SECURE->security_hash_js().">\r\n";
		echo $SECURE->security_hash_field();
	}
	else
	{
		echo "<form method=\"post\" action=\"$search_page\">\r\n";
	}
	
	echo "<input type=\"hidden\" name=\"weblog\" value=\"$weblog\" />\r\n";

	if ($override == 1)
	{
		echo "<input type=\"hidden\" name=\"override\" value=\"1\" />\r\n";
	}

	echo "$block\r\n";
	echo "</form>\r\n";
}
// END


//	---------------------------------------------
//		LIMIT RESULTS TO 100 CHARACTERS
//	---------------------------------------------

function limit_result($str) 
{  
    $total = 100;
    $lstr  = strip_tags(pmcode_img_strip($str));

    if (strlen($str) > $total) 
    {
         $lstr = substr($lstr, 0, $total);
         $word = preg_split("/\s+/", $lstr);

         $limit = "";

        for ($i=0; $i < sizeof($word) -1; $i++) 
        {
             $limit .= "$word[$i] ";
        }
        
        $limit = trim($limit);
        
        if ($limit)
        {
        	$limit .="..."; 
        }
    }
    else 
    {
         $limit = $str;
    } 

return $limit;
}
// END


//	---------------------------------------------
//		PERFORM THE SEARCH
//	---------------------------------------------

function show_search_results($weblog='',$keywords='',$criteria='',$where='', $insecure='n') 
{    
    global $db_weblog, $db_members, $db_categories, $db_nonmembers, $url_rewriting;
    global $db_upload_prefs, $db_multiweblogs, $db_multiweblogs, $override, $db_prefs, $sfx;
    global $db_comments, $SECURE, $db_prefs, $DB, $SHARED, $db_search_queries;
    global $pm_path, $language, $messagespage;
    
    // ---------------------------------
	//  Pagination Check
	// ---------------------------------
	
	$pagination = FALSE;
	$offset     = '0';
	$search_id	= '';
	$page_num	= '1';
	
	if (isset($_GET['search']) && is_numeric($_GET['search']) && isset($_GET['page']) && is_numeric($_GET['page']))
	{
		// Check for Search in Database
		$query = new DB_query($DB, "DELETE FROM $db_search_queries WHERE search_date < '".(time() - 7200)."'");
		
		$query = new DB_query($DB, "SELECT * FROM $db_search_queries WHERE search_id = '".$DB->escape_str($_GET['search'])."' AND search_ip = '".$SHARED->IP."'");
		
		if ($query->db_num_rows() == 0)
		{
			return advanced_search_form();
		}
		else
		{
			$pagination = TRUE;
			$page_num   = $SECURE->xss_clean($_GET['page']);
			
			$query->db_fetch_array();
			foreach($query->row as $name => $value)
			{
				$$name = stripslashes($value);
			}
		}
	}
    
    
    if ($keywords == '') 
    {
    	return advanced_search_form();
    }
        
    if (isset($override) AND $override == 1)
    {
        $url_rewriting = 0;
    }
    
    // ---------------------------------
	//  Secure Forms and Captcha
	// ---------------------------------
	
	$memdir = $SHARED->get_pref("memdir","1");
	
	if ($pagination !== TRUE && $insecure == 'n')
	{	
		$query = new DB_query($DB, "SELECT pm_option, pm_value FROM $db_prefs WHERE pm_option = 'secure_forms'");
		
		while ($query->db_fetch_object()) 
		{
			${$query->obj->pm_option} = $query->obj->pm_value; 
		}
		
		if ($secure_forms == 'yes' && $SECURE->check_hash(false) !== true)
		{
			echo "Invalid Secure Form Value<br /><br />";
			return advanced_search_form();
		}
    }

    $y = '';
    $whichblog = '';
    $whichblogc = '';
    $categorylink = '';
    $category = '';
    
    $newtime	   = $SHARED->get_offset_time();
    $perpage       = $SHARED->get_pref("results_per_page_search");                
    $date_and_time = $SHARED->get_pref("date_and_time_search");
    $color_one     = $SHARED->get_pref("row_color_one_search");
    $color_two     = $SHARED->get_pref("row_color_two_search");
    $word_censor   = $SHARED->get_pref("word_censor_weblog");
    
    // ---------------------------------
    //  Weblog Display Options and IDs
    // ---------------------------------
    
    $html_display_array = array();
	$cat_array = array();

    $sql = "select id,weblog from $db_multiweblogs order by id";
    $query = new DB_query($DB, $sql);
    
    while ($query->db_fetch_object())
    {
        $blogname = $query->obj->weblog;        
        $lcblog = strtolower($blogname);
        
        $cat_array[$lcblog] = $query->obj->id;

		$html_display_array[$lcblog] = $SHARED->get_pref("html_display_options_$blogname");
    }
    
    // ---------------------------------
    //  Image Directories
    // ---------------------------------
    
    $img_array = array();
    $img_count = array();
    
    $q = "select id,abspath from $db_upload_prefs order by id"; 
    $query = new DB_query($DB, $q);
    
    while ($query->db_fetch_object())
    {
        $abspath = $query->obj->abspath;
        
        if (!eregi('/$',$abspath)) 
        	$abspath = "$abspath" . "/";

        $img_array[$query->obj->id] = $abspath;
        array_push($img_count,$query->obj->id);
    }
    
    if ($pagination !== TRUE)
    {
    	// ---------------------------------
    	//  Parse Keywords
    	// ---------------------------------
    
    	$terms			= array();
    	$keywords		= preg_replace("/(\r\n|\n|\r)/", ' ', stripslashes($keywords));
    	$orig_keywords	= $keywords;
    	
    	//echo("<!--- ".$keywords." -->");
    	
    	if(preg_match_all("/\-*\"(.*?)\"/", $keywords, $matches))
    	{
    		for($m=0; $m < sizeof($matches['1']); $m++)
    		{
    			$terms[] = trim(str_replace('"','',$matches['0'][$m]));
    			$keywords = str_replace($matches['0'][$m],'',$keywords);
    		}    
    	}
    	
    	
    	if (trim($keywords) != '')
    	{
    		$terms  = array_merge($terms, preg_split("/\s+/", trim($keywords)));
    	}
    	
    	$not_and = (sizeof($terms) > 2) ? ') AND (' : 'AND';
 	
		$mysql_function	= (substr($terms['0'], 0,1) == '-') ? 'NOT LIKE' : 'LIKE';    
		$search_term	= (substr($terms['0'], 0,1) == '-') ? $DB->escape_str(substr($terms['0'], 1)) : $DB->escape_str($terms['0']);
 	           
		$tquery = "(title $mysql_function '%$search_term%'";                
		$bquery = "(body $mysql_function '%$search_term%'";
		$mquery = "(more $mysql_function '%$search_term%'";
		$cquery = "($db_comments.body $mysql_function '%$search_term%'";
 	           
		if ($criteria == 'all') $criteria  = "AND";
		elseif ($criteria == 'any') $criteria  = "OR";
		elseif ($criteria == ''   ) $criteria  = "OR";	    
		   
		   //print_r($terms);
		   
    	for ($i=1; $i < sizeof($terms); $i++) 
    	{
    		$mysql_criteria	= ($mysql_function == 'NOT LIKE' OR substr($terms[$i], 0,1) == '-') ? $not_and : $criteria;
			$mysql_function	= (substr($terms[$i], 0,1) == '-') ? 'NOT LIKE' : 'LIKE';
			$search_term	= (substr($terms[$i], 0,1) == '-') ? $DB->escape_str(substr($terms[$i], 1)) : $DB->escape_str($terms[$i]);
	
	        $tquery .=" $mysql_criteria title $mysql_function '%$search_term%'";        	    
	        $bquery .=" $mysql_criteria body $mysql_function '%$search_term%'";
	        $mquery .=" $mysql_criteria more $mysql_function '%$search_term%'";
	        $cquery .=" $mysql_criteria $db_comments.body  $mysql_function '%$search_term%'";
		}
	    	
	    $tquery .= ')';        	  
	    $bquery .= ')';
	    $mquery .= ')';
	    $cquery .= ')';
	                
	    if ($where == '')
	    {
	    	$where = 'all';  
	    }
	          
		switch($where)
		{
			case  "all"   	: $fullquery = (stristr($bquery, 'NOT LIKE') !== false && sizeof($terms) > 2) ? "( ($tquery) OR ($bquery) OR ($mquery) )" : "( $tquery OR $bquery OR $mquery )";
			break;
			case  "title" 	: $fullquery = "( $tquery )"; 
			break;
			case  "body"  	: $fullquery = (stristr($bquery, 'NOT LIKE') !== false && sizeof($terms) > 2) ? "( ($bquery) OR ($mquery) )" : "( $bquery OR $mquery )"; 
			break;
			case "comments" : $fullquery = "( $cquery )";
			break;
			default 	  	: $fullquery = (stristr($bquery, 'NOT LIKE') !== false && sizeof($terms) > 2) ? "( ($tquery) OR ($bquery) OR ($mquery) )": "( $tquery OR $bquery OR $mquery )";
			break;
		}
         
    
    	if ($weblog != '') 
    	{
    	    if (substr($weblog, 0, 4) == "not ") 
        	{
        	    $blogs = explode(' ', trim($weblog));
	
	            for ($i=1; $i < sizeof($blogs); $i++) 
	            {
	                 $whichblog  .= "weblog != '".$DB->escape_str($blogs[$i])."' AND ";
	                 $whichblogc .= "$db_comments.weblog != '".$DB->escape_str($blogs[$i])."' AND ";
	            }
	        }
	        else 
	        {
	            $blogs = explode(' ', trim($weblog));
	            $whichblog = "( weblog = '".$DB->escape_str($blogs['0'])."' ";  
    	        $whichblogc = "( $db_comments.weblog = '".$DB->escape_str($blogs['0'])."' ";  
	
	            for ($i=1; $i < sizeof($blogs); $i++) 
	            {
	                 $whichblog  .= "OR weblog = '".$DB->escape_str($blogs[$i])."'";
	                 $whichblogc .= "OR $db_comments.weblog = '".$DB->escape_str($blogs[$i])."'";
	            }
	            
	          	$whichblog  .= ") AND";
	          	$whichblogc .= ") AND";
	        }
	    } 
	    
	    if ($where == 'comments')
	    {
	    	$sql = "FROM $db_weblog, $db_comments
					WHERE $db_weblog.post_id = $db_comments.post_id
					AND $whichblogc
					$db_comments.preview = '0'
					AND $db_comments.status = 'open'
					AND $db_weblog.status = 'open'
					AND $db_weblog.t_stamp <= '$newtime' 
					AND $db_weblog.x_stamp >= '$newtime' 
					AND $cquery 
					ORDER BY $db_weblog.t_stamp DESC";
		}
		else
		{
			$sql = "FROM $db_weblog 
					WHERE $whichblog status = 'open'
					AND preview = '0'
					AND t_stamp <= '$newtime'
					AND x_stamp >= '$newtime'
					AND $fullquery
					ORDER BY t_stamp DESC";
		}
		
		$query = new DB_query($DB, "SELECT COUNT(*) AS count ".$sql);
		$query->db_fetch_object();
		$total_results = $query->obj->count;
		
		// ---------------------------------
		//  Insert into DB for Pagination
		// ---------------------------------
		
		if ($total_results > 0)
		{
			$data = array(
							'search_id'      => '',
							'search_query'   => $sql,
							'search_ip'      => $SHARED->IP,
							'total_results'  => $total_results,
							'keywords'       => $orig_keywords,
							'search_date'    => time()							
						  );
						  
			$query = new DB_query($DB, $DB->insert_string($db_search_queries, $data));
			$search_id = $query->db_insert_id();
		}
	}
	else
	{
		$sql			= $search_query;
		$orig_keywords	= $keywords; 
		$offset			= ($page_num - 1)*$perpage;
	}
        
	if ($total_results == 0 OR $offset > $total_results) 
	{
		$swap = array("%%keywords%%" => $orig_keywords); 
		$block = $SHARED->get_template('search',"10");
		
		while(list($key,$value) = each($swap))
		{
			$block = str_replace("$key","$value",$block); 
		}

		// HEADER
		echo $block;
	} 
	else 
	{
	    $swap = array("%%total%%" => $total_results,"%%keywords%%" => $keywords);  
	    $block = $SHARED->get_template('search',"02");    
	
	    while(list($key,$value) = each($swap))
	    {
	    	$block = str_replace("$key","$value",$block); 
		}
		
		echo $block;
		
		$query = new DB_query($DB, "SELECT DISTINCT $db_weblog.* ".$sql." LIMIT $offset, $perpage");
		
		$counter = $offset;
		$delim   = ($url_rewriting == 1) ? '/' : '?id=';
      
		while ($query->db_fetch_object())
		{
			$postid     = $query->obj->post_id;
			$t_stamp    = $query->obj->t_stamp;
			$mem_id     = $query->obj->member_id;
        	$weblog     = strtolower($query->obj->weblog);
        	$categoryid = $query->obj->category;
        	$title      = $query->obj->title;
        	$body       = $query->obj->body;
        	$blurb      = $query->obj->blurb;
        	$more       = $query->obj->more;
        	$custom1    = $query->obj->custom1;
        	$custom2    = $query->obj->custom2;
        	$custom3    = $query->obj->custom3;
        	$nl2brBody  = $query->obj->nl2brBody;
        	$nl2brMore  = $query->obj->nl2brMore;
        	$nl2brBlurb = $query->obj->nl2brBlurb;
        	$nl2brC1    = $query->obj->nl2brC1;
        	$nl2brC2    = $query->obj->nl2brC2;
        	$nl2brC3    = $query->obj->nl2brC3;
    
			if (get_magic_quotes_runtime()) 
			{
				$title   = stripslashes($title);
				$body    = stripslashes($body);
				$blurb   = stripslashes($blurb);
				$more    = stripslashes($more);
				$custom1 = stripslashes($custom1);
				$custom2 = stripslashes($custom2);
				$custom3 = stripslashes($custom3);
			}
    
        	$date = date("$date_and_time",$t_stamp);

        	$html_display = $html_display_array[$weblog];

        	if ($word_censor == "yes") 
        	{
        	    $title = censor($title);
        	    $body  = censor($body);
        	         
        	    if ($blurb != '') $blurb = censor($blurb);
        	    if ($more  != '') $more = censor($more);
        	}
        
        	if ($html_display == "convert_html") 
        	{
        	    $title = pmcode_remove_tags($title);
        	    $body  = pmcode_remove_tags($body);
        	        
        		if ($blurb   != '') $blurb   = pmcode_remove_tags($blurb);
        		if ($more    != '') $more    = pmcode_remove_tags($more);
        		if ($custom1 != '') $custom1 = pmcode_remove_tags($custom1);
        		if ($custom2 != '') $custom2 = pmcode_remove_tags($custom2);
        		if ($custom3 != '') $custom3 = pmcode_remove_tags($custom3);
			}
        
			$title = pmcode_decode($title);
			$body  = pmcode_decode($body);
            
        	if ($blurb   != '') $blurb   = pmcode_decode($blurb);
        	if ($more    != '') $more    = pmcode_decode($more);
        	if ($custom1 != '') $custom1 = pmcode_decode($custom1);
        	if ($custom2 != '') $custom2 = pmcode_decode($custom2);
        	if ($custom3 != '') $custom3 = pmcode_decode($custom3);
        	
        	if ($nl2brBody == 1) $body  = nl2brExceptPre($body);
        	
        	if ($blurb   != ''  && $nl2brBlurb == 1) $blurb   = nl2brExceptPre($blurb);
        	if ($more    != ''  && $nl2brMore == 1 ) $more    = nl2brExceptPre($more);
        	if ($custom1 != ''  && $nl2brC1 == 1   ) $custom1 = nl2brExceptPre($custom1);
        	if ($custom2 != ''  && $nl2brC2 == 1   ) $custom2 = nl2brExceptPre($custom2);
        	if ($custom3 != ''  && $nl2brC3 ==1    ) $custom3 = nl2brExceptPre($custom3);

        	$counter++;
    
        	if (substr($mem_id, 0, 2)=="NM") 
        	{
        	    $q = "select id,signature,email,url,location,show_email from $db_nonmembers where id = '".substr($mem_id,2)."'";  
        	}
        	else 
        	{
        	    $q = "select id,signature,email,url,location,show_email,numentries,numcomments from $db_members where id = '$mem_id'";
        	}
        	 
        	$result = new DB_query($DB, $q);
        	$result->db_fetch_object();
        	$signature  = $result->obj->signature;
    
        	if(get_magic_quotes_runtime())
        	{
        	    $signature = stripslashes($signature); 
			}

			$pagespath = $SHARED->get_pref("pages_path_abs_$weblog","1");  
			$weblogpage = $SHARED->get_pref("$weblog" . "_page");
			$commentpage = $SHARED->get_pref("comments_page_"."$weblog");
			$morepage = $SHARED->get_pref("more_page_"."$weblog");

        	$weblog_permalink = "$pagespath$weblogpage{$delim}P{$postid}";
        	$comment_permalink = "$pagespath$commentpage$delim{$postid}_0_"."$cat_array[$weblog]"."_0_C";
        	$morepage_permalink = "$pagespath$morepage$delim{$postid}_0_"."$cat_array[$weblog]"."_0_C";

    		if ($url_rewriting == 1)
    		{	
        		$weblog_permalink .= '/';
        		$comment_permalink .= '/';
        		$morepage_permalink .= '/';
    		}

    		if ($categoryid != '')
    		{
    	    	$cq = "select category from $db_categories where id = '$categoryid'";
    	    	$cquery = new DB_query($DB, $cq);
    	    	$cquery->db_fetch_array();
    	    
    		    $category = stripslashes($cquery->row['category']);
    		
    	    	if ($url_rewriting == 1)
    	    	{
    	    	    $categorylink = "$pagespath$weblogpage"."/C0"."{$categoryid}_"."$cat_array[$weblog]"."/";  
    	    	}
    	    	else
    	    	{
    	    	    $categorylink = "$pagespath$weblogpage?id=C0{$categoryid}_"."$cat_array[$weblog]";  
    	    	}
    		}

    		$altcolor = ($y % 2) ? $color_one : $color_two; $y++;

     		$swap = array(
        		"%%author%%"            => $signature,     
        		"%%title%%"             => $title,
        		"%%body%%"              => $body,
        		"%%body_excerpt%%"      => limit_result($body),
        		"%%blurb%%"             => $blurb,
        		"%%blurb_excerpt%%"     => limit_result($blurb),
        		"%%more%%"              => $more,
        		"%%more_excerpt%%"      => limit_result($more),
        		"%%custom1%%"           => $custom1,
        		"%%custom1_excerpt%%"   => limit_result($custom1),
        		"%%custom2%%"           => $custom2,
        		"%%custom2_excerpt%%"   => limit_result($custom2),
        		"%%custom3%%"           => $custom3,
        		"%%custom3_excerpt%%"   => limit_result($custom3),
        		"%%entry_url%%"         => $weblog_permalink,  
        		"%%comment_url%%"       => $comment_permalink, 
        		"%%more_url%%"          => $morepage_permalink,       
        		"%%date%%"              => $date,
        		"%%category%%"          => $category,
        		"%%category_url%%"      => $categorylink,
        		"%%color_switch%%"      => $altcolor,
        		"%%keywords%%"          => $keywords,
        		"%%count%%"             => $counter,
        		"%%a%%"                 => date("a",$t_stamp),
        		"%%A%%"                 => date("A",$t_stamp),
        		"%%B%%"                 => date("B",$t_stamp),
        		"%%d%%"                 => date("d",$t_stamp),
        		"%%D%%"                 => date("D",$t_stamp),
        		"%%F%%"                 => date("F",$t_stamp),
        		"%%g%%"                 => date("g",$t_stamp),
        		"%%G%%"                 => date("G",$t_stamp),
        		"%%h%%"                 => date("h",$t_stamp),
        		"%%H%%"                 => date("H",$t_stamp),
        		"%%i%%"                 => date("i",$t_stamp),
        		"%%I%%"                 => date("I",$t_stamp),
        		"%%j%%"                 => date("j",$t_stamp),
        		"%%l%%"                 => date("l",$t_stamp),
        		"%%L%%"                 => date("L",$t_stamp),
        		"%%m%%"                 => date("m",$t_stamp),
        		"%%M%%"                 => date("M",$t_stamp),
        		"%%n%%"                 => date("n",$t_stamp),
        		"%%r%%"                 => date("r",$t_stamp),
       	 		"%%s%%"                 => date("s",$t_stamp),
       	 		"%%S%%"                 => date("S",$t_stamp),
    			"%%t%%"                 => date("t",$t_stamp),
    	    	"%%T%%"                 => date("T",$t_stamp),
    	    	"%%U%%"                 => date("U",$t_stamp),
    	    	"%%w%%"                 => date("w",$t_stamp),
    	    	"%%Y%%"                 => date("Y",$t_stamp),
    	    	"%%y%%"                 => date("y",$t_stamp),
    	    	"%%z%%"                 => date("z",$t_stamp),
    	    	"%%Z%%"                 => date("Z",$t_stamp)
			);  
      
			$block = $SHARED->get_template('search','04');
    		while(list($key,$value) = each($swap)) 
    		{
    		    $block = str_replace($key, $value, $block); 
    		} 
    		
    		for ($j=0; $j< sizeof($img_count); $j++)
    		{    
        		$block = str_replace("%%dir[$img_count[$j]]%%",$img_array[$img_count[$j]],$block);
    		}

    		echo $block;
		}
		
		// -----------------------------------
		//  SEARCH PREVIOUS/NEXT LINKS
		// -----------------------------------
		
		include ("{$pm_path}language/{$language}/main$sfx");
		$base = $SHARED->get_template('search',"12");
		$search_page = $SHARED->get_pref("search_page"); 
		
		if ($page_num > 1)
		{
			$url = $search_page.'?search='.$search_id.'&page='.($page_num - 1);
			
			$base =& str_replace('%%search_prev_page%%', '<a href="'.$url.'">'.$L_WEBLOG['380'].'</a>', $base);
		}
		else
		{
			$base =& str_replace('%%search_prev_page%%','', $base);
		}
		
		if ($total_results > $perpage+$offset)
		{
			$url = $search_page.'?search='.$search_id.'&page='.($page_num + 1);
			
			$base =& str_replace('%%search_next_page%%', '<a href="'.$url.'">'.$L_WEBLOG['385'].'</a>', $base);
		}
		else
		{
			if ($page_num == '1')
			{
				$base = '';	
			}
			else
			{
				$base =& str_replace('%%search_next_page%%', '', $base);
			}
		}
 
 		// -----------------------------------
		//  SEARCH RESULTS FOOTER
		// -----------------------------------
		echo $SHARED->get_template('search',"06")."\r\n\r\n".$base;
	}
}
// END
?>