<?php

//
// pMachine Publishing Software
//
// Version 2.4 (Pro2.4.004)
//
// Copyright (c) 2003 - 2005 pMachine, Inc.
//
// THIS IS COPYRIGHTED SOFTWARE
//
// License holders may alter or modify this software for their own use, 
// but may NOT resell or redistribute the modified or derivative version 
// without prior written consent from pMachine.  Components from this 
// software may not be extracted and used in other programs without prior 
// written consent from pMachine.
//
// PLEASE READ THE LICENSE AGREEMENT
//

class Security {

	var $seed				= false;
	var $cached_captcha		= '';
	var $javascript_hash	= true;
	var $hashes				= 0;

	//-------------------------------------------------
    //  Constructor
    //-------------------------------------------------
	
	function Security()
	{
	}
	// END

    //-------------------------------------------------
    //  XSS hacking stuff
    //-------------------------------------------------

	function xss_clean($str)
	{
    	// These are naughty things that we don't want users to submit
    	
    	 $bad = array(
        				"(<|%3c|%253c)(.*?)script(.*?)(>|%3e|%0e)"		=>	"&lt;\\2script\\3&gt;",
						"(<|%3c|%253c).*?object(.*?)(>|%3e|%0e)"		=>	"&lt;object\\2&gt;",        
        				"(<|%3c|%253c).*?applet(.*?)(>|%3e|%0e)"		=>	"&lt;applet\\2&gt;",
        				"(<|%3c|%253c).*?embed(.*?)(>|%3e|%0e)"			=>	"&lt;embed\\2&gt;",	
        				"(<|%3c|%253c).*?plaintext(.*?)(>|%3e|%0e)"		=>	"&lt;plaintext\\2&gt;",
        				"(<|%3c|%253c).*?iframe(.*?)(>|%3e|%0e)"		=>	"&lt;iframe\\2&gt;",
        				"(<|%3c|%253c).*?style(.*?)(>|%3e|%0e)"			=>	"&lt;style\\2&gt;",	
        				"(<|%3c|%253c)form(.*?)(>|%3e|%0e)"				=>	"&lt;form\\2&gt;",	
						"(%3c|%253c)img%20(.+?)(%3e|%0e)"				=>	"&lt;img&nbsp;\\2&gt;",
						"(%3c|%253c)font%20+(.+?)(%3e|%0e)"				=>	"&lt;font&nbsp;\\2&gt;",
        				"<(.*?)textarea(.*?)>"							=>	"&lt;\\2textarea\\3&gt;",	       				
						"<!--"											=>	"&lt;!--",
						"-->"											=>	"--&gt;",
						"%20"											=>	" ",
						"%2527"											=>	"&apos;",	// '
						"%27"											=>	"&apos;",	// '
						"%22"											=>	"&quot;",	// "
						"%3c"											=>	"&lt;",		// <
						"%5B"											=>	"&91;",		// [
						"%5D"											=>	"&93;",		// ]
						"%253c"											=>	"&lt;",		// <
						"%3e"											=>	"&gt;",		// >
						"%0e"											=>	"&gt;",		// >
						"%28"											=>	"&#40;",	 // (  
						"%29"											=>	"&#41;",	 // ) 
						"%2528"											=>	"&#40;",	 // (
						"%26"											=>	"&amp;",	 // &
						"%24"											=>	"&#36;",	 // $
						"%3f"											=>	"&#63;",	 // ?
						"%3b"											=>	"&#59;",	 // ;
						"%3d"											=>	"&#61;",	 // =
						"passthru\("									=>	"passthru&#40;",
						"exec\("										=>	"exec&#40;",
						"system\("										=>	"system&#40;"
        			);
        			
        foreach ($bad as $key => $val)
        {
			$str = preg_replace("#".$key."#si", $val, $str);   
        }
        
		return $str;
     }           
	// END
	
	// -------------------------------------------------
    //   Sanitize URL Data
    // -------------------------------------------------
	
	function sanitize_get($str)
	{
		if (preg_match("#(;|exec\(|system\(|passthru\(|cmd\()#i", $str))
		{
			exit('Invalid GET Data');
		}

		$bad	= array('$', '(', ')', '%28', '%29', ';');
		$good	= array('&#36;', '&#40;', '&#41;', '&#40;', '&#41;', '&#59;');
	
		return str_replace($bad, $good, $str);
	}
	// END
	
	// -------------------------------------------------
    //   Sanitize GET, POST, COOKIE Keys
    // -------------------------------------------------
	
	function sanitize_keys($str)
	{
		if ( ! eregi("^[A-Za-z0-9\_\/\-]+$", $str))
		{
			exit('Disallowed Characters in your global keys');
		}
		
		return $str;
	}
	// END
	
	// -------------------------------------------------
    //   Random number/password generator
    // -------------------------------------------------
    
    function random($type = 'encrypt', $len = 8)
    {
        if ($this->seed == FALSE)
        {
            if (phpversion() >= 4.2)
                mt_srand();
            else
                mt_srand(hexdec(substr(md5(microtime()), -8)) & 0x7fffffff);
            
            $this->seed = TRUE;
        }
                        
        switch($type)
        {
            case 'basic'	: return mt_rand();  
              break;
            case 'alpha'	:
            case 'numeric'	:
            
					$pool = ($type == 'alpha') ? "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ" : "0123456789";

					$str = '';
                
                    for ($i=0; $i < $len; $i++) 
                    {    
                        $str .= substr($pool, mt_rand(0, strlen($pool) -1), 1); 
                    }
                    return $str;      
              break;
            case 'md5'		: return md5(uniqid(mt_rand())); 
              break; 
            case 'encrypt'	: return md5(uniqid(mt_rand())); 
              break; 
        }        
    }
    // END
    

    // -------------------------------------------------
    //   JavaScript for Secure Hashes
    // -------------------------------------------------
    
    function security_hash_js($pre='n')
    {
    	$js = '';
    	
    	if ($this->javascript_hash !== true)
    	{
    		return $js;
    	}
    	
    	if ($pre == 'n')
    	{
    		return "onsubmit=\"check{$this->hashes}('valid{$this->hashes}_hash',6);\"";
    	}
    		
    	// ---------------------------------
    	//  Obfuscates the field name hash
    	// ---------------------------------
    	
    	if ( ! function_exists('str_split'))
    	{
    		@preg_match_all('/.{1,1}/s', strrev($this->security_hash_name()), $matches);
    		$code = (isset($matches['0']) && sizeof($matches['0']) > 0) ? $matches['0'] : array();
    	}
    	else
    	{
    		$code =& str_split(strrev($this->security_hash_name()));
    	}
    	
    	$js_code	= 'var l=new Array();';
    	$this->hashes++;
    	
    	for($i=0; $i < sizeof($code); $i++)
		{
			$js_code .= "l[{$i}]='{$code[$i]}';";
		}
    		
    	$js = <<<EOT

function valid{$this->hashes}(x)
{
	var input = '';
	{$js_code}
	for (var i = l.length-1; i >= 0; i=i-1)
	{
		input += unescape(l[i]);
	}
	document.getElementById(x+'{$this->hashes}').name = input; 
	return true;
}

function check{$this->hashes}(x,y)
{
	var o="",t="";
	for(i=0; i < y; i+=1) {o+=x.charAt(i)};
	for(i=y+1; i < y+5; i++) {t+=x.charAt(i)};
	o+="('"+t+"');";
	s=eval(o);
	return s;
}
EOT;
		
		$js =& preg_replace("|\s+|",' ', $js);
		
		$js = '<script type="text/javascript">'."\r\n<!--\r\n".$js."\r\n-->\r\n</script>";
    	
    	return $js."\r\n";
    	
    }
    // END
    
    // -------------------------------------------------
    //   Create Form Field for Security Hash
    // -------------------------------------------------
    
    function security_hash_field()
    {
    	// ----------------------------------------------------
    	//  Default Layouts - Harder for Spammers to Parse 
    	// ----------------------------------------------------
    	
    	$fields = array();
    	$fields[] = '<input type="hidden" name="'.$this->security_hash_name().'" value="'.$this->security_hash().'" />'."\r\n";
    	$fields[] = "\r\n".'<input type="hidden" value="'.$this->security_hash().'" name="'.$this->security_hash_name().'" />'."\r\n";
    	$fields[] = '<input name="'.$this->security_hash_name().'" type="hidden" value="'.$this->security_hash().'" />'."\r\n";
    	$fields[] = '<input type="hidden" name="'.$this->security_hash_name().'" value="'.$this->security_hash().'" onblur="javascript:history.go(-1)" />'."\r\n";
    	
    	// -------------------------------------
    	//  Even More Complicated, Requires JS
    	// -------------------------------------
    	
    	if ($this->javascript_hash === true)
    	{
    		$fields		= array();
    		$hash		= $this->security_hash();    		
			
			$fields[] = '<input type="hidden" id="hash'.$this->hashes.'" name="hash" value="'.$hash.'" />'."\r\n";
		}    	
    	
    	$i = rand(0,sizeof($fields)-1);
    	
    	return $fields[$i];
    }
    // END


    // -------------------------------------------------
    //   Create Form Hash NAME 
    // -------------------------------------------------
    
    function security_hash_name($other='n')
    {
    	global $SHARED;
    	
    	$day		= date('l',$SHARED->get_offset_time());
    	$hour		= date('G', $SHARED->get_offset_time());
    	$adminemail	= substr($SHARED->get_pref('adminemail'), 0,5);
    
    	if ($other == 'y')
    	{
    		if ($hour - 1 < 0)
    		{
    			$hour = 23;
    			$day  = date('l',$SHARED->get_offset_time()-(60*60*1));
    		}
    		else
    		{
    			$hour--;
    		}
    	}
    		
    	$name =& md5("{$adminemail}{$day}{$hour}{$SHARED->IP}");
    	
    	return $name;
    }
    // END

    
    // -------------------------------------------------
    //   Create Form Hash
    // -------------------------------------------------
    
    function security_hash()
    {
    	global $db_security_hashes, $DB;
    	
    	$hash = $this->random();
    	
    	$query = new DB_query($DB, "INSERT INTO $db_security_hashes (date, ip_address, hash) 
    								VALUES (UNIX_TIMESTAMP(), '".get_ipaddress()."', '".$hash."')");
    	
    	return $hash;
    }
    // END
    
    
	// -------------------------------------------------
    //   Check Form Hash
    // -------------------------------------------------
    
    function check_hash($delete = true)
    {    
    	global $db_security_hashes, $DB;
    	
    	// ------------------------------
    	//  Valid Form Names for Hash
    	// ------------------------------
    	
    	$var1 = $this->security_hash_name();  
    	$var2 = $this->security_hash_name('y');
    	
    	if ( ! isset($_POST[$var1]) && !isset($_POST[$var2]))
    	{
    		return false;
    	}
    	
    	$var = ( ! isset($_POST[$var1])) ? $var2 : $var1;
    	
    	// ------------------------------
    	//  Check for Hash in Database
    	// ------------------------------
    	
    	$query = new DB_query($DB, "DELETE FROM $db_security_hashes WHERE date < UNIX_TIMESTAMP()-7200");
    	
    	$query = new DB_query($DB, "SELECT COUNT(*) AS count FROM $db_security_hashes 
    								WHERE ip_address = '".get_ipaddress()."'
    								AND hash = '".$DB->escape_str($_POST[$var])."'");
    								
    	$query->db_fetch_array();
		
		if ($query->row['count'] > 0)
		{
			// By making delete false, we can allow things like
			// searches to happen multiple times.
			if ($delete == true)
			{
				$query = new DB_query($DB, "DELETE FROM $db_security_hashes
										 	WHERE hash = '".$DB->escape_str($_POST[$var])."'");
			}
										 
			return true;
		}
		
    	return false;
    }
    // END
    
    
    // -------------------------------------------------
    //   Create Captcha
    // -------------------------------------------------
    
	function create_captcha($old_word = '')
	{
		global $DB, $SHARED, $pm_path, $db_captchas, $sfx;
			
		$img_path	= $SHARED->get_pref('captcha_relative', 1);
		$img_url	= $SHARED->get_pref('captcha_full_url', 1);
		$use_font	= ($SHARED->get_pref('captcha_truetype') == 'y') ? TRUE : FALSE;
		
		$font_face	= "texb.ttf";
		$font_size	= 16;
		
		$expiration = 60*60*2;  // 2 hours
		
		$img_width	= 140;	// Image width
		$img_height	= 30;	// Image height	
				
		if ($img_path == '' || $img_url == '')
		{
			return false;
		}

		if ( ! is_dir($img_path)) 
		{
			return false;
		}
		
        if ( ! is_writable($img_path))
        {
			return false;
		}
		
		if ( ! file_exists("{$pm_path}captcha/words$sfx"))
        {
			return false;
		}
		
		if ( ! extension_loaded('gd'))
		{
			return false;
		}
		
		if ( ! ereg("/$", $img_url)) $img_url .= '/';
				
		
		// -----------------------------------
		// Remove old images	
		// -----------------------------------
		
		// We are using time() instead of MySQL's UNIX_TIMESTAMP() for the very,
		// very rare instance where the database is on a separate server in a 
		// separate time zone. - Buddha
		
		$query = new DB_query($DB, "DELETE FROM $db_captchas WHERE date < '".(time()-$expiration)."'");		
		
		list($usec, $sec) = explode(" ", microtime());
		$now = ((float)$usec + (float)$sec);
				
        $current_dir = @opendir($img_path);
        
        while($filename = @readdir($current_dir))
        {        
			if ($filename != "." and $filename != ".." and $filename != "index.html")
            { 
            		$name = str_replace(".jpg", "", $filename);
            
				if (($name + $expiration) < $now)
				{
					@unlink($img_path.$filename);
				}
            }
        }
        
        @closedir($current_dir);
	
		// -----------------------------------
		//  Fetch and Insert "The Word"
		// -----------------------------------
	
		if ($old_word == '')
		{
			require "{$pm_path}captcha/words$sfx";
			$word = $words[array_rand($words)];
			
			if ($SHARED->get_pref('captcha_random_numbers') == 'yes')
			{
				$nums = rand(0,99);
				$word .= (strlen($nums) == '1') ? "0{$nums}" : "$nums";
			}

			$query = new DB_query($DB, "INSERT INTO $db_captchas (date, ip_address, word) VALUES ('".time()."', '".$SHARED->IP."', '$word')");		
		}
		else
		{
			$word = $old_word;
		}
		
		$this->cached_captcha = $word;
		
 		// -----------------------------------
		// Determine angle and position	
		// -----------------------------------
		
		$length	= strlen($word);
		$angle	= ($length >= 6) ? rand(-($length-6), ($length-6)) : 0;
		$x_axis	= rand(6, (360/$length)-16);			
		$y_axis = ($angle >= 0 ) ? rand($img_height, $img_width) : rand(6, $img_height);
		
		// -----------------------------------
		// Create image
		// -----------------------------------
				
		$im = ImageCreate($img_width, $img_height);
				
		// -----------------------------------
		//  Assign colors
		// -----------------------------------
		
		$bg_color		= ImageColorAllocate($im, 255, 255, 255);
		$border_color	= ImageColorAllocate($im, 153, 102, 102);
		$text_color		= ImageColorAllocate($im, 120, 123, 131);
		$grid_color		= imagecolorallocate($im, 255, 204, 204);
		$shadow_color	= imagecolorallocate($im, 255, 240, 240);

		// -----------------------------------
		//  Create the rectangle
		// -----------------------------------
		
		ImageFilledRectangle($im, 0, 0, $img_width, $img_height, $bg_color);
		
		// -----------------------------------
		//  Create the spiral pattern
		// -----------------------------------
		
		$theta		= 1;
		$thetac		= 6;  
		$radius		= 12;  
		$circles	= 20;  
		$points		= 36;

		for( $i = 0; $i < ($circles * $points) - 1; $i++) 
		{
			$theta = $theta + $thetac;
			$rad = $radius * ($i / $points );
			$x = ($rad * cos($theta)) + $x_axis;
			$y = ($rad * sin($theta)) + $y_axis;
			$theta = $theta + $thetac;
			$rad1 = $radius * (($i + 1) / $points);
			$x1 = ($rad1 * cos($theta)) + $x_axis;
			$y1 = ($rad1 * sin($theta )) + $y_axis;
			imageline($im, $x, $y, $x1, $y1, $grid_color);
			$theta = $theta - $thetac;
		}
		
    	// imageline($im, $img_width, $img_height, 0, 0, $grid_color);
		
		// -----------------------------------
		//  Write the text
		// -----------------------------------
		
		$font_path = "{$pm_path}captcha/".$font_face;
		
		if ($use_font == TRUE)
		{
			if ( ! file_exists($font_path))
			{
				$use_font = FALSE;
			}		
		}
				
		if ($use_font == FALSE)
		{
			$font_size = 8;
			ImageString($im, $font_size, $x_axis, $img_height/3.8, $word, $text_color);
		}
		else
		{
			imagettftext($im, $font_size, $angle, $x_axis, $img_height/1.5, $text_color, $font_path, $word);
		}

		// -----------------------------------
		//  Create the border
		// -----------------------------------

		imagerectangle($im, 0, 0, $img_width-1, $img_height-1, $border_color);		

		// -----------------------------------
		//  Generate the image
		// -----------------------------------
		
		$img_name = $now.'.jpg';

		ImageJPEG($im, $img_path.$img_name);
		
		$img = "<img src=\"$img_url$img_name\" width=\"$img_width\" height=\"$img_height\" border=\"0\" alt=\" \" />";
		
		ImageDestroy($im);
		
		return $img;
	}
	// END
    


} // END Security Class
	
?>
