<?php
//
// pMachine Publishing Software
//
// Version 2.4 (Pro2.4.004)
//
// Copyright (c) 2003 - 2005 pMachine, Inc.
//
// THIS IS COPYRIGHTED SOFTWARE
//
// License holders may alter or modify this software for their own use, 
// but may NOT resell or redistribute the modified or derivative version 
// without prior written consent from pMachine.  Components from this 
// software may not be extracted and used in other programs without prior 
// written consent from pMachine.
//
// PLEASE READ THE LICENSE AGREEMENT
//


class Shared {

	var $prefs			= array();		// Array of retrieved prefs
	var $offset_time	= '';			// Offset time
	var $templates		= array();		// Array of retrieved templates
	var $IP				= '';			// IP Address of User
	

	// ----------------------------------------
	//  Constructor
	// ----------------------------------------
	
	function Shared()
	{
		//-----------------------------------
		// Fetch the IP address
		//-----------------------------------
        
		$CIP = (isset($_SERVER['HTTP_CLIENT_IP']) AND $_SERVER['HTTP_CLIENT_IP'] != "") ? $_SERVER['HTTP_CLIENT_IP'] : FALSE;
		$RIP = (isset($_SERVER['REMOTE_ADDR']) AND $_SERVER['REMOTE_ADDR'] != "") ? $_SERVER['REMOTE_ADDR'] : FALSE;
		$FIP = (isset($_SERVER['HTTP_X_FORWARDED_FOR']) AND $_SERVER['HTTP_X_FORWARDED_FOR'] != "") ? $_SERVER['HTTP_X_FORWARDED_FOR'] : FALSE;
                    
		if ($CIP && $RIP)	$this->IP = $CIP;	
		elseif ($RIP)		$this->IP = $RIP;
		elseif ($CIP)		$this->IP = $CIP;
		elseif ($FIP)		$this->IP = $FIP;
		
		if (strstr($this->IP, ','))
		{
			$this->IP = end(explode(',', $this->IP));
		}
	
		if ( ! preg_match( "/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/", $this->IP))
		{
			$this->IP = '0.0.0.0';
		}
	}
	// END


	// ---------------------------------------------------
	//	GET PREFERENCE, 3rd Parameter is for a Default
	// ---------------------------------------------------

	function get_pref($which, $tslash=0, $pref='') 
	{
		global $db_prefs, $DB;
		
		if (isset($this->prefs[$which]))
		{
			$pref = $this->prefs[$which];
		}
		else
		{
			$query = new DB_query($DB, "SELECT pm_value FROM $db_prefs WHERE pm_option = '".$DB->escape_str($which)."'");
	
			if ($query->db_num_rows() > 0) 
			{
			    $query->db_fetch_object();
	    		
	    		$pref = (get_magic_quotes_runtime()) ? stripslashes($query->obj->pm_value) : $query->obj->pm_value;
	    		
	    		$this->prefs[$which] = $pref;
	    	}
	    }
	    
	    if ($tslash == 1 && substr($pref, -1) != '/')
	    {
	    	$pref .= '/';
	    }	    
	    
	    return $pref;
	}
	// END


	//	----------------------------------------------
	//		GET TEMPLATE
	//	----------------------------------------------

	function get_template($category,$id)
	{
	    global $db_templates, $DB;
	    
	    $tcategory = ($category == '') ? 'none' : $category;
	    
	    if (isset($this->templates[$tcategory][$id]))
	    {
	    	$tmpl = $this->templates[$tcategory][$id];
	    }
	    else
	    {
		    $query = new DB_query($DB, "SELECT body FROM $db_templates 
		    							WHERE cat_name = '".$DB->escape_str($category)."' 
		    							AND template_id = '".$DB->escape_str($id)."'"); 
		    							
	    	$query->db_fetch_object();
	    	$tmpl = (get_magic_quotes_runtime()) ? stripslashes($query->obj->body) : $query->obj->body;
	    	
	    	$this->templates[$tcategory][$id] = $tmpl;
		}
		
	    return $tmpl;
	}
	// END


	//	----------------------------------------------
	//		CALCULATE TIME OFFSET
	//	----------------------------------------------

	function get_offset_time()
	{          		
		if ($this->offset_time != '')
		{
			return $this->offset_time;
		}
	
	    $time = $this->get_pref("timeoffset");
	
	    $now = time(); 
	    
	    if ($time == "+0")
	    {
	        return $now;
		}
		
	    $operator = substr ($time ,0,1);
	    $offset   = (substr ($time ,1) * 3600);
	
	    if ($operator == "-")
	    {
	        $ntime = ($now - $offset);
	    }
	    else
	    {
	        $ntime = ($now + $offset); 
	    }
	
	    return $ntime;
	}
	// END



	//	----------------------------------------------
	//		SHOW BULLETS INSTEAD OF STRING
	//	----------------------------------------------
	
	function bullets($str) 
	{		
	    $bullets = "";
	    $bullet = "&#8226;";
	    $len = strlen($str);
	    
	    for ($i=0; $i < $len; $i++) 
	    {
	       $bullets .= $bullet ;
	    }
	  
	    return $bullets;
	}
	// END
	
}
// END Shared Class
?>