<?php
//
// pMachine Publishing Software
//
// Version 2.4 (Pro2.4.004)
//
// Copyright (c) 2003 - 2005 pMachine, Inc.
//
// THIS IS COPYRIGHTED SOFTWARE
//
// License holders may alter or modify this software for their own use, 
// but may NOT resell or redistribute the modified or derivative version 
// without prior written consent from pMachine.  Components from this 
// software may not be extracted and used in other programs without prior 
// written consent from pMachine.
//
// PLEASE READ THE LICENSE AGREEMENT
//



//	----------------------------------------------
//		PING WEBLOGS.COM
//	----------------------------------------------

function ping_weblogs($weblog, $server,$port=80)
{
	global $SHARED;
	
    $url  = $SHARED->get_pref("pages_path_abs_$weblog","1");
    $url .= $SHARED->get_pref("$weblog"."_page");
    
    $sitename = stripslashes($SHARED->get_pref("ping_name_$weblog"));

	if (!$sitename OR $sitename == '')
	{
		$sitename = stripslashes($SHARED->get_pref("sitename"));
		
		if ($sitename == '')
		{
			return false;
		}
	}
        
	// ----------------------------
	//  Parse Server
	// ----------------------------
    
	if (substr($server, 0, 4) != "http") $server = "http://".$server; 
    
    $parts = parse_url($server);
    	
    $path = ( ! isset($parts['path'])) ? '' : $parts['path'];
    	
    if ($path == "/RPC2/")
    {
    	$path = "/RPC2";
    }
    
	// ----------------------------
	//  Send Ping
	// ----------------------------

	$client = new xmlrpc_client($path,$parts['host'],$port);
	$client->setDebug(0);

	$message = new xmlrpcmsg('weblogUpdates.ping',array(
			   new xmlrpcval($sitename),
			   new xmlrpcval($url)));
	
    if ( ! $result = $client->send($message))
        return false;
		
	if (!$result->value())
	{
		return false;
	}
	else
	{
		if ($result->faultCode())
		{
			return false;
		}
		else
		{
			return true;
		}
	}
}
// END



// ----------------------------------------------
//      SEND PINGBACK 
// ----------------------------------------------

// Function that is called when you want to PingBack
// For pMachine: pingback($body,$post_id)
// Tried to follow the standard found here:
// http://www.hixie.ch/specs/pingback/pingback

function pingback($content,$post_id) {

	global $db_weblog, $db_pingback, $DB, $SHARED;

	// Variables
	$ltrs = "\w";
	$gunk = "/#~:.?+=&%@!\-";
	$punc = ".:?\-";
	$any = $ltrs.$gunk.$punc;
	$pingback_str_dquote = 'rel="pingback"';
	$pingback_str_squote = "rel=\"pingback\"";
	$x_pingback_str = "x-pingback: ";
	$pingback_href_original_pos = 27;
	
	// Step 1
	// Parsing the post, external links (if any) are stored in the $post_links array
	// Code for parsing from www.phpfreaks.com
	
	$post_links = array();
	preg_match_all("{\b http : [$any] +? (?= [$punc] * [^$any] | $)}x", $content, $post_links_temp);


	
	// Step 2
	// Walking thru the links array
	// first we get rid of links pointing to sites, not to specific files
	// Example:
	// http://www.website.org
	// http://www.website.org/
	// http://www.website.org/post.php
	// We don't wanna ping first and second types, even if they have a valid <link/>

	foreach($post_links_temp[0] as $link_test) {
		$test = parse_url($link_test);
		if (isset($test['query'])) {
			$post_links[] = $link_test;
		} elseif(($test['path'] != "/") && ($test['path'] != "")) {
			$post_links[] = $link_test;
		}
	}
	
	$links_string = " empty";
	
	// PINGBACK URL SEARCH AND PING
	//
	// Checks that this is an actual page
	// Checks for duplicate links
	// Checks to insure that there is a host name for us.
	// Builds path for both perl and PHP
	// Sets port number
	// Searches for PingBack URL
	// Sends PingBack
	
	foreach ($post_links as $pagelinkedto) {
		
		if(!$valid = @fopen($pagelinkedto,"r")) 
			continue;
		
		if(stristr($links_string,$pagelinkedto))
			continue;
			
			
		$links_string .= " ".$pagelinkedto;
			
		$bits = parse_url($pagelinkedto);
		
		if (!isset($bits['host'])) 
			continue;
		
		$host = $bits['host'];
		$path = isset($bits['path']) ? $bits['path'] : "";
		if (isset($bits['query'])) {
			$path .= '?'.$bits['query'];
		}
		if (!$path) {
			$path = "/";
		}
		$port = isset($bits['port']) ? $bits['port'] : 80;

		// Try to connect to the server at $host
		
		$fp = fsockopen($host, $port, $errno, $errstr, 30);
		if (!$fp) {
			continue;
		}
		
		$link = "http://" . $host . $path;
		
		// Send the GET request
		$version = "pMachine ";
		$version .= $SHARED->get_pref("version") . $SHARED->get_pref("vnumber");
		
		$request = "GET $path HTTP/1.1\r\nHost: $host\r\nUser-Agent: $version PHP/" . phpversion() . "\r\n\r\n";
		// ob_end_flush();
		fputs($fp, $request);

		// Start receiving headers and content
		// Grabs file and searches for pingback link in document
		// If that is not found, we convert the headers to lowercase.
		// Then, we start searching the headers for a X-PingBack header
		// Ex.  X-Pingback: http://charlie.example.com/pingback/xmlrpc 
		// Sets $pingback_server_url
		// This might need to be cleaned up a bit, I think
		$contents = "";
		$headers = "";
		$gettingHeaders = true;
		$found_pingback_server = 0;
		while (!feof($fp)) {
			$line = fgets($fp, 4096);
			if (trim($line) == '') {
				$gettingHeaders = false;
			}
			if (!$gettingHeaders) {
				$page = implode("", file($link)); 
				// look for a pingback link and return it if found. 
				if (eregi('<link rel="pingback" href="([^"]+)', $page, $match)) {
					$pingback_server_url = trim($match[1]); 
					$found_pingback_server = 1;
				}
				break;
			} else {
				$headers .= trim($line)."\n";
				$x_pingback_header_offset = strpos(strtolower($headers), $x_pingback_str);
			}
			if ($x_pingback_header_offset) {
				preg_match("#x-pingback: (.+)#is", $headers, $matches);
				$pingback_server_url = trim($matches[1]);
				$found_pingback_server = 1;
				break;
			}
			
		}
		
		
		
		if ($found_pingback_server == 0) {
			@fclose($fp);
		} else {
			// Break down URL into parts
			
			$parts = parse_url($pingback_server_url); 

			$host = $parts['host'];
			
			$port = isset($parts['port']) ? $parts['port'] : 80; 
			
			$path = isset($parts['path']) ? $parts['path'] : "/"; 
			
			$res1 = new DB_query($DB, "select weblog from $db_weblog where post_id = '$post_id'"); 
			$res1->db_fetch_object();
        	$weblog = $res1->obj->weblog;
        	$wpath = $SHARED->get_pref("pages_path_abs_".$weblog);

			if (!eregi('/$',$wpath)) $wpath = "$wpath" . "/";
		
			$wpage = $SHARED->get_pref($weblog."_page");
			$pagelinkedfrom = $wpath . $wpage ."?id=P".$post_id;
        	
        				
			 //
			 // Now, the RPC call ---> Quite important here!
			 //
			 
			$method = "pingback.ping";
			
			$client = new xmlrpc_client($path, $host, 80);
			//$client->setDebug(2);
			
			$message = new xmlrpcmsg($method,array(new xmlrpcval($pagelinkedfrom),new xmlrpcval($pagelinkedto)));
			
			$result = $client->send($message);
		
		if ($result){
				if (!$result->value()){
					// echo $result->faultString();
					// echo "<br />";
				} 
				else {
					$value = decode_xmlrpc($result->value());
					
					if (is_array($value)) {
						$value_arr = "";
						foreach($value as $blah) {
							$value_arr .= $blah." \r\n ";
						}
						// Testing
						//echo $value_arr."<br />";
					} else {
						// Testing
						// echo $value."<br />";
					}
				}
			}
			@fclose($fp);
		}
		
		// End of else above	
		
	}
	
	// End of sending URLS

}
// END
?>