<?php
//
// pMachine Publishing Software
//
// File Name: xml_rpc_fns.php
//
// Description: XML-RPC function library.
//
// Copyright (c) 2003 - 2005 pMachine, Inc.
//
// THIS IS COPYRIGHTED SOFTWARE
//
// License holders may alter or modify this software for their own use, 
// but may NOT resell or redistribute the modified or derivative version 
// without prior written consent from pMachine.  Components from this 
// software may not be extracted and used in other programs without prior 
// written consent from pMachine.
//
// PLEASE READ THE LICENSE AGREEMENT
//



//	-----------------------------------------
//		BLOGGER API: getUserInfo
//	-----------------------------------------

function blogger_getUserInfo($params)
{
	global $db_members, $L_ERROR, $DB;
 
	$plist = decode_parameters($params);
  
    $sql = "select * 
            from $db_members 
            where username = '$plist[1]' 
            and password = '".md5($plist[2])."'"; 
            
    $query = new DB_query($DB, $sql);

	$query->db_fetch_array();
    
	if ($query->row['status'] < 7)
	{
		return new xmlrpcresp(0,$xmlrpcerruser + 2, $L_ERROR['230']);
	}

 	$member = new xmlrpcval(array(
		"nickname" => new xmlrpcval($query->row['signature'],"string"),
		"userid" => new xmlrpcval($query->row['member_id'],"string"),
		"url" => new xmlrpcval($query->row['url'],"string"),
		"email" => new xmlrpcval($query->row['email'],"string"),
		"lastname" => new xmlrpcval("","string"),
		"firstname" => new xmlrpcval("","string")),'struct');
	
	return new xmlrpcresp($member);
}
// END


//	-----------------------------------------
//		BLOGGER API: getUsersBlogs
//	-----------------------------------------

function blogger_getUsersBlogs($params)
{
	global $db_multiweblogs, $L_ERROR, $DB, $SHARED;
 
	$plist = decode_parameters($params);
	
	$access = user_access($plist['1'],$plist['2']);
 
    $sql = "select id,weblog from $db_multiweblogs ";
 
	if ($access == 0)
	{
		return new xmlrpcresp(0,$xmlrpcerruser + 2, $L_ERROR['230']);
	}
	elseif ($access == 1)
	{
		$sql .= " where weblog = '".get_default_weblog($plist['1'],$plist['2'])."'";
	}
    
	$sql .= " order by weblog"; 
	
    $query = new DB_query($DB, $sql);
 
 	$siteurl = $SHARED->get_pref("siteurl");

	$bloglist = array();
	
	while ($query->db_fetch_array()) 
	{
		$weblog = $query->row['weblog'];
		$id = $query->row['id'];
		
		if (magic_quotes_runtime())
			$weblog = stripslashes($weblog);
	
		$weblogs = new xmlrpcval(array(
		"url" => new xmlrpcval($siteurl,"string"),
		"blogid" => new xmlrpcval($id,"string"),
		"blogName" => new xmlrpcval($weblog,"string")),'struct');
		
		array_push($bloglist, $weblogs);
	}
	
 	return new xmlrpcresp(new xmlrpcval($bloglist,"array"));
}
// END



//	-----------------------------------------
//		BLOGGER API: newPost
//	-----------------------------------------

function blogger_newPost($params)
{
	global $db_weblog, $db_multiweblogs, $db_categories, $L_ERROR, $DB;
	global $SHARED, $db_ping_servers;
 
	$plist	= decode_parameters($params);
		
	$access = user_access($plist['2'],$plist['3']);
 
	if ($access == 0)
	{
		return new xmlrpcresp(0,$xmlrpcerruser + 2, $L_ERROR['230']);
	}
	
	$weblog = get_weblog($plist['1']);
	$memid  = get_mbr_id($plist['2'],$plist['3']);
    
    
    $query = new DB_query($DB,"select count(*) as count
    						from $db_multiweblogs 
    						where weblog = '$weblog'");
	    							    						
    $query->db_fetch_array();
    if ($query->row['count'] == 0)
        return new xmlrpcresp(0,$xmlrpcerruser + 2,"You are attempting to submit this entry into a non-existant weblog.");

    unset($query);
    
	$t_stamp = $SHARED->get_offset_time();
	$month	 = date("m",$t_stamp);    
	$year    = date("Y",$t_stamp); 
	$day     = date("d",$t_stamp);
	
	if ($plist['5']==1)
	{
		$status = "open";
	}
	else
	{
		$status = "closed";
	}
		
	$clean	   = addslashes($plist['4']);
	$title	   = stripslashes(get_title($clean));
	$body	   = stripslashes(get_body($clean));
	$blurb	   = stripslashes(get_chunk($clean,"blurb"));
	$more	   = stripslashes(get_chunk($clean,"more"));
	$custom1   = stripslashes(get_chunk($clean,"custom1"));
	$custom2   = stripslashes(get_chunk($clean,"custom2"));
	$custom3   = stripslashes(get_chunk($clean,"custom3"));
	$category  = stripslashes(get_chunk($clean,"category"));
	$brBlurb   = stripslashes(get_chunk($clean,"brBlurb"));
	$brBody	   = stripslashes(get_chunk($clean,"brBody"));
	$brMore	   = stripslashes(get_chunk($clean,"brMore"));
	$brCustom1 = stripslashes(get_chunk($clean,"brCustom1"));
	$brCustom2 = stripslashes(get_chunk($clean,"brCustom2"));
	$brCustom3 = stripslashes(get_chunk($clean,"brCustom3"));
	$tstatus   = stripslashes(get_chunk($clean,"status"));
	
	if ($tstatus != "")
	{
		if ($tstatus == "open" | "closed")
			$status = $tstatus;
	}	
	
		if ($brBlurb =="") $brBlurb = 1;
	elseif ($brBlurb != 0 && $brBlurb !=1) $brBlurb =1;
	
		if ($brBody =="") $brBody = 1;
	elseif ($brBody != 0 && $brBody !=1) $brBody =1;
	
		if ($brMore =="") $brMore = 1;
	elseif ($brMore != 0 && $brMore !=1) $brMore =1;
	
		if ($brCustom1 =="") $brCustom1 = 1;
	elseif ($brCustom1 != 0 && $brCustom1 !=1) $brCustom1 =1;
	
		if ($brCustom2 =="") $brCustom2 = 1;
	elseif ($brCustom2 != 0 && $brCustom2 !=1) $brCustom2 =1;
	
		if ($brCustom3 =="") $brCustom3 = 1;
	elseif ($brCustom3 != 0 && $brCustom3 !=1) $brCustom3 =1;
			
	if ($category != "")
	{
	    $cat_array = array();
	    
	    $query = new DB_query($DB,"select id,category 
	    						from $db_categories 
	    						where weblog = '$weblog' 
	    						order by id");
	    							    						
	     while ($query->db_fetch_array())
	     {
	            $cat_array[$query->row['category']] = $query->row['id'];
	     }      
		
		$catid = $cat_array[$category];
		
		unset($query);
	}
	
    
    if ($SHARED->get_pref("auto_format_HTML_$weblog") == "yes") 
    {
            $title = pmcode_basic_encode($title);
                
        if ($blurb   <> "") $blurb   = pmcode_basic_encode($blurb);
        if ($body    <> "") $body    = pmcode_basic_encode($body);
        if ($more    <> "") $more    = pmcode_basic_encode($more);
        if ($custom1 <> "") $custom1 = pmcode_basic_encode($custom1);
        if ($custom2 <> "") $custom2 = pmcode_basic_encode($custom2);
        if ($custom3 <> "") $custom3 = pmcode_basic_encode($custom3);
    } 
    if ($SHARED->get_pref("auto_format_URLS_$weblog") == "yes") 
    {
            $title = pmcode_url_encode($title);
                
        if ($blurb   <> "") $blurb   = pmcode_url_encode($blurb);
        if ($body    <> "") $body    = pmcode_url_encode($body);
        if ($more    <> "") $more    = pmcode_url_encode($more);
        if ($custom1 <> "") $custom1 = pmcode_url_encode($custom1);
        if ($custom2 <> "") $custom2 = pmcode_url_encode($custom2);
        if ($custom3 <> "") $custom3 = pmcode_url_encode($custom3);
    } 
    if ($SHARED->get_pref("auto_format_IMGS_$weblog") == "yes") 
    {
            $title = pmcode_img_encode($title);
                
        if ($blurb   <> "") $blurb   = pmcode_img_encode($blurb);
        if ($body    <> "") $body    = pmcode_img_encode($body);
        if ($more    <> "") $more    = pmcode_img_encode($more);
        if ($custom1 <> "") $custom1 = pmcode_img_encode($custom1);
        if ($custom2 <> "") $custom2 = pmcode_img_encode($custom2);
        if ($custom3 <> "") $custom3 = pmcode_img_encode($custom3);
    }    
         	        
    if(!get_magic_quotes_gpc()) 
    {
        $title   = addslashes($title);
        $blurb   = addslashes($blurb);
        $body    = addslashes($body);
        $more    = addslashes($more);
        $custom1 = addslashes($custom1);
        $custom2 = addslashes($custom2);
        $custom3 = addslashes($custom3);
        $weblog  = addslashes($weblog);
    }
    
	$zip = "0";

 
    $sql = "insert into $db_weblog 
           (post_id, 
           member_id, 
           t_stamp, 
           title, 




		   blurb, 
           body, 
           more,
           custom1,
           custom2,
           custom3, 
           status, 
           weblog,
           category,
           preview, 
           year,
           month, 
           day,
           nl2brBlurb,
           nl2brBody,
           nl2brMore,
           nl2brC1,
           nl2brC2,
           nl2brC3)
    values ('', 


           '$memid', 
           '$t_stamp',
           '$title',
           '$blurb',
           '$body',
           '$more',
           '$custom1',
           '$custom2',
           '$custom3',
           '$status',
           '$weblog',
           '$catid',
           '$zip',
           '$year',
           '$month',
           '$day',
           '$brBlurb',
           '$brBody',
           '$brMore',
           '$brCustom1',
           '$brCustom2',
           '$brCustom3')"; 
           
    $query = new DB_query($DB, $sql);
    
    unset($query);

    if ($SHARED->get_pref("rss_on_weblog") == "yes")
    {
        if (write_rss() == false)
		return new xmlrpcresp(0,$xmlrpcerruser + 2,"Unable to write data to your RSS file.");
    }

    if (($SHARED->get_pref("ping_$weblog") == "yes") && ($status =="open"))
    {
    	$query = new DB_query($DB, "SELECT server_name, server_url, server_port FROM $db_ping_servers WHERE server_default='y')");
			
		$bad_pings = array();	
		
		if ($query->db_num_rows() > 0)
		{
			while($query->db_fetch_array())
			{
				if (!ping_weblogs($weblog, $query->row['server_url'], $query->row['server_port']))
				{
					$bad_pings[] = $query->row['server_name'];
				}
			}			
		}
			
        if (sizeof($bad_pings) > 0)
        {
			return new xmlrpcresp(0,$xmlrpcerruser + 2,"Unable to ping:".implode(',', $bad_pings));
		}
    }
    
    $query = new DB_query($DB, "select post_id from $db_weblog order by post_id desc limit 1");
    $query->db_fetch_array();

	return new xmlrpcresp(new xmlrpcval($query->row['post_id'],"string"));
}
// END



//	---------------------------------------------
//		BLOGGER API: getRecentPosts
//	---------------------------------------------

function blogger_getRecentPosts($params)
{
	global $db_weblog,$db_multiweblogs,$db_categories, $L_ERROR, $DB;

	$plist = decode_parameters($params);
		
	$access = user_access($plist['2'],$plist['3']);
 
	if ($access == 0)
	{
		return new xmlrpcresp(0,$xmlrpcerruser + 2, $L_ERROR['230']);
	}
    
	$blog_id_array = array();
    
    $query = new DB_query($DB, "select id,weblog from $db_multiweblogs order by id");  
	while ($query->db_fetch_array())
		   $blog_id_array[$query->row['weblog']] = $query->row['id'];
		   
	unset($query);

    $cat_array = array();
    
    $query = new DB_query($DB, "select id,category from $db_categories order by id");  
     while ($query->db_fetch_array())
            $cat_array[$query->row['id']] = $query->row['category'];
            
    unset($query);
		
	$structarray = array();

	$sql = "select * from $db_weblog ";
	
	if ($plist['1'] != '')
	{
		$sql .= "WHERE weblog = '".$plist['1']."' ";
	}
	
	$sql .= "order by post_id desc";

	$query = new DB_query($DB, $sql);

	while ($query->db_fetch_array()) 
	{			
			$title    = $query->row['title'];
			$body     = $query->row['body'];
			$blurb    = $query->row['blurb'];
			$more     = $query->row['more'];
			$custom1  = $query->row['custom1'];
			$custom2  = $query->row['custom2'];
			$custom3  = $query->row['custom3'];
						
			$category = (!isset($cat_array[$query->row['category']])) ? '' : $cat_array[$query->row['category']];
			
		if ($body != "")
			$body = "\r\n<body>". $body ."</body>";
		if ($blurb != "")
			$blurb = "\r\n<blurb>". $blurb ."</blurb>";
		if ($more != "")
			$more = "\r\n<more>". $more ."</more>";
		if ($custom1 != "")
			$custom1 = "\r\n<custom1>". $custom1 ."</custom1>";
		if ($custom2 != "")
			$custom2 = "\r\n<custom2>". $custom2 ."</custom2>";
		if ($custom3 != "")
			$custom3 = "\r\n<custom3>". $custom3 ."</custom3>";			
		if ($category != "")
			$category = "\r\n<category>". $category ."</category>";

		$content = $title.$body.$blurb.$more.$custom1.$custom2.$custom3.$category;

		$weblogid = $blog_id_array[$query->row['weblog']];
				
		$time = date("Y-m-d\TH:i:s.\3\0T", $query->row['t_stamp']);
	
		$newstruct = new xmlrpcval(array(
			"userid" => new xmlrpcval($query->row['member_id'],"string"),
			"dateCreated" => new xmlrpcval(iso8601_encode($time),"dateTime.iso8601"),
			"blogid" => new xmlrpcval($weblogid,"string"),
			"content" => new xmlrpcval($content,"string"),
			"postid" => new xmlrpcval($query->row['post_id'],"string"),),'struct');
			
		array_push($structarray, $newstruct);		
	}

	return new xmlrpcresp(new xmlrpcval($structarray , "array"));
}
// END



//	---------------------------------------------
//		BLOGGER API: getPost
//	---------------------------------------------

function blogger_getPost($params)
{
	global $db_weblog,$db_multiweblogs,$db_categories, $L_ERROR, $DB;

	$plist	= decode_parameters($params);
		
	$access = user_access($plist['2'],$plist['3']);
 
	if ($access == 0)
	{
		return new xmlrpcresp(0,$xmlrpcerruser + 2, $L_ERROR['230']);
	}
	
    $cat_array = array();
    
    $query = new DB_query($DB, "select id,category from $db_categories order by id");  
    
    while ($query->db_fetch_array())
            $cat_array[$query->row['id']] = $query->row['category'];
		
    unset($query);

    $query = new DB_query($DB, "select * from $db_weblog where post_id = '$plist[1]'");

	$query->db_fetch_array();
				
			$title    = $query->row['title'];
			$body     = $query->row['body'];
			$blurb    = $query->row['blurb'];
			$more     = $query->row['more'];
			$custom1  = $query->row['custom1'];
			$custom2  = $query->row['custom2'];
			$custom3  = $query->row['custom3'];
						
			$category = $cat_array[$query->row['category']];
			
		//	$title = "<title>". $title ."</title>";
			
		if ($body != "")
			$body = "\r\n<body>". $body ."</body>";
		if ($blurb != "")
			$blurb = "\r\n<blurb>". $blurb ."</blurb>";
		if ($more != "")
			$more = "\r\n<more>". $more ."</more>";
		if ($custom1 != "")
			$custom1 = "\r\n<custom1>". $custom1 ."</custom1>";
		if ($custom2 != "")
			$custom2 = "\r\n<custom2>". $custom2 ."</custom2>";
		if ($custom3 != "")
			$custom3 = "\r\n<custom3>". $custom3 ."</custom3>";			
		if ($category != "")
			$category = "\r\n<category>". $category ."</category>";

		$content = $title.$body.$blurb.$more.$custom1.$custom2.$custom3.$category;
		
		$time = date("Y-m-d\TH:i:s.\3\0T", $row['t_stamp']);
	
		$newstruct = new xmlrpcval(array(
			"dateCreated" => new xmlrpcval(iso8601_encode($time),"dateTime.iso8601"),
			"userid" => new xmlrpcval("1","string"),
			"blogid" => new xmlrpcval("5","string"),
			"content" => new xmlrpcval($content,"string")),'struct');

		return new xmlrpcresp($newstruct);
}
// END



//	-----------------------------------------
//		BLOGGER API: editPost
//	-----------------------------------------

function blogger_editPost($params)
{
    global $db_weblog,$db_categories, $L_ERROR, $DB, $SHARED;
    global $db_ping_servers;
 
	$plist	= decode_parameters($params);
		
	$access = user_access($plist['2'],$plist['3']);
	
	if ($access == 0)
	{
		return new xmlrpcresp(0,$xmlrpcerruser + 2, $L_ERROR['230']);
	}
	elseif ($access == 1)
	{
		
		$m1  = get_mbr_id($plist['2'],$plist['3']);

		$m2 = get_mbr_id_from_entry($plist['1']);

		if ($m1 != $m2)
		return new xmlrpcresp(0,$xmlrpcerruser + 2,"You are not authorized to edit this entry.");
	}

	if ($plist['5']==1)
	{
		$status = "open";
	}
	else
	{
		$status = "closed";
	}
		
	$clean	   = addslashes($plist['4']);
	$title	   = stripslashes(get_title($clean));
	$body	   = stripslashes(get_body($clean));
	$blurb	   = stripslashes(get_chunk($clean,"blurb"));
	$more	   = stripslashes(get_chunk($clean,"more"));
	$custom1   = stripslashes(get_chunk($clean,"custom1"));
	$custom2   = stripslashes(get_chunk($clean,"custom2"));
	$custom3   = stripslashes(get_chunk($clean,"custom3"));
	$category  = stripslashes(get_chunk($clean,"category"));
	$brBlurb   = stripslashes(get_chunk($clean,"brBlurb"));
	$brBody	   = stripslashes(get_chunk($clean,"brBody"));
	$brMore	   = stripslashes(get_chunk($clean,"brMore"));
	$brCustom1 = stripslashes(get_chunk($clean,"brCustom1"));
	$brCustom2 = stripslashes(get_chunk($clean,"brCustom2"));
	$brCustom3 = stripslashes(get_chunk($clean,"brCustom3"));
	$tstatus   = stripslashes(get_chunk($clean,"status"));
	
	if ($tstatus != "")
	{
		if ($tstatus == "open" | "closed")
			$status = $tstatus;
	}	
	
		if ($brBlurb =="") $brBlurb = 1;
	elseif ($brBlurb != 0 && $brBlurb !=1) $brBlurb =1;
	
		if ($brBody =="") $brBody = 1;
	elseif ($brBody != 0 && $brBody !=1) $brBody =1;
	
		if ($brMore =="") $brMore = 1;
	elseif ($brMore != 0 && $brMore !=1) $brMore =1;
	
		if ($brCustom1 =="") $brCustom1 = 1;
	elseif ($brCustom1 != 0 && $brCustom1 !=1) $brCustom1 =1;
	
		if ($brCustom2 =="") $brCustom2 = 1;
	elseif ($brCustom2 != 0 && $brCustom2 !=1) $brCustom2 =1;
	
		if ($brCustom3 =="") $brCustom3 = 1;
	elseif ($brCustom3 != 0 && $brCustom3 !=1) $brCustom3 =1;
			
	if ($category != "")
	{
	    $cat_array = array();
	    
	    $query = new DB_query($DB, "select id,category 
	    						from $db_categories 
	    						where weblog = '$weblog' 
	    						order by id");  
	    						
	     while ($query->db_fetch_array())
	     {
	            $cat_array[$query->row['category']] = $query->row['id'];
	     }      
		
		$catid = $cat_array[$category];
		
		unset($query);
	}


    if ($SHARED->get_pref("auto_format_HTML_$weblog") == "yes") 
    {
            $title = pmcode_basic_encode($title);
                
        if ($blurb   <> "") $blurb   = pmcode_basic_encode($blurb);
        if ($body    <> "") $body    = pmcode_basic_encode($body);
        if ($more    <> "") $more    = pmcode_basic_encode($more);
        if ($custom1 <> "") $custom1 = pmcode_basic_encode($custom1);
        if ($custom2 <> "") $custom2 = pmcode_basic_encode($custom2);
        if ($custom3 <> "") $custom3 = pmcode_basic_encode($custom3);
    } 
    if ($SHARED->get_pref("auto_format_URLS_$weblog") == "yes") 
    {
            $title = pmcode_url_encode($title);
                
        if ($blurb   <> "") $blurb   = pmcode_url_encode($blurb);
        if ($body    <> "") $body    = pmcode_url_encode($body);
        if ($more    <> "") $more    = pmcode_url_encode($more);
        if ($custom1 <> "") $custom1 = pmcode_url_encode($custom1);
        if ($custom2 <> "") $custom2 = pmcode_url_encode($custom2);
        if ($custom3 <> "") $custom3 = pmcode_url_encode($custom3);
    } 
    if ($SHARED->get_pref("auto_format_IMGS_$weblog") == "yes") 
    {
            $title = pmcode_img_encode($title);
                
        if ($blurb   <> "") $blurb   = pmcode_img_encode($blurb);
        if ($body    <> "") $body    = pmcode_img_encode($body);
        if ($more    <> "") $more    = pmcode_img_encode($more);
        if ($custom1 <> "") $custom1 = pmcode_img_encode($custom1);
        if ($custom2 <> "") $custom2 = pmcode_img_encode($custom2);
        if ($custom3 <> "") $custom3 = pmcode_img_encode($custom3);
    }    
	        
        $title   = addslashes($title);
        $blurb   = addslashes($blurb);

        $body    = addslashes($body);
        $more    = addslashes($more);
        $custom1 = addslashes($custom1);
        $custom2 = addslashes($custom2);
        $custom3 = addslashes($custom3);
        $weblog  = addslashes($weblog);
    
	 	$post_id = $plist['1'];
	 	
	 	if ($post_id == "")
	 		return new xmlrpcresp(0,$xmlrpcerruser + 2,"Invalid ID number");


	$query = new DB_query($DB, "update $db_weblog
							set title      = '$title',
								blurb      = '$blurb',
								body       = '$body',
								more       = '$more',
								custom1    = '$custom1',
								custom2    = '$custom2',
								custom3    = '$custom3',
								status     = '$status',
								category   = '$category',
								nl2brBlurb = '$brBlurb',
								nl2brBody  = '$brBody',
								nl2brMore  = '$brMore',
								nl2brC1    = '$brCustom1',
								nl2brC2    = '$brCustom2',
								nl2brC3    = '$brCustom3'
						  where post_id    = '$post_id'");
                   
	if (!$query->result)
		return new xmlrpcresp(0,$xmlrpcerruser + 2,"A problem was encountered while updating this entry.");
	
    if ($SHARED->get_pref("rss_on_weblog") == "yes")
    {
        if (write_rss() == false)
		return new xmlrpcresp(0,$xmlrpcerruser + 2,"Unable to write data to your RSS file.");
    }

    if (($SHARED->get_pref("ping_$weblog") == "yes") && ($status =="open"))
    {
        $query = new DB_query($DB, "SELECT server_name, server_url, server_port FROM $db_ping_servers WHERE server_default='y')");
			
		$bad_pings = array();
		
		if ($query->db_num_rows() > 0)
		{
			while($query->db_fetch_array())
			{
				if (!ping_weblogs($weblog, $query->row['server_url'], $query->row['server_port']))
				{
					$bad_pings[] = $query->row['server_name'];
				}
			}			
		}
		
		if (sizeof($bad_pings) > 0)
		{
			return new xmlrpcresp(0,$xmlrpcerruser + 2,"Unable to ping:".implode(',',$bad_pings));
		}
    }    

    return new xmlrpcresp(new xmlrpcval(1,"boolean"));
}
// END



//	-----------------------------------------
//		BLOGGER API: deletePost
//	-----------------------------------------

function blogger_deletePost($params)
{
    global $db_weblog, $L_ERROR, $DB;

	$plist	= decode_parameters($params);
		 	
	$post_id = $plist['1'];
	
	if ($post_id == "")
		return new xmlrpcresp(0,$xmlrpcerruser + 2,"Invalid ID number");
		
    $query = new DB_query($DB, "select count(*) as count from $db_weblog where post_id = '$post_id'"); 
    $query->db_fetch_array();
    
    if ($query->row['count'] != 1)
		return new xmlrpcresp(0,$xmlrpcerruser + 2,"The ID number being sent to pMachine is not corrrect.");
	
		
	$access = user_access($plist['2'],$plist['3']);

	if ($access == 0)
	{
		return new xmlrpcresp(0,$xmlrpcerruser + 2, $L_ERROR['230']);
	}
	elseif ($access == 1)
	{		
		$m1  = get_mbr_id($plist['2'],$plist['3']);

		$m2 = get_mbr_id_from_entry($plist['1']);

		if ($m1 != $m2)
			return new xmlrpcresp(0,$xmlrpcerruser + 2,"You are not authorized to delete this entry.");
	}

    $query = new DB_query($DB, "delete from $db_weblog where post_id = '$post_id'"); 
      
	if (!$query->result)
        return new xmlrpcresp(0,$xmlrpcerruser + 2,"A problem was encountered while attempting to delete this entry.");
	else
		return new xmlrpcresp(new xmlrpcval(1,"boolean"));

}
// END


//	-----------------------------------------
//		XML-RPC DECODE PARAMETER ARRAY
//	-----------------------------------------

function decode_parameters($params) 
{
  $plist = array();
  
  $size = $params -> getNumParams();

  for ($i = 0; $i < $size; $i++) 
  {
    $item = $params -> getParam($i);
    
    $plist[] = $item -> scalarval();
  }
  return $plist;
}

// END



//	---------------------------------------------
//		USER ACCESS PRIVILEGES
//	---------------------------------------------

function user_access($username,$password)  
{
    global $db_members, $DB;

    $query = new DB_query($DB, "select status 
    						from $db_members 
    						where username = '$username' 
    						and password = '".md5($password)."'"); 
      
    $query->db_fetch_array();
    
    if ($query->row['status'] < 7) 
    {
        return 0;
    }
    else if (($query->row['status'] == 7) || ($query->row['status'] == 8)) 
    { 	 
		return 1;
    }
    else if ($query->row['status'] >= 9) 
    {
        return 2;
    } 
}
// END



//	-----------------------------------------
//		GET USER DEFAULT WEBLOG
//	-----------------------------------------

function get_default_weblog($username,$password)  
{
    global $db_members, $DB;

    $query = new DB_query($DB, "select deft_weblog 
    						from $db_members 
    						where username = '$username' 
    						and password = '".md5($password)."'"); 
      
    $query->db_fetch_array();
    
	return $query->row['deft_weblog'];
}
// END


//	-----------------------------------------
//		GET MEMBER ID NUMBER
//	-----------------------------------------

function get_mbr_id($username,$password)  
{
    global $db_members, $DB;

    $query = new DB_query($DB, "select id from $db_members 
    						where username = '$username' 
    						and password = '".md5($password)."'"); 
      
    $query->db_fetch_array();
    
	return $query->row['id'];
}
// END


//	-----------------------------------------
//		GET MEMBER ID NUMBER FROM ENTRY
//	-----------------------------------------

function get_mbr_id_from_entry($postid)  
{
    global $db_weblog, $DB; 

    $query = new DB_query($DB, "select member_id from $db_weblog where post_id = '$postid'"); 
      
    $query->db_fetch_array();
    
	return $query->row['member_id'];
}

// END





//	-----------------------------------------
//		GET WEBLOG ID NUMBER
//	-----------------------------------------

function get_weblog($id)  
{
    global $db_multiweblogs, $DB;

    $query = new DB_query($DB, "select weblog 
    						from $db_multiweblogs 
    						where id = '$id'"); 
      
    $query->db_fetch_array();
    
	return $query->row['weblog'];
}
// END


//	-----------------------------------------
//		EXTRACT ENTRY TITLE
//	-----------------------------------------

function get_title($str)
{
	$str = addslashes($str);

	if (eregi("<title>(.*)</title>", $str, $tstr)) 
	{		
		$title = preg_replace("/<title>(.*)<\/title>/si","\\1",$tstr['0']);
	} 
	else 
	{
		preg_match("/(.*)/i",$str,$line);
		
		$word = explode(" ",$line[0]);
		
		$total = 5;
		
		if (sizeof($word) > $total)
		{				
			for ($i=0; $i< $total; $i++) 
			{
			    $title .= $word[$i] . " ";
			} 
		}
		else
		{
			$title = $line[0];	
		}              
	}
	
	if (!get_magic_quotes_gpc())
		$title = stripslashes($title);
	
	return $title;
}
// END


//	-----------------------------------------
//		EXTRACT ENTRY BODY
//	-----------------------------------------

function get_body($str)
{
	$search = array("<title>(.*)</title>",
					"<status>(.*)</status>",
					"<category>(.*)</category>",
					"<blurb>(.*)</blurb>",
					"<more>(.*)</more>",
					"<custom1>(.*)</custom1>",
					"<custom2>(.*)</custom2>",
					"<custom3>(.*)</custom3>",
					"<brBlurb>(.*)</brBlurb>",
					"<brBody>(.*)</brBody>",
					"<brMore>(.*)</brMore>",
					"<brCustom1>(.*)</brCustom1>",
					"<brCustom2>(.*)</brCustom2>",
					"<brCustom3>(.*)</brCustom3>");
					
	for ($i =0; $i < sizeof($search); $i++)			
	{
		$str = ereg_replace($search[$i],"", $str);
	}
	
	if (eregi("<body>(.*)</body>", $str, $bstr))
	{
		$str = preg_replace("/<body>(.*)<\/body>/si","\\1",$bstr[0]);
	}
	
	return $str;
}
// END


//	-----------------------------------------
//		EXTRACT DATA CHUNKS
//	-----------------------------------------

function get_chunk($str,$tag)
{
	if (eregi("<$tag>(.*)<\/$tag>", $str, $tstr))
	{
		$str = preg_replace("/<$tag>(.*)<\/$tag>/si","\\1",$tstr[0]);
	}
	else
	{
		$str = "";
	}
		
 	return $str;
}
// END


///
/// Being Paul's New Functions
///

// --------------------------
// RECEIVE PINGBACK
// --------------------------

function pingback_ping($params) {
	global $db_pingback, $db_weblog, $pm_path;
    global $language, $sfx, $xmlrpcerruser, $DB, $SHARED;
	
	$title = "";
	
	// Calling params from xmlrpc.inc
	
	$pagelinkedfrom = $params->getParam(0);

	$pagelinkedfrom = $pagelinkedfrom->scalarval();

	$pagelinkedto = $params->getParam(1);
	$pagelinkedto = $pagelinkedto->scalarval();
	
	
	// Replace certain things, so the urls look like urls again.
	
	$pagelinkedfrom = str_replace('&amp;', '&', $pagelinkedfrom);
	$pagelinkedto = preg_replace('#&([^amp\;])#is', '&amp;$1', $pagelinkedto);

	$sitename = $SHARED->get_pref("sitename");
	// Set up messages
	
	$messages = array();
	
	$messages[0] = "Pingback received for " . $pagelinkedto . " Thanks!\n\r";
	$messages[1] = "The site name seems to be incorrect for this link. Please check how you wrote the post's permalink in your entry.\n\r";
	$messages[2] = $sitename." Pingback Server: We cannot find the post to which you are linking. Please check the post's permalink.\n\r";
	$messages[3] = "Pingbacks are not currently accepted for " .$pagelinkedto . " Sorry.\n\r";
	$messages[4] = "Pingback already received for $pagelinkedto\n\r";
	
	
	// Check if the page linked to is in our site.
	
	$cat = 0;

	$siteurl = $SHARED->get_pref("siteurl");
	$test = parse_url($siteurl);
	$page = $test['host'];
	
	
	if (!eregi($page,$pagelinkedto)) 
		return new xmlrpcresp(0,$xmlrpcerruser + 3, $messages[1]);
	
	// Work on finding the post id or page
	$urltest = parse_url($pagelinkedto); 

	$urltest = parse_url($pagelinkedto); 
	
	if (!isset($urltest['query'])) {
	
		if (!$path = $urltest['path']) {
			return new xmlrpcresp(0,$xmlrpcerruser + 3, $messages[1]);
		}
		else {
			$path = trim($path);
			
			if(eregi('/$',$path))
				$path = substr($path, 0, -1);

			$blah = explode('/', $path);
			$num = count($blah) - 1;
			$zid = $blah[$num];
		}
	
	}
	else {
		$query_str = $urltest['query']; 
		// There is an id set, let's find it.
		
		$id = explode('=', trim($query_str));
		$zid = $id[1];
	}
	
	$x = explode("_", $zid);
	$postid = $x['0'];
						
	// Lose any of those pesky letters in front...
	if ((substr($postid, 0, 1)=="A") || 
        (substr($postid, 0, 1)=="P") ||         
        (substr($postid, 0, 1)=="D") || 
        (substr($postid, 0, 1)=="M"))
    	{
			$postid = substr($postid, 1);		
    	}
    	
    	
	if ($postid <> "")
	{   
		$sql = "select weblog from $db_weblog where post_id = '$postid'"; 
		$query = new DB_query($DB, $sql);
           	
		if ($query->db_num_rows() == 0) 
		{
			return new xmlrpcresp(0,$xmlrpcerruser + 3, $messages[2]);
		}
		else
		{
			$query->db_fetch_object();
			$weblog = $query->obj->weblog;
    				
			// Check if pingback is on for weblog.
			if ($SHARED->get_pref("pingback_$weblog") == "no") 
			{
				return new xmlrpcresp(0,$xmlrpcerruser + 3, $messages[3]);
			}
			
			$cat = 2;
		}
	}    		

	$dog = 0;
	
	// Let's make sure there is no previous pingback for this entry from the remote entry
	
	if ($cat == 2)
	{
		$sql = "select * from $db_pingback where from_url = '$pagelinkedfrom' and post_id = '$postid'"; 
        $query = new DB_query($DB, $sql);
           	
        if ($query->db_num_rows() > 0) 
		{
			return new xmlrpcresp(0,$xmlrpcerruser + 3, $messages[4]);
		}
		else
		{
			$dog = 3;
		}
    }

	
	
	if ($dog == 3) {
			
	// Let's check the remote site
	$fp = @fopen($pagelinkedfrom, 'r');
	$puntero = 4096;
	
	while($linea = fread($fp, $puntero)) {
		
		// Find title of page
		eregi("<title>(.*)</title>", $linea, $matchtitle);	
		
		// Strip out all tags except links
		$linea = strip_tags($linea, '<a>');
		
		// Strip out all links except ours.
		$linea = strip_all_but_one_link($linea, $pagelinkedto);
		$linea = preg_replace('#&([^amp\;])#is', '&amp;$1', $linea);
		
		// Let's make sure our link is in there and grab content around it.
		$pos2 = strpos($linea, $pagelinkedto);
		$pos3 = strpos($linea, str_replace('http://www.', 'http://', $pagelinkedto));
		if (is_integer($pos2) || is_integer($pos3)) {
			//  The page really links to us
			$pos4 = (is_integer($pos2)) ? $pos2 : $pos3;
			$start = $pos4-100;
			$linea = eregi_replace('<([^>]|\n)*>', '', $linea); 
			$linea = str_replace("\t", ' ', $linea);	
			$linea = str_replace("  ", ' ', $linea);
			
			$newcontext = "";			
			$context = substr($linea, $start, 260);
			$context_array = explode(" ",$context);
			$count = sizeof($context_array);
			for ($i=1; $i< $count-1; $i++) 
            {
                $newcontext .= $context_array[$i] . " ";
            }			
			
			$context = "..." . $newcontext . "...";
			
			$context = str_replace("\n", ' ', $context);
			$context = str_replace('&amp;', '&', $context);
			} 
		else {
				// The page does not link to us.
			}
		} 
				
				
	fclose($fp);
	
	
// If context actually has something, let's finish up

	if (!empty($context)) {
		$pagelinkedfrom = preg_replace('#&([^amp\;])#is', '&amp;$1', $pagelinkedfrom);
		$title = (!strlen($matchtitle[1])) ? $pagelinkedfrom : $matchtitle[1];
		
		$context = trim($context);
		$title = trim($title);
		
		if(!get_magic_quotes_runtime()) {
				$context = addslashes($context);
				$title = addslashes($title);
				$pagelinkedfrom = addslashes($pagelinkedfrom);
		}
		
		$now = $SHARED->get_offset_time();
				
		// Let's put our results in the database			
		
		$result = new DB_query($DB, "insert into $db_pingback 
					
					(id,
					post_id, 
					from_title, 
					from_url, 
					t_stamp,
					from_context) 
					
					VALUES 
					
					('',
					'$postid',
					'$title',
					'$pagelinkedfrom',
					'$now',
					'$context')"); 

		if ($result->result) {
			$sql = "select pb_total from $db_weblog where post_id = '$postid'";
    		$query = new DB_query($DB, $sql);
			$query->db_fetch_object();
			$pb_total = $query->obj->pb_total +1;

    		unset($sql);
    		unset($query);
    		
			$sql = "update $db_weblog set pb_total = '$pb_total' where post_id = '$postid'";
	
    		$query = new DB_query($DB, $sql);

    		unset($sql);
    		unset($query);
    	}
					
		
		if ($SHARED->get_pref("notify_of_pingback_$weblog") == "yes") 
		{
			$towho = $SHARED->get_pref("notify_address_$weblog");
		
			if ($towho <> "")
		    {
				include ("{$pm_path}language/{$language}/main{$sfx}");
		
				$sql = "select title from $db_weblog where post_id = '$postid'";
				$query = new DB_query($DB, $sql);
				$query->db_fetch_object();
				$title = $query->obj->title;
			
				unset($sql);
				unset($query);
			
		
				$subject  = $L_WEBLOG['570'];
				$message  = $L_WEBLOG['570']."\r\n\r\n";
				$message .= $title."\n";
				$message .= $pagelinkedto."\n\n";
						
				$email =  $SHARED->get_pref("adminemail");
			
            	mail ($towho,$subject,$message,"From: $email\r\nReply-To: $email\r\n");
			}
		} // if pingback notify for admin
		
	 } // Context variable not empty
  
		
 }	
		
return new xmlrpcresp(new xmlrpcval($messages[0])); 

}

// END

// -------------------
// STRIP ALL BUT ONE LINK
// -------------------

function strip_all_but_one_link($text, $mylink) {
	$match_link = '#(<a.+?href.+?'.'>)(.+?)(</a>)#';
	preg_match_all($match_link, $text, $matches);
	$count = count($matches[0]);
	for ($i=0; $i<$count; $i++) {
		if (!strstr($matches[0][$i], $mylink)) {
			$text = str_replace($matches[0][$i], $matches[2][$i], $text);
		}
	}
	return $text;
}

// END
?>